
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.27
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	IDENTIFIER	257
#define	TYPENAME	258
#define	SELFNAME	259
#define	PFUNCNAME	260
#define	SCSPEC	261
#define	TYPESPEC	262
#define	CV_QUALIFIER	263
#define	CONSTANT	264
#define	STRING	265
#define	ELLIPSIS	266
#define	SIZEOF	267
#define	ENUM	268
#define	IF	269
#define	ELSE	270
#define	WHILE	271
#define	DO	272
#define	FOR	273
#define	SWITCH	274
#define	CASE	275
#define	DEFAULT	276
#define	BREAK	277
#define	CONTINUE	278
#define	RETURN_KEYWORD	279
#define	GOTO	280
#define	ASM_KEYWORD	281
#define	TYPEOF	282
#define	ALIGNOF	283
#define	SIGOF	284
#define	ATTRIBUTE	285
#define	EXTENSION	286
#define	LABEL	287
#define	REALPART	288
#define	IMAGPART	289
#define	VA_ARG	290
#define	AGGR	291
#define	VISSPEC	292
#define	DELETE	293
#define	NEW	294
#define	THIS	295
#define	OPERATOR	296
#define	CXX_TRUE	297
#define	CXX_FALSE	298
#define	NAMESPACE	299
#define	TYPENAME_KEYWORD	300
#define	USING	301
#define	LEFT_RIGHT	302
#define	TEMPLATE	303
#define	TYPEID	304
#define	DYNAMIC_CAST	305
#define	STATIC_CAST	306
#define	REINTERPRET_CAST	307
#define	CONST_CAST	308
#define	SCOPE	309
#define	EMPTY	310
#define	PTYPENAME	311
#define	NSNAME	312
#define	THROW	313
#define	ASSIGN	314
#define	OROR	315
#define	ANDAND	316
#define	MIN_MAX	317
#define	EQCOMPARE	318
#define	ARITHCOMPARE	319
#define	LSHIFT	320
#define	RSHIFT	321
#define	POINTSAT_STAR	322
#define	DOT_STAR	323
#define	UNARY	324
#define	PLUSPLUS	325
#define	MINUSMINUS	326
#define	HYPERUNARY	327
#define	POINTSAT	328
#define	TRY	329
#define	CATCH	330
#define	EXTERN_LANG_STRING	331
#define	ALL	332
#define	PRE_PARSED_CLASS_DECL	333
#define	DEFARG	334
#define	DEFARG_MARKER	335
#define	PRE_PARSED_FUNCTION_DECL	336
#define	TYPENAME_DEFN	337
#define	IDENTIFIER_DEFN	338
#define	PTYPENAME_DEFN	339
#define	END_OF_LINE	340
#define	END_OF_SAVED_INPUT	341

#line 29 "parse.y"

/* Cause the `yydebug' variable to be defined.  */
#define YYDEBUG 1

#include "config.h"

#include "system.h"

#include "tree.h"
#include "input.h"
#include "flags.h"
#include "lex.h"
#include "cp-tree.h"
#include "output.h"
#include "except.h"
#include "toplev.h"
#include "ggc.h"

/* Since parsers are distinct for each language, put the language string
   definition here.  (fnf) */
const char * const language_string = "GNU C++";

extern struct obstack permanent_obstack;

extern int end_of_file;

/* Like YYERROR but do call yyerror.  */
#define YYERROR1 { yyerror ("syntax error"); YYERROR; }

#define OP0(NODE) (TREE_OPERAND (NODE, 0))
#define OP1(NODE) (TREE_OPERAND (NODE, 1))

/* Contains the statement keyword (if/while/do) to include in an
   error message if the user supplies an empty conditional expression.  */
static const char *cond_stmt_keyword;

static tree empty_parms PROTO((void));
static void parse_decl PROTO((tree, tree, tree, int, tree *));

/* Nonzero if we have an `extern "C"' acting as an extern specifier.  */
int have_extern_spec;
int used_extern_spec;

/* Cons up an empty parameter list.  */
static inline tree
empty_parms ()
{
  tree parms;

  if (strict_prototype
      || current_class_type != NULL)
    parms = void_list_node;
  else
    parms = NULL_TREE;
  return parms;
}


#line 90 "parse.y"
typedef union {
  long itype; 
  tree ttype; 
  char *strtype; 
  enum tree_code code; 
  flagged_type_tree ftype; 
  struct pending_inline *pi;
} YYSTYPE;
#line 293 "parse.y"

/* List of types and structure classes of the current declaration.  */
static tree current_declspecs;

/* List of prefix attributes in effect.
   Prefix attributes are parsed by the reserved_declspecs and declmods
   rules.  They create a list that contains *both* declspecs and attrs.  */
/* ??? It is not clear yet that all cases where an attribute can now appear in
   a declspec list have been updated.  */
static tree prefix_attributes;

/* When defining an aggregate, this is the kind of the most recent one
   being defined.  (For example, this might be class_type_node.)  */
static tree current_aggr;

/* When defining an enumeration, this is the type of the enumeration.  */
static tree current_enum_type;

/* Tell yyparse how to print a token's value, if yydebug is set.  */

#define YYPRINT(FILE,YYCHAR,YYLVAL) yyprint(FILE,YYCHAR,YYLVAL)
extern void yyprint			PROTO((FILE *, int, YYSTYPE));
extern tree combine_strings		PROTO((tree));

static void
parse_decl (declarator, specs_attrs, attributes, initialized, decl)
  tree declarator;
  tree specs_attrs;
  tree attributes;
  int initialized;
  tree* decl;
{
  split_specs_attrs (specs_attrs, &current_declspecs, &prefix_attributes);
  if (current_declspecs
      && TREE_CODE (current_declspecs) != TREE_LIST)
    current_declspecs = build_decl_list (NULL_TREE, current_declspecs);
  if (have_extern_spec && !used_extern_spec)
    {
      current_declspecs = decl_tree_cons (NULL_TREE, 
					  get_identifier ("extern"), 
					  current_declspecs);
      used_extern_spec = 1;
    }
  *decl = start_decl (declarator, current_declspecs, initialized,
		      attributes, prefix_attributes);
}

void
cp_parse_init ()
{
  ggc_add_tree_root (&current_declspecs, 1);
  ggc_add_tree_root (&prefix_attributes, 1);
  ggc_add_tree_root (&current_aggr, 1);
  ggc_add_tree_root (&current_enum_type, 1);
}
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		1661
#define	YYFLAG		-32768
#define	YYNTBASE	112

#define YYTRANSLATE(x) ((unsigned)(x) <= 341 ? yytranslate[x] : 397)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,   110,     2,     2,     2,    83,    71,     2,    93,
   108,    81,    79,    60,    80,    92,    82,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    63,    61,    75,
    65,    76,    66,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    94,     2,   111,    70,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    59,    69,   109,    89,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    62,    64,    67,    68,    72,    73,    74,    77,
    78,    84,    85,    86,    87,    88,    90,    91,    95,    96,
    97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     3,     4,     7,    10,    12,    13,    14,    15,
    17,    19,    20,    23,    26,    28,    30,    36,    41,    47,
    52,    53,    60,    61,    67,    69,    72,    74,    77,    78,
    85,    88,    92,    96,   100,   104,   109,   110,   116,   119,
   123,   125,   127,   130,   133,   135,   138,   139,   145,   149,
   151,   155,   157,   158,   161,   164,   168,   170,   174,   176,
   180,   182,   186,   189,   192,   195,   197,   199,   205,   210,
   213,   216,   220,   224,   227,   230,   234,   238,   241,   244,
   247,   250,   253,   255,   257,   259,   260,   262,   265,   266,
   268,   273,   277,   281,   282,   291,   297,   298,   308,   315,
   316,   325,   331,   332,   342,   349,   352,   355,   357,   360,
   362,   369,   374,   381,   386,   389,   391,   394,   397,   399,
   402,   404,   407,   410,   415,   418,   422,   423,   424,   426,
   430,   433,   437,   439,   444,   447,   452,   455,   460,   463,
   465,   467,   469,   471,   473,   475,   477,   479,   481,   483,
   485,   487,   488,   495,   496,   503,   504,   510,   511,   517,
   518,   526,   527,   535,   536,   543,   544,   551,   552,   553,
   559,   565,   567,   569,   575,   581,   582,   584,   586,   587,
   589,   591,   595,   597,   599,   601,   603,   605,   607,   609,
   611,   613,   615,   617,   621,   623,   627,   628,   630,   632,
   633,   641,   643,   645,   649,   654,   658,   659,   663,   665,
   669,   673,   677,   681,   683,   685,   687,   690,   693,   696,
   699,   702,   705,   708,   713,   716,   721,   724,   728,   732,
   737,   742,   748,   754,   761,   764,   769,   775,   778,   781,
   788,   792,   796,   800,   802,   806,   809,   813,   818,   820,
   823,   829,   831,   835,   839,   843,   847,   851,   855,   859,
   863,   867,   871,   875,   879,   883,   887,   891,   895,   899,
   903,   907,   913,   917,   921,   923,   926,   930,   934,   936,
   938,   940,   942,   944,   945,   951,   957,   963,   969,   975,
   977,   979,   981,   983,   986,   988,   991,   994,   998,  1003,
  1008,  1010,  1012,  1014,  1018,  1020,  1022,  1024,  1026,  1030,
  1034,  1038,  1039,  1044,  1049,  1052,  1057,  1060,  1065,  1068,
  1071,  1073,  1078,  1080,  1088,  1096,  1104,  1112,  1117,  1122,
  1125,  1128,  1131,  1133,  1138,  1141,  1144,  1150,  1154,  1157,
  1160,  1166,  1170,  1176,  1180,  1185,  1192,  1195,  1197,  1200,
  1202,  1205,  1207,  1209,  1211,  1214,  1215,  1218,  1221,  1225,
  1229,  1233,  1236,  1239,  1242,  1244,  1246,  1248,  1251,  1254,
  1257,  1260,  1262,  1264,  1266,  1268,  1271,  1274,  1278,  1282,
  1286,  1291,  1293,  1296,  1299,  1302,  1304,  1306,  1308,  1311,
  1314,  1317,  1319,  1321,  1324,  1327,  1331,  1333,  1336,  1338,
  1340,  1342,  1347,  1352,  1357,  1362,  1364,  1366,  1368,  1370,
  1374,  1376,  1380,  1382,  1386,  1387,  1392,  1393,  1400,  1404,
  1405,  1410,  1412,  1416,  1420,  1421,  1426,  1430,  1431,  1433,
  1435,  1438,  1445,  1447,  1451,  1452,  1454,  1459,  1466,  1471,
  1473,  1475,  1477,  1479,  1481,  1485,  1486,  1489,  1491,  1494,
  1498,  1503,  1505,  1507,  1511,  1516,  1520,  1526,  1528,  1533,
  1537,  1541,  1542,  1546,  1550,  1554,  1555,  1558,  1561,  1562,
  1569,  1570,  1576,  1579,  1582,  1585,  1586,  1587,  1588,  1599,
  1601,  1602,  1604,  1605,  1607,  1609,  1612,  1615,  1618,  1621,
  1624,  1627,  1630,  1633,  1636,  1640,  1645,  1649,  1652,  1656,
  1658,  1659,  1663,  1666,  1669,  1671,  1673,  1674,  1677,  1681,
  1683,  1688,  1690,  1694,  1696,  1698,  1701,  1704,  1708,  1712,
  1713,  1715,  1719,  1722,  1725,  1727,  1730,  1733,  1736,  1739,
  1742,  1745,  1748,  1750,  1753,  1756,  1760,  1763,  1766,  1771,
  1776,  1779,  1781,  1787,  1792,  1794,  1795,  1797,  1801,  1802,
  1804,  1808,  1810,  1812,  1814,  1816,  1821,  1826,  1831,  1836,
  1841,  1845,  1850,  1855,  1860,  1865,  1869,  1872,  1874,  1876,
  1880,  1882,  1886,  1889,  1891,  1898,  1899,  1902,  1904,  1907,
  1911,  1915,  1917,  1921,  1923,  1926,  1930,  1934,  1937,  1940,
  1944,  1946,  1951,  1956,  1960,  1964,  1967,  1969,  1971,  1974,
  1976,  1978,  1981,  1984,  1986,  1989,  1993,  1997,  2000,  2003,
  2007,  2009,  2013,  2017,  2020,  2023,  2027,  2029,  2034,  2038,
  2043,  2047,  2049,  2052,  2055,  2058,  2061,  2064,  2066,  2069,
  2074,  2079,  2082,  2084,  2086,  2088,  2090,  2093,  2098,  2101,
  2104,  2107,  2110,  2112,  2115,  2118,  2121,  2124,  2128,  2130,
  2133,  2137,  2142,  2145,  2148,  2151,  2154,  2157,  2160,  2165,
  2168,  2170,  2173,  2176,  2180,  2182,  2186,  2189,  2193,  2196,
  2199,  2203,  2205,  2209,  2214,  2216,  2219,  2223,  2226,  2229,
  2231,  2235,  2238,  2241,  2243,  2246,  2250,  2252,  2256,  2263,
  2268,  2273,  2277,  2283,  2287,  2291,  2295,  2298,  2300,  2302,
  2305,  2308,  2311,  2312,  2314,  2316,  2319,  2323,  2325,  2328,
  2329,  2333,  2334,  2335,  2341,  2343,  2344,  2347,  2349,  2351,
  2353,  2356,  2357,  2362,  2364,  2365,  2366,  2372,  2373,  2374,
  2382,  2383,  2384,  2385,  2386,  2399,  2400,  2401,  2409,  2410,
  2416,  2417,  2425,  2426,  2431,  2434,  2437,  2440,  2444,  2451,
  2460,  2471,  2484,  2489,  2493,  2496,  2499,  2501,  2503,  2505,
  2507,  2509,  2510,  2511,  2518,  2519,  2520,  2526,  2528,  2531,
  2532,  2533,  2539,  2541,  2543,  2547,  2551,  2554,  2557,  2560,
  2563,  2566,  2568,  2571,  2572,  2574,  2575,  2577,  2579,  2580,
  2582,  2584,  2588,  2593,  2595,  2599,  2600,  2602,  2604,  2606,
  2609,  2612,  2615,  2617,  2620,  2623,  2624,  2628,  2630,  2632,
  2634,  2637,  2640,  2643,  2648,  2651,  2654,  2657,  2660,  2663,
  2666,  2668,  2671,  2673,  2676,  2678,  2680,  2681,  2682,  2684,
  2685,  2690,  2693,  2695,  2697,  2701,  2702,  2706,  2710,  2714,
  2716,  2719,  2722,  2725,  2728,  2731,  2734,  2737,  2740,  2743,
  2746,  2749,  2752,  2755,  2758,  2761,  2764,  2767,  2770,  2773,
  2776,  2779,  2782,  2785,  2789,  2792,  2795,  2798,  2801,  2805,
  2808,  2811,  2816,  2821,  2825
};

static const short yyrhs[] = {    -1,
   113,     0,     0,   114,   120,     0,   113,   120,     0,   113,
     0,     0,     0,     0,    32,     0,    27,     0,     0,   121,
   122,     0,   148,   147,     0,   144,     0,   141,     0,   119,
    93,   217,   108,    61,     0,   133,    59,   115,   109,     0,
   133,   116,   148,   117,   147,     0,   133,   116,   144,   117,
     0,     0,    45,   163,    59,   123,   115,   109,     0,     0,
    45,    59,   124,   115,   109,     0,   125,     0,   127,    61,
     0,   129,     0,   118,   122,     0,     0,    45,   163,    65,
   126,   132,    61,     0,    47,   310,     0,    47,   324,   310,
     0,    47,   324,   207,     0,    47,   131,   163,     0,    47,
   324,   163,     0,    47,   324,   131,   163,     0,     0,    47,
    45,   130,   132,    61,     0,    58,    55,     0,   131,    58,
    55,     0,   207,     0,   310,     0,   324,   310,     0,   324,
   207,     0,    97,     0,   133,    97,     0,     0,    49,    75,
   135,   136,    76,     0,    49,    75,    76,     0,   140,     0,
   136,    60,   140,     0,   163,     0,     0,   267,   137,     0,
    46,   137,     0,   134,   267,   137,     0,   138,     0,   138,
    65,   223,     0,   388,     0,   388,    65,   202,     0,   139,
     0,   139,    65,   184,     0,   134,   142,     0,   134,     1,
     0,   148,   147,     0,   143,     0,   141,     0,   133,   116,
   148,   117,   147,     0,   133,   116,   143,   117,     0,   118,
   142,     0,   234,    61,     0,   227,   233,    61,     0,   224,
   232,    61,     0,   259,    61,     0,   234,    61,     0,   227,
   233,    61,     0,   224,   232,    61,     0,   227,    61,     0,
   166,    61,     0,   224,    61,     0,     1,    61,     0,     1,
   109,     0,    61,     0,   218,     0,   159,     0,     0,   158,
     0,   158,    61,     0,     0,   107,     0,   154,   146,   145,
   335,     0,   154,   146,   359,     0,   154,   146,     1,     0,
     0,   315,     5,    93,   150,   379,   108,   297,   391,     0,
   315,     5,    48,   297,   391,     0,     0,   324,   315,     5,
    93,   151,   379,   108,   297,   391,     0,   324,   315,     5,
    48,   297,   391,     0,     0,   315,   179,    93,   152,   379,
   108,   297,   391,     0,   315,   179,    48,   297,   391,     0,
     0,   324,   315,   179,    93,   153,   379,   108,   297,   391,
     0,   324,   315,   179,    48,   297,   391,     0,   224,   221,
     0,   227,   307,     0,   307,     0,   227,   149,     0,   149,
     0,     5,    93,   379,   108,   297,   391,     0,     5,    48,
   297,   391,     0,   179,    93,   379,   108,   297,   391,     0,
   179,    48,   297,   391,     0,   227,   155,     0,   155,     0,
   224,   221,     0,   227,   307,     0,   307,     0,   227,   149,
     0,   149,     0,    25,     3,     0,   157,   251,     0,   157,
    93,   196,   108,     0,   157,    48,     0,    63,   160,   161,
     0,     0,     0,   162,     0,   161,    60,   162,     0,   161,
     1,     0,    93,   196,   108,     0,    48,     0,   164,    93,
   196,   108,     0,   164,    48,     0,   303,    93,   196,   108,
     0,   303,    48,     0,   317,    93,   196,   108,     0,   317,
    48,     0,     1,     0,     3,     0,     4,     0,     5,     0,
    57,     0,    58,     0,     3,     0,    57,     0,    58,     0,
   104,     0,   103,     0,   105,     0,     0,    49,   175,   230,
    61,   167,   176,     0,     0,    49,   175,   224,   221,   168,
   176,     0,     0,    49,   175,   307,   169,   176,     0,     0,
    49,   175,   149,   170,   176,     0,     0,     7,    49,   175,
   230,    61,   171,   176,     0,     0,     7,    49,   175,   224,
   221,   172,   176,     0,     0,     7,    49,   175,   307,   173,
   176,     0,     0,     7,    49,   175,   149,   174,   176,     0,
     0,     0,    57,    75,   182,   181,   180,     0,     4,    75,
   182,   181,   180,     0,   179,     0,   177,     0,   163,    75,
   182,    76,   180,     0,     5,    75,   182,   181,   180,     0,
     0,    76,     0,    78,     0,     0,   183,     0,   184,     0,
   183,    60,   184,     0,   223,     0,    57,     0,   202,     0,
    80,     0,    79,     0,    87,     0,    88,     0,   110,     0,
   195,     0,   202,     0,    48,     0,    93,   186,   108,     0,
    48,     0,    93,   190,   108,     0,     0,   190,     0,     1,
     0,     0,   369,   221,   235,   244,    65,   191,   252,     0,
   186,     0,   109,     0,   332,   330,   109,     0,   332,   330,
     1,   109,     0,   332,     1,   109,     0,     0,    59,   194,
   192,     0,   344,     0,   202,    60,   202,     0,   202,    60,
     1,     0,   195,    60,   202,     0,   195,    60,     1,     0,
   202,     0,   195,     0,   212,     0,   118,   201,     0,    81,
   201,     0,    71,   201,     0,    89,   201,     0,   185,   201,
     0,    68,   163,     0,    13,   197,     0,    13,    93,   223,
   108,     0,    29,   197,     0,    29,    93,   223,   108,     0,
   214,   296,     0,   214,   296,   199,     0,   214,   198,   296,
     0,   214,   198,   296,   199,     0,   214,    93,   223,   108,
     0,   214,    93,   223,   108,   199,     0,   214,   198,    93,
   223,   108,     0,   214,   198,    93,   223,   108,   199,     0,
   215,   201,     0,   215,    94,   111,   201,     0,   215,    94,
   186,   111,   201,     0,    34,   201,     0,    35,   201,     0,
    36,    93,   202,    60,   223,   108,     0,    93,   196,   108,
     0,    59,   196,   109,     0,    93,   196,   108,     0,    48,
     0,    93,   230,   108,     0,    65,   252,     0,    93,   223,
   108,     0,   200,    93,   223,   108,     0,   197,     0,   200,
   197,     0,   200,    59,   253,   265,   109,     0,   201,     0,
   202,    84,   202,     0,   202,    85,   202,     0,   202,    79,
   202,     0,   202,    80,   202,     0,   202,    81,   202,     0,
   202,    82,   202,     0,   202,    83,   202,     0,   202,    77,
   202,     0,   202,    78,   202,     0,   202,    74,   202,     0,
   202,    75,   202,     0,   202,    76,   202,     0,   202,    73,
   202,     0,   202,    72,   202,     0,   202,    71,   202,     0,
   202,    69,   202,     0,   202,    70,   202,     0,   202,    68,
   202,     0,   202,    67,   202,     0,   202,    66,   374,    63,
   202,     0,   202,    65,   202,     0,   202,    64,   202,     0,
    62,     0,    62,   202,     0,    89,   389,   163,     0,    89,
   389,   177,     0,   205,     0,   396,     0,     3,     0,    57,
     0,    58,     0,     0,     6,    75,   204,   182,   181,     0,
   396,    75,   204,   182,   181,     0,    49,   163,    75,   182,
   181,     0,    49,     6,    75,   182,   181,     0,    49,   396,
    75,   182,   181,     0,   203,     0,     4,     0,     5,     0,
   209,     0,   245,   209,     0,   203,     0,    81,   208,     0,
    71,   208,     0,    93,   208,   108,     0,     3,    75,   182,
   181,     0,    58,    75,   183,   181,     0,   309,     0,   203,
     0,   210,     0,    93,   208,   108,     0,   203,     0,    10,
     0,   216,     0,   217,     0,    93,   186,   108,     0,    93,
   208,   108,     0,    93,     1,   108,     0,     0,    93,   213,
   336,   108,     0,   203,    93,   196,   108,     0,   203,    48,
     0,   212,    93,   196,   108,     0,   212,    48,     0,   212,
    94,   186,   111,     0,   212,    87,     0,   212,    88,     0,
    41,     0,     9,    93,   196,   108,     0,   313,     0,    51,
    75,   223,    76,    93,   186,   108,     0,    52,    75,   223,
    76,    93,   186,   108,     0,    53,    75,   223,    76,    93,
   186,   108,     0,    54,    75,   223,    76,    93,   186,   108,
     0,    50,    93,   186,   108,     0,    50,    93,   223,   108,
     0,   324,     3,     0,   324,   205,     0,   324,   396,     0,
   312,     0,   312,    93,   196,   108,     0,   312,    48,     0,
   219,   206,     0,   219,   206,    93,   196,   108,     0,   219,
   206,    48,     0,   219,   207,     0,   219,   312,     0,   219,
   207,    93,   196,   108,     0,   219,   207,    48,     0,   219,
   312,    93,   196,   108,     0,   219,   312,    48,     0,   219,
    89,     8,    48,     0,   219,     8,    55,    89,     8,    48,
     0,   219,     1,     0,    40,     0,   324,    40,     0,    39,
     0,   324,   215,     0,    43,     0,    44,     0,    11,     0,
   217,    11,     0,     0,   212,    92,     0,   212,    91,     0,
   230,   232,    61,     0,   224,   232,    61,     0,   227,   233,
    61,     0,   224,    61,     0,   227,    61,     0,   118,   220,
     0,   301,     0,   307,     0,    48,     0,   222,    48,     0,
   228,   328,     0,   298,   328,     0,   230,   328,     0,   228,
     0,   298,     0,   228,     0,   225,     0,   227,   230,     0,
   230,   226,     0,   230,   229,   226,     0,   227,   230,   226,
     0,   227,   230,   229,     0,   227,   230,   229,   226,     0,
     7,     0,   226,   231,     0,   226,     7,     0,   226,   245,
     0,   245,     0,   298,     0,     7,     0,   227,     9,     0,
   227,     7,     0,   227,   245,     0,   245,     0,   230,     0,
   298,   230,     0,   230,   229,     0,   298,   230,   229,     0,
   231,     0,   229,   231,     0,   259,     0,     8,     0,   304,
     0,    28,    93,   186,   108,     0,    28,    93,   223,   108,
     0,    30,    93,   186,   108,     0,    30,    93,   223,   108,
     0,     8,     0,     9,     0,   259,     0,   240,     0,   232,
    60,   236,     0,   241,     0,   233,    60,   236,     0,   242,
     0,   234,    60,   236,     0,     0,   119,    93,   217,   108,
     0,     0,   221,   235,   244,    65,   237,   252,     0,   221,
   235,   244,     0,     0,   244,    65,   239,   252,     0,   244,
     0,   221,   235,   238,     0,   307,   235,   238,     0,     0,
   307,   235,   243,   238,     0,   149,   235,   244,     0,     0,
   245,     0,   246,     0,   245,   246,     0,    31,    93,    93,
   247,   108,   108,     0,   248,     0,   247,    60,   248,     0,
     0,   249,     0,   249,    93,     3,   108,     0,   249,    93,
     3,    60,   196,   108,     0,   249,    93,   196,   108,     0,
   163,     0,     7,     0,     8,     0,     9,     0,   163,     0,
   250,    60,   163,     0,     0,    65,   252,     0,   202,     0,
    59,   109,     0,    59,   253,   109,     0,    59,   253,    60,
   109,     0,     1,     0,   252,     0,   253,    60,   252,     0,
    94,   202,   111,   252,     0,   163,    63,   252,     0,   253,
    60,   163,    63,   252,     0,   102,     0,   254,   146,   145,
   335,     0,   254,   146,   359,     0,   254,   146,     1,     0,
     0,   256,   255,   147,     0,   101,   202,   107,     0,   101,
     1,   107,     0,     0,   258,   257,     0,   258,     1,     0,
     0,    14,   163,    59,   260,   293,   109,     0,     0,    14,
    59,   261,   293,   109,     0,    14,   163,     0,    14,   322,
     0,    46,   317,     0,     0,     0,     0,   274,    59,   262,
   280,   109,   244,   263,   258,   264,   256,     0,   274,     0,
     0,    60,     0,     0,    60,     0,    37,     0,   267,     7,
     0,   267,     8,     0,   267,     9,     0,   267,    37,     0,
   267,   245,     0,   267,   163,     0,   267,   165,     0,   268,
    59,     0,   268,    63,     0,   267,   315,   163,     0,   267,
   324,   315,   163,     0,   267,   324,   163,     0,   267,   178,
     0,   267,   315,   178,     0,   268,     0,     0,   269,   272,
   275,     0,   270,   275,     0,   267,    59,     0,   273,     0,
   271,     0,     0,    63,   389,     0,    63,   389,   276,     0,
   277,     0,   276,    60,   389,   277,     0,   278,     0,   279,
   389,   278,     0,   317,     0,   303,     0,    38,   389,     0,
     7,   389,     0,   279,    38,   389,     0,   279,     7,   389,
     0,     0,   282,     0,   280,   281,   282,     0,   280,   281,
     0,    38,    63,     0,   283,     0,   282,   283,     0,   284,
    61,     0,   284,   109,     0,   156,    63,     0,   156,    95,
     0,   156,    25,     0,   156,    59,     0,    61,     0,   118,
   283,     0,   134,   283,     0,   134,   224,    61,     0,   224,
   285,     0,   227,   286,     0,   307,   235,   244,   251,     0,
   149,   235,   244,   251,     0,    63,   202,     0,     1,     0,
   227,   155,   235,   244,   251,     0,   155,   235,   244,   251,
     0,   127,     0,     0,   287,     0,   285,    60,   288,     0,
     0,   290,     0,   286,    60,   292,     0,   289,     0,   290,
     0,   291,     0,   292,     0,   301,   235,   244,   251,     0,
     4,    63,   202,   244,     0,   307,   235,   244,   251,     0,
   149,   235,   244,   251,     0,     3,    63,   202,   244,     0,
    63,   202,   244,     0,   301,   235,   244,   251,     0,     4,
    63,   202,   244,     0,   307,   235,   244,   251,     0,     3,
    63,   202,   244,     0,    63,   202,   244,     0,   294,   266,
     0,   266,     0,   295,     0,   294,    60,   295,     0,   163,
     0,   163,    65,   202,     0,   369,   325,     0,   369,     0,
    93,   223,   108,    94,   186,   111,     0,     0,   297,     9,
     0,     9,     0,   298,     9,     0,    93,   196,   108,     0,
    93,   379,   108,     0,    48,     0,    93,     1,   108,     0,
   301,     0,   245,   301,     0,    81,   298,   300,     0,    71,
   298,   300,     0,    81,   300,     0,    71,   300,     0,   323,
   297,   300,     0,   302,     0,   302,   299,   297,   391,     0,
   302,    94,   186,   111,     0,   302,    94,   111,     0,    93,
   300,   108,     0,   315,   314,     0,   314,     0,   314,     0,
   324,   314,     0,   303,     0,   305,     0,   324,   305,     0,
   315,   314,     0,   307,     0,   245,   307,     0,    81,   298,
   306,     0,    71,   298,   306,     0,    81,   306,     0,    71,
   306,     0,   323,   297,   306,     0,   211,     0,    81,   298,
   306,     0,    71,   298,   306,     0,    81,   308,     0,    71,
   308,     0,   323,   297,   306,     0,   309,     0,   211,   299,
   297,   391,     0,    93,   308,   108,     0,   211,    94,   186,
   111,     0,   211,    94,   111,     0,   311,     0,   315,   210,
     0,   315,   207,     0,   315,   206,     0,   315,   203,     0,
   315,   206,     0,   311,     0,   324,   311,     0,   230,    93,
   196,   108,     0,   230,    93,   208,   108,     0,   230,   222,
     0,     4,     0,     5,     0,   177,     0,   316,     0,   315,
   316,     0,   315,    49,   321,    55,     0,     4,    55,     0,
     5,    55,     0,    58,    55,     0,   177,    55,     0,   318,
     0,   324,   318,     0,   319,   163,     0,   319,   177,     0,
   319,   321,     0,   319,    49,   321,     0,   320,     0,   319,
   320,     0,   319,   321,    55,     0,   319,    49,   321,    55,
     0,     4,    55,     0,     5,    55,     0,   177,    55,     0,
    57,    55,     0,     3,    55,     0,    58,    55,     0,   163,
    75,   182,   181,     0,   324,   314,     0,   305,     0,   324,
   305,     0,   315,    81,     0,   324,   315,    81,     0,    55,
     0,    81,   297,   325,     0,    81,   297,     0,    71,   297,
   325,     0,    71,   297,     0,   323,   297,     0,   323,   297,
   325,     0,   326,     0,    94,   186,   111,     0,   326,    94,
   186,   111,     0,   328,     0,   245,   328,     0,    81,   298,
   327,     0,    81,   327,     0,    81,   298,     0,    81,     0,
    71,   298,   327,     0,    71,   327,     0,    71,   298,     0,
    71,     0,   323,   297,     0,   323,   297,   327,     0,   329,
     0,    93,   327,   108,     0,   329,    93,   379,   108,   297,
   391,     0,   329,    48,   297,   391,     0,   329,    94,   186,
   111,     0,   329,    94,   111,     0,    93,   380,   108,   297,
   391,     0,   200,   297,   391,     0,   222,   297,   391,     0,
    94,   186,   111,     0,    94,   111,     0,   343,     0,   331,
     0,   330,   343,     0,   330,   331,     0,     1,    61,     0,
     0,   333,     0,   334,     0,   333,   334,     0,    33,   250,
    61,     0,   336,     0,     1,   336,     0,     0,    59,   337,
   192,     0,     0,     0,    15,   339,   188,   340,   341,     0,
   336,     0,     0,   342,   344,     0,   336,     0,   344,     0,
   220,     0,   186,    61,     0,     0,   338,    16,   345,   341,
     0,   338,     0,     0,     0,    17,   346,   188,   347,   193,
     0,     0,     0,    18,   348,   341,    17,   349,   187,    61,
     0,     0,     0,     0,     0,    19,   350,    93,   372,   351,
   189,    61,   352,   374,   108,   353,   193,     0,     0,     0,
    20,   354,    93,   190,   108,   355,   341,     0,     0,    21,
   202,    63,   356,   343,     0,     0,    21,   202,    12,   202,
    63,   357,   343,     0,     0,    22,    63,   358,   343,     0,
    23,    61,     0,    24,    61,     0,    25,    61,     0,    25,
   186,    61,     0,   119,   373,    93,   217,   108,    61,     0,
   119,   373,    93,   217,    63,   375,   108,    61,     0,   119,
   373,    93,   217,    63,   375,    63,   375,   108,    61,     0,
   119,   373,    93,   217,    63,   375,    63,   375,    63,   378,
   108,    61,     0,    26,    81,   186,    61,     0,    26,   163,
    61,     0,   371,   343,     0,   371,   109,     0,    61,     0,
   362,     0,   129,     0,   128,     0,   125,     0,     0,     0,
    95,   360,   145,   336,   361,   365,     0,     0,     0,    95,
   363,   336,   364,   365,     0,   366,     0,   365,   366,     0,
     0,     0,    96,   367,   370,   368,   336,     0,   228,     0,
   298,     0,    93,    12,   108,     0,    93,   388,   108,     0,
     3,    63,     0,    57,    63,     0,     4,    63,     0,     5,
    63,     0,   374,    61,     0,   220,     0,    59,   192,     0,
     0,     9,     0,     0,   186,     0,     1,     0,     0,   376,
     0,   377,     0,   376,    60,   377,     0,    11,    93,   186,
   108,     0,    11,     0,   378,    60,    11,     0,     0,   380,
     0,   223,     0,   384,     0,   385,    12,     0,   384,    12,
     0,   223,    12,     0,    12,     0,   384,    63,     0,   223,
    63,     0,     0,    65,   382,   383,     0,   100,     0,   252,
     0,   386,     0,   388,   381,     0,   385,   387,     0,   385,
   390,     0,   385,   390,    65,   252,     0,   384,    60,     0,
   223,    60,     0,   225,   221,     0,   228,   221,     0,   230,
   221,     0,   225,   328,     0,   225,     0,   227,   307,     0,
   388,     0,   388,   381,     0,   386,     0,   223,     0,     0,
     0,   307,     0,     0,    62,    93,   393,   108,     0,    62,
    48,     0,   223,     0,   392,     0,   393,    60,   392,     0,
     0,    81,   297,   394,     0,    71,   297,   394,     0,   323,
   297,   394,     0,    42,     0,   395,    81,     0,   395,    82,
     0,   395,    83,     0,   395,    79,     0,   395,    80,     0,
   395,    71,     0,   395,    69,     0,   395,    70,     0,   395,
    89,     0,   395,    60,     0,   395,    74,     0,   395,    75,
     0,   395,    76,     0,   395,    73,     0,   395,    64,     0,
   395,    65,     0,   395,    77,     0,   395,    78,     0,   395,
    87,     0,   395,    88,     0,   395,    68,     0,   395,    67,
     0,   395,   110,     0,   395,    66,    63,     0,   395,    72,
     0,   395,    91,     0,   395,    84,     0,   395,    48,     0,
   395,    94,   111,     0,   395,    40,     0,   395,    39,     0,
   395,    40,    94,   111,     0,   395,    39,    94,   111,     0,
   395,   369,   394,     0,   395,     1,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   351,   353,   361,   364,   365,   369,   371,   374,   379,   383,
   389,   393,   396,   400,   403,   405,   407,   410,   412,   415,
   418,   420,   422,   424,   426,   427,   429,   430,   434,   437,
   446,   449,   451,   455,   458,   460,   464,   467,   479,   486,
   494,   496,   497,   499,   503,   506,   512,   515,   517,   522,
   525,   529,   532,   535,   538,   542,   547,   557,   559,   561,
   563,   565,   578,   581,   585,   588,   590,   592,   595,   598,
   602,   604,   606,   608,   613,   615,   617,   619,   621,   622,
   629,   630,   631,   634,   637,   641,   643,   644,   647,   649,
   652,   655,   657,   661,   664,   666,   670,   672,   674,   678,
   680,   682,   686,   688,   690,   696,   700,   703,   706,   709,
   714,   717,   719,   721,   727,   739,   742,   747,   752,   755,
   760,   765,   774,   777,   779,   783,   792,   808,   811,   813,
   814,   817,   824,   830,   832,   834,   836,   838,   841,   844,
   847,   849,   850,   851,   852,   855,   857,   858,   861,   863,
   864,   867,   872,   872,   876,   876,   879,   879,   882,   882,
   886,   886,   891,   891,   894,   894,   897,   899,   902,   909,
   913,   916,   919,   921,   925,   931,   940,   942,   950,   953,
   956,   959,   963,   966,   968,   971,   974,   976,   978,   980,
   984,   987,   990,   995,   999,  1004,  1008,  1011,  1012,  1016,
  1034,  1040,  1043,  1045,  1046,  1047,  1050,  1054,  1055,  1059,
  1063,  1066,  1068,  1072,  1075,  1078,  1082,  1085,  1087,  1089,
  1091,  1094,  1098,  1100,  1103,  1105,  1111,  1114,  1117,  1120,
  1123,  1128,  1131,  1134,  1138,  1140,  1144,  1148,  1150,  1152,
  1157,  1160,  1165,  1168,  1170,  1178,  1191,  1196,  1202,  1204,
  1206,  1219,  1222,  1224,  1226,  1228,  1230,  1232,  1234,  1236,
  1238,  1240,  1242,  1244,  1246,  1248,  1250,  1252,  1254,  1256,
  1258,  1260,  1262,  1266,  1268,  1270,  1287,  1290,  1292,  1293,
  1294,  1295,  1296,  1299,  1311,  1314,  1318,  1321,  1323,  1328,
  1330,  1331,  1334,  1336,  1344,  1346,  1348,  1350,  1354,  1357,
  1361,  1365,  1366,  1367,  1371,  1379,  1380,  1381,  1391,  1393,
  1396,  1398,  1409,  1414,  1416,  1418,  1420,  1422,  1424,  1426,
  1429,  1431,  1442,  1443,  1447,  1451,  1455,  1459,  1461,  1465,
  1467,  1469,  1477,  1479,  1481,  1483,  1487,  1489,  1491,  1493,
  1498,  1500,  1502,  1504,  1507,  1509,  1511,  1555,  1558,  1562,
  1565,  1569,  1572,  1577,  1579,  1583,  1592,  1595,  1602,  1608,
  1612,  1614,  1619,  1621,  1628,  1630,  1634,  1638,  1644,  1648,
  1651,  1655,  1658,  1668,  1670,  1673,  1677,  1680,  1683,  1686,
  1689,  1695,  1701,  1703,  1708,  1710,  1728,  1731,  1733,  1736,
  1742,  1744,  1754,  1758,  1761,  1764,  1769,  1772,  1780,  1782,
  1784,  1786,  1789,  1792,  1807,  1826,  1829,  1831,  1834,  1836,
  1840,  1842,  1846,  1848,  1852,  1855,  1859,  1865,  1866,  1878,
  1884,  1886,  1892,  1897,  1902,  1908,  1909,  1917,  1920,  1924,
  1927,  1931,  1936,  1939,  1943,  1946,  1948,  1950,  1952,  1959,
  1961,  1962,  1963,  1967,  1970,  1974,  1977,  1983,  1985,  1988,
  1991,  1994,  2000,  2003,  2006,  2008,  2010,  2014,  2021,  2027,
  2032,  2038,  2040,  2045,  2048,  2051,  2053,  2055,  2059,  2063,
  2068,  2071,  2076,  2079,  2082,  2088,  2090,  2102,  2106,  2111,
  2135,  2137,  2140,  2142,  2147,  2149,  2151,  2153,  2155,  2157,
  2161,  2169,  2172,  2174,  2178,  2185,  2191,  2197,  2203,  2213,
  2219,  2223,  2230,  2258,  2268,  2274,  2277,  2280,  2282,  2286,
  2288,  2292,  2295,  2299,  2302,  2305,  2307,  2311,  2322,  2336,
  2337,  2338,  2339,  2342,  2351,  2356,  2362,  2364,  2369,  2371,
  2373,  2375,  2377,  2379,  2382,  2392,  2399,  2424,  2430,  2433,
  2436,  2438,  2449,  2454,  2457,  2462,  2465,  2472,  2482,  2485,
  2492,  2502,  2504,  2507,  2509,  2512,  2519,  2527,  2534,  2540,
  2546,  2554,  2558,  2563,  2567,  2570,  2575,  2577,  2584,  2586,
  2589,  2592,  2597,  2601,  2606,  2616,  2619,  2623,  2627,  2636,
  2639,  2641,  2643,  2649,  2651,  2660,  2663,  2665,  2667,  2669,
  2673,  2676,  2679,  2681,  2683,  2685,  2689,  2692,  2703,  2713,
  2715,  2716,  2720,  2728,  2730,  2738,  2741,  2743,  2745,  2747,
  2751,  2754,  2757,  2759,  2761,  2763,  2767,  2770,  2773,  2775,
  2777,  2779,  2781,  2788,  2792,  2797,  2801,  2806,  2808,  2812,
  2815,  2817,  2820,  2822,  2823,  2826,  2828,  2830,  2837,  2848,
  2854,  2860,  2874,  2876,  2880,  2894,  2896,  2898,  2902,  2908,
  2921,  2924,  2929,  2942,  2948,  2950,  2951,  2952,  2960,  2965,
  2974,  2975,  2979,  2982,  2988,  2994,  2997,  2999,  3001,  3003,
  3007,  3011,  3015,  3018,  3022,  3024,  3033,  3036,  3038,  3040,
  3042,  3044,  3046,  3048,  3050,  3054,  3058,  3062,  3066,  3068,
  3070,  3072,  3074,  3076,  3078,  3080,  3082,  3090,  3092,  3093,
  3094,  3097,  3103,  3105,  3110,  3112,  3115,  3128,  3131,  3134,
  3138,  3141,  3148,  3150,  3153,  3155,  3157,  3160,  3163,  3166,
  3169,  3171,  3174,  3178,  3180,  3186,  3188,  3189,  3191,  3196,
  3198,  3200,  3202,  3204,  3207,  3208,  3210,  3213,  3214,  3217,
  3217,  3220,  3220,  3223,  3223,  3225,  3227,  3229,  3231,  3237,
  3243,  3246,  3249,  3255,  3257,  3258,  3261,  3263,  3264,  3265,
  3267,  3270,  3273,  3276,  3282,  3286,  3288,  3291,  3293,  3296,
  3300,  3302,  3305,  3307,  3310,  3327,  3335,  3338,  3340,  3342,
  3346,  3349,  3350,  3358,  3362,  3366,  3369,  3370,  3376,  3379,
  3382,  3384,  3388,  3393,  3396,  3406,  3411,  3412,  3419,  3422,
  3425,  3427,  3430,  3432,  3442,  3456,  3460,  3463,  3465,  3469,
  3473,  3476,  3479,  3481,  3485,  3487,  3494,  3501,  3504,  3508,
  3512,  3516,  3522,  3526,  3531,  3533,  3536,  3541,  3547,  3558,
  3561,  3563,  3567,  3575,  3578,  3582,  3585,  3587,  3589,  3595,
  3600,  3603,  3605,  3607,  3609,  3611,  3613,  3615,  3617,  3619,
  3621,  3623,  3625,  3627,  3629,  3631,  3633,  3635,  3637,  3639,
  3641,  3643,  3645,  3647,  3649,  3651,  3653,  3655,  3657,  3659,
  3661,  3663,  3665,  3668,  3670
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","IDENTIFIER",
"TYPENAME","SELFNAME","PFUNCNAME","SCSPEC","TYPESPEC","CV_QUALIFIER","CONSTANT",
"STRING","ELLIPSIS","SIZEOF","ENUM","IF","ELSE","WHILE","DO","FOR","SWITCH",
"CASE","DEFAULT","BREAK","CONTINUE","RETURN_KEYWORD","GOTO","ASM_KEYWORD","TYPEOF",
"ALIGNOF","SIGOF","ATTRIBUTE","EXTENSION","LABEL","REALPART","IMAGPART","VA_ARG",
"AGGR","VISSPEC","DELETE","NEW","THIS","OPERATOR","CXX_TRUE","CXX_FALSE","NAMESPACE",
"TYPENAME_KEYWORD","USING","LEFT_RIGHT","TEMPLATE","TYPEID","DYNAMIC_CAST","STATIC_CAST",
"REINTERPRET_CAST","CONST_CAST","SCOPE","EMPTY","PTYPENAME","NSNAME","'{'","','",
"';'","THROW","':'","ASSIGN","'='","'?'","OROR","ANDAND","'|'","'^'","'&'","MIN_MAX",
"EQCOMPARE","ARITHCOMPARE","'<'","'>'","LSHIFT","RSHIFT","'+'","'-'","'*'","'/'",
"'%'","POINTSAT_STAR","DOT_STAR","UNARY","PLUSPLUS","MINUSMINUS","'~'","HYPERUNARY",
"POINTSAT","'.'","'('","'['","TRY","CATCH","EXTERN_LANG_STRING","ALL","PRE_PARSED_CLASS_DECL",
"DEFARG","DEFARG_MARKER","PRE_PARSED_FUNCTION_DECL","TYPENAME_DEFN","IDENTIFIER_DEFN",
"PTYPENAME_DEFN","END_OF_LINE","END_OF_SAVED_INPUT","')'","'}'","'!'","']'",
"program","extdefs","@1","extdefs_opt",".hush_warning",".warning_ok","extension",
"asm_keyword","lang_extdef","@2","extdef","@3","@4","namespace_alias","@5","using_decl",
"namespace_using_decl","using_directive","@6","namespace_qualifier","any_id",
"extern_lang_string","template_header","@7","template_parm_list","maybe_identifier",
"template_type_parm","template_template_parm","template_parm","template_def",
"template_extdef","template_datadef","datadef","ctor_initializer_opt","maybe_return_init",
"eat_saved_input","fndef","constructor_declarator","@8","@9","@10","@11","fn.def1",
"component_constructor_declarator","fn.def2","return_id","return_init","base_init",
".set_base_init","member_init_list","member_init","identifier","notype_identifier",
"identifier_defn","explicit_instantiation","@12","@13","@14","@15","@16","@17",
"@18","@19","begin_explicit_instantiation","end_explicit_instantiation","template_type",
"apparent_template_type","self_template_type",".finish_template_type","template_close_bracket",
"template_arg_list_opt","template_arg_list","template_arg","unop","expr","paren_expr_or_null",
"paren_cond_or_null","xcond","condition","@20","compstmtend","already_scoped_stmt",
"@21","nontrivial_exprlist","nonnull_exprlist","unary_expr","new_placement",
"new_initializer","regcast_or_absdcl","cast_expr","expr_no_commas","notype_unqualified_id",
"do_id","template_id","object_template_id","unqualified_id","expr_or_declarator_intern",
"expr_or_declarator","notype_template_declarator","direct_notype_declarator",
"primary","@22","new","delete","boolean.literal","string","nodecls","object",
"decl","declarator","fcast_or_absdcl","type_id","typed_declspecs","typed_declspecs1",
"reserved_declspecs","declmods","typed_typespecs","reserved_typespecquals","typespec",
"typespecqual_reserved","initdecls","notype_initdecls","nomods_initdecls","maybeasm",
"initdcl","@23","initdcl0_innards","@24","initdcl0","notype_initdcl0","nomods_initdcl0",
"@25","maybe_attribute","attributes","attribute","attribute_list","attrib","any_word",
"identifiers_or_typenames","maybe_init","init","initlist","fn.defpen","pending_inline",
"pending_inlines","defarg_again","pending_defargs","structsp","@26","@27","@28",
"@29","@30","maybecomma","maybecomma_warn","aggr","named_class_head_sans_basetype",
"named_class_head_sans_basetype_defn","named_complex_class_head_sans_basetype",
"named_class_head","@31","unnamed_class_head","class_head","maybe_base_class_list",
"base_class_list","base_class","base_class.1","base_class_access_list","opt.component_decl_list",
"access_specifier","component_decl_list","component_decl","component_decl_1",
"components","notype_components","component_declarator0","component_declarator",
"after_type_component_declarator0","notype_component_declarator0","after_type_component_declarator",
"notype_component_declarator","enumlist_opt","enumlist","enumerator","new_type_id",
"cv_qualifiers","nonempty_cv_qualifiers","maybe_parmlist","after_type_declarator_intern",
"after_type_declarator","direct_after_type_declarator","nonnested_type","complete_type_name",
"nested_type","notype_declarator_intern","notype_declarator","complex_notype_declarator",
"complex_direct_notype_declarator","qualified_id","notype_qualified_id","overqualified_id",
"functional_cast","type_name","nested_name_specifier","nested_name_specifier_1",
"typename_sub","typename_sub0","typename_sub1","typename_sub2","explicit_template_type",
"complex_type_name","ptr_to_mem","global_scope","new_declarator","direct_new_declarator",
"absdcl_intern","absdcl","direct_abstract_declarator","stmts","errstmt","maybe_label_decls",
"label_decls","label_decl","compstmt_or_error","compstmt","@32","simple_if",
"@33","@34","implicitly_scoped_stmt","@35","stmt","simple_stmt","@36","@37",
"@38","@39","@40","@41","@42","@43","@44","@45","@46","@47","@48","@49","function_try_block",
"@50","@51","try_block","@52","@53","handler_seq","handler","@54","@55","type_specifier_seq",
"handler_args","label_colon","for.init.statement","maybe_cv_qualifier","xexpr",
"asm_operands","nonnull_asm_operands","asm_operand","asm_clobbers","parmlist",
"complex_parmlist","defarg","@56","defarg1","parms","parms_comma","named_parm",
"full_parm","parm","see_typename","bad_parm","exception_specification_opt","ansi_raise_identifier",
"ansi_raise_identifiers","conversion_declarator","operator","operator_name", NULL
};
#endif

static const short yyr1[] = {     0,
   112,   112,   114,   113,   113,   115,   115,   116,   117,   118,
   119,   121,   120,   122,   122,   122,   122,   122,   122,   122,
   123,   122,   124,   122,   122,   122,   122,   122,   126,   125,
   127,   127,   127,   128,   128,   128,   130,   129,   131,   131,
   132,   132,   132,   132,   133,   133,   135,   134,   134,   136,
   136,   137,   137,   138,   138,   139,   140,   140,   140,   140,
   140,   140,   141,   141,   142,   142,   142,   142,   142,   142,
   143,   143,   143,   143,   144,   144,   144,   144,   144,   144,
   144,   144,   144,   145,   145,   146,   146,   146,   147,   147,
   148,   148,   148,   150,   149,   149,   151,   149,   149,   152,
   149,   149,   153,   149,   149,   154,   154,   154,   154,   154,
   155,   155,   155,   155,   156,   156,   156,   156,   156,   156,
   156,   157,   158,   158,   158,   159,   160,   161,   161,   161,
   161,   162,   162,   162,   162,   162,   162,   162,   162,   162,
   163,   163,   163,   163,   163,   164,   164,   164,   165,   165,
   165,   167,   166,   168,   166,   169,   166,   170,   166,   171,
   166,   172,   166,   173,   166,   174,   166,   175,   176,   177,
   177,   177,   178,   178,   179,   180,   181,   181,   182,   182,
   183,   183,   184,   184,   184,   185,   185,   185,   185,   185,
   186,   186,   187,   187,   188,   188,   189,   189,   189,   191,
   190,   190,   192,   192,   192,   192,   194,   193,   193,   195,
   195,   195,   195,   196,   196,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   197,   197,   197,   197,   197,   197,   197,   197,   197,   197,
   198,   198,   199,   199,   199,   199,   200,   200,   201,   201,
   201,   202,   202,   202,   202,   202,   202,   202,   202,   202,
   202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
   202,   202,   202,   202,   202,   202,   203,   203,   203,   203,
   203,   203,   203,   204,   205,   205,   206,   206,   206,   207,
   207,   207,   208,   208,   209,   209,   209,   209,   210,   210,
   211,   211,   211,   211,   212,   212,   212,   212,   212,   212,
   212,   213,   212,   212,   212,   212,   212,   212,   212,   212,
   212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
   212,   212,   212,   212,   212,   212,   212,   212,   212,   212,
   212,   212,   212,   212,   212,   212,   212,   214,   214,   215,
   215,   216,   216,   217,   217,   218,   219,   219,   220,   220,
   220,   220,   220,   220,   221,   221,   222,   222,   223,   223,
   223,   223,   223,   224,   224,   225,   225,   225,   225,   225,
   225,   226,   226,   226,   226,   226,   227,   227,   227,   227,
   227,   227,   228,   228,   228,   228,   229,   229,   230,   230,
   230,   230,   230,   230,   230,   231,   231,   231,   232,   232,
   233,   233,   234,   234,   235,   235,   237,   236,   236,   239,
   238,   238,   240,   241,   243,   242,   242,   244,   244,   245,
   245,   246,   247,   247,   248,   248,   248,   248,   248,   249,
   249,   249,   249,   250,   250,   251,   251,   252,   252,   252,
   252,   252,   253,   253,   253,   253,   253,   254,   255,   255,
   255,   256,   256,   257,   257,   258,   258,   258,   260,   259,
   261,   259,   259,   259,   259,   262,   263,   264,   259,   259,
   265,   265,   266,   266,   267,   267,   267,   267,   267,   267,
   268,   269,   269,   269,   270,   270,   270,   270,   270,   271,
   272,   271,   271,   273,   274,   274,   275,   275,   275,   276,
   276,   277,   277,   278,   278,   279,   279,   279,   279,   280,
   280,   280,   280,   281,   282,   282,   283,   283,   283,   283,
   283,   283,   283,   283,   283,   283,   284,   284,   284,   284,
   284,   284,   284,   284,   284,   285,   285,   285,   286,   286,
   286,   287,   287,   288,   288,   289,   289,   290,   290,   290,
   290,   291,   291,   292,   292,   292,   293,   293,   294,   294,
   295,   295,   296,   296,   296,   297,   297,   298,   298,   299,
   299,   299,   299,   300,   300,   301,   301,   301,   301,   301,
   301,   302,   302,   302,   302,   302,   302,   303,   303,   304,
   304,   304,   305,   306,   306,   307,   307,   307,   307,   307,
   307,   308,   308,   308,   308,   308,   308,   309,   309,   309,
   309,   309,   309,   310,   310,   311,   311,   312,   312,   313,
   313,   313,   314,   314,   314,   315,   315,   315,   316,   316,
   316,   316,   317,   317,   318,   318,   318,   318,   319,   319,
   319,   319,   320,   320,   320,   320,   320,   320,   321,   322,
   322,   322,   323,   323,   324,   325,   325,   325,   325,   325,
   325,   325,   326,   326,   327,   327,   328,   328,   328,   328,
   328,   328,   328,   328,   328,   328,   328,   329,   329,   329,
   329,   329,   329,   329,   329,   329,   329,   330,   330,   330,
   330,   331,   332,   332,   333,   333,   334,   335,   335,   337,
   336,   339,   340,   338,   341,   342,   341,   343,   343,   344,
   344,   345,   344,   344,   346,   347,   344,   348,   349,   344,
   350,   351,   352,   353,   344,   354,   355,   344,   356,   344,
   357,   344,   358,   344,   344,   344,   344,   344,   344,   344,
   344,   344,   344,   344,   344,   344,   344,   344,   344,   344,
   344,   360,   361,   359,   363,   364,   362,   365,   365,   367,
   368,   366,   369,   369,   370,   370,   371,   371,   371,   371,
   372,   372,   372,   373,   373,   374,   374,   374,   375,   375,
   376,   376,   377,   378,   378,   379,   379,   379,   380,   380,
   380,   380,   380,   380,   380,   382,   381,   383,   383,   384,
   384,   384,   384,   384,   385,   385,   386,   386,   386,   386,
   386,   386,   387,   387,   388,   388,   389,   390,   390,   391,
   391,   391,   392,   393,   393,   394,   394,   394,   394,   395,
   396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
   396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
   396,   396,   396,   396,   396,   396,   396,   396,   396,   396,
   396,   396,   396,   396,   396
};

static const short yyr2[] = {     0,
     0,     1,     0,     2,     2,     1,     0,     0,     0,     1,
     1,     0,     2,     2,     1,     1,     5,     4,     5,     4,
     0,     6,     0,     5,     1,     2,     1,     2,     0,     6,
     2,     3,     3,     3,     3,     4,     0,     5,     2,     3,
     1,     1,     2,     2,     1,     2,     0,     5,     3,     1,
     3,     1,     0,     2,     2,     3,     1,     3,     1,     3,
     1,     3,     2,     2,     2,     1,     1,     5,     4,     2,
     2,     3,     3,     2,     2,     3,     3,     2,     2,     2,
     2,     2,     1,     1,     1,     0,     1,     2,     0,     1,
     4,     3,     3,     0,     8,     5,     0,     9,     6,     0,
     8,     5,     0,     9,     6,     2,     2,     1,     2,     1,
     6,     4,     6,     4,     2,     1,     2,     2,     1,     2,
     1,     2,     2,     4,     2,     3,     0,     0,     1,     3,
     2,     3,     1,     4,     2,     4,     2,     4,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     0,     6,     0,     6,     0,     5,     0,     5,     0,
     7,     0,     7,     0,     6,     0,     6,     0,     0,     5,
     5,     1,     1,     5,     5,     0,     1,     1,     0,     1,
     1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     3,     1,     3,     0,     1,     1,     0,
     7,     1,     1,     3,     4,     3,     0,     3,     1,     3,
     3,     3,     3,     1,     1,     1,     2,     2,     2,     2,
     2,     2,     2,     4,     2,     4,     2,     3,     3,     4,
     4,     5,     5,     6,     2,     4,     5,     2,     2,     6,
     3,     3,     3,     1,     3,     2,     3,     4,     1,     2,
     5,     1,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     5,     3,     3,     1,     2,     3,     3,     1,     1,
     1,     1,     1,     0,     5,     5,     5,     5,     5,     1,
     1,     1,     1,     2,     1,     2,     2,     3,     4,     4,
     1,     1,     1,     3,     1,     1,     1,     1,     3,     3,
     3,     0,     4,     4,     2,     4,     2,     4,     2,     2,
     1,     4,     1,     7,     7,     7,     7,     4,     4,     2,
     2,     2,     1,     4,     2,     2,     5,     3,     2,     2,
     5,     3,     5,     3,     4,     6,     2,     1,     2,     1,
     2,     1,     1,     1,     2,     0,     2,     2,     3,     3,
     3,     2,     2,     2,     1,     1,     1,     2,     2,     2,
     2,     1,     1,     1,     1,     2,     2,     3,     3,     3,
     4,     1,     2,     2,     2,     1,     1,     1,     2,     2,
     2,     1,     1,     2,     2,     3,     1,     2,     1,     1,
     1,     4,     4,     4,     4,     1,     1,     1,     1,     3,
     1,     3,     1,     3,     0,     4,     0,     6,     3,     0,
     4,     1,     3,     3,     0,     4,     3,     0,     1,     1,
     2,     6,     1,     3,     0,     1,     4,     6,     4,     1,
     1,     1,     1,     1,     3,     0,     2,     1,     2,     3,
     4,     1,     1,     3,     4,     3,     5,     1,     4,     3,
     3,     0,     3,     3,     3,     0,     2,     2,     0,     6,
     0,     5,     2,     2,     2,     0,     0,     0,    10,     1,
     0,     1,     0,     1,     1,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     3,     4,     3,     2,     3,     1,
     0,     3,     2,     2,     1,     1,     0,     2,     3,     1,
     4,     1,     3,     1,     1,     2,     2,     3,     3,     0,
     1,     3,     2,     2,     1,     2,     2,     2,     2,     2,
     2,     2,     1,     2,     2,     3,     2,     2,     4,     4,
     2,     1,     5,     4,     1,     0,     1,     3,     0,     1,
     3,     1,     1,     1,     1,     4,     4,     4,     4,     4,
     3,     4,     4,     4,     4,     3,     2,     1,     1,     3,
     1,     3,     2,     1,     6,     0,     2,     1,     2,     3,
     3,     1,     3,     1,     2,     3,     3,     2,     2,     3,
     1,     4,     4,     3,     3,     2,     1,     1,     2,     1,
     1,     2,     2,     1,     2,     3,     3,     2,     2,     3,
     1,     3,     3,     2,     2,     3,     1,     4,     3,     4,
     3,     1,     2,     2,     2,     2,     2,     1,     2,     4,
     4,     2,     1,     1,     1,     1,     2,     4,     2,     2,
     2,     2,     1,     2,     2,     2,     2,     3,     1,     2,
     3,     4,     2,     2,     2,     2,     2,     2,     4,     2,
     1,     2,     2,     3,     1,     3,     2,     3,     2,     2,
     3,     1,     3,     4,     1,     2,     3,     2,     2,     1,
     3,     2,     2,     1,     2,     3,     1,     3,     6,     4,
     4,     3,     5,     3,     3,     3,     2,     1,     1,     2,
     2,     2,     0,     1,     1,     2,     3,     1,     2,     0,
     3,     0,     0,     5,     1,     0,     2,     1,     1,     1,
     2,     0,     4,     1,     0,     0,     5,     0,     0,     7,
     0,     0,     0,     0,    12,     0,     0,     7,     0,     5,
     0,     7,     0,     4,     2,     2,     2,     3,     6,     8,
    10,    12,     4,     3,     2,     2,     1,     1,     1,     1,
     1,     0,     0,     6,     0,     0,     5,     1,     2,     0,
     0,     5,     1,     1,     3,     3,     2,     2,     2,     2,
     2,     1,     2,     0,     1,     0,     1,     1,     0,     1,
     1,     3,     4,     1,     3,     0,     1,     1,     1,     2,
     2,     2,     1,     2,     2,     0,     3,     1,     1,     1,
     2,     2,     2,     4,     2,     2,     2,     2,     2,     2,
     1,     2,     1,     2,     1,     1,     0,     0,     1,     0,
     4,     2,     1,     1,     3,     0,     3,     3,     3,     1,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     3,     2,     2,     2,     2,     3,     2,
     2,     4,     4,     3,     2
};

static const short yydefact[] = {     3,
    12,    12,     5,     0,     4,     0,   281,   633,   634,     0,
   388,   400,   578,     0,    11,     0,     0,     0,    10,   485,
   840,     0,     0,     0,   168,   665,   282,   283,    83,     0,
     0,   827,     0,    45,     0,     0,    13,    25,     0,    27,
     8,     0,    16,    15,    89,   110,    86,     0,   635,   172,
   302,   279,   303,   611,     0,   375,     0,   374,   393,     0,
   413,   392,   430,   399,     0,   500,   501,   507,   506,   505,
   480,   387,   600,   401,   601,   108,   301,   622,   598,     0,
   636,   576,     0,     0,   280,    81,    82,   179,   639,   179,
   640,   179,   284,   168,   141,   142,   143,   144,   145,   471,
   473,     0,   661,     0,   474,     0,     0,     0,     0,   142,
   143,   144,   145,    23,     0,     0,     0,     0,     0,     0,
     0,   475,   643,     0,   649,     0,     0,     0,    37,     0,
     0,    31,     0,     0,    47,     0,   179,   641,     0,     0,
     0,   609,   604,     0,     0,     0,   608,     0,     0,     0,
     0,   302,     0,   293,     0,     0,     0,   301,   576,    28,
     0,    26,     3,    46,     0,    64,   388,     0,     0,     8,
    67,    63,    66,    89,     0,     0,     0,   399,    90,    14,
     0,   428,     0,     0,   446,    87,    79,   642,   582,     0,
     0,   576,    80,     0,     0,     0,   106,     0,   409,   365,
   591,   366,   597,     0,   576,   390,   389,    78,   109,   376,
     0,   411,   391,   107,   382,   406,   407,   377,   395,   397,
   386,   408,     0,    75,   431,   486,   487,   488,   489,   504,
   150,   149,   151,   491,   492,   173,   498,   490,     0,     0,
   493,   494,   507,   827,   503,   476,   579,   394,     0,   425,
   634,     0,   663,   172,   626,   627,   623,   603,   637,     0,
   602,   599,     0,   875,   871,   870,   868,   850,   855,   856,
     0,   862,   861,   847,   848,   846,   865,   854,   851,   852,
   853,   857,   858,   844,   845,   841,   842,   843,   867,   859,
   860,   849,   866,     0,   863,   773,   393,   774,   836,   284,
   281,   578,   306,   354,     0,     0,     0,     0,     0,   350,
   348,   321,   352,   353,     0,     0,     0,     0,     0,   282,
   283,   275,     0,     0,   187,   186,     0,   188,   189,     0,
     0,   190,     0,     0,   180,   181,     0,   249,     0,   252,
   185,   305,   216,     0,     0,   307,   308,     0,   183,   372,
   393,   373,   628,   333,   323,     0,     0,     0,     0,   179,
     0,   483,   469,     0,   662,   660,     0,   191,   192,     0,
     0,     0,   435,     3,    21,    29,   657,   653,   654,   656,
   658,   655,   141,   142,   143,     0,   144,   145,   645,   646,
   650,   647,   644,     0,   291,   292,   290,   625,   624,    33,
    32,    49,     0,   158,     0,     0,   393,   156,     0,     0,
   605,   607,     0,   606,   142,   143,   277,   278,   297,     0,
   615,   296,     0,   614,     0,   304,   282,   283,     0,     0,
     0,   295,   294,   619,     0,     0,    12,     0,   168,     9,
     9,    70,     0,    65,     0,     0,    71,    74,     0,   427,
   429,   122,    93,   127,   762,     0,    85,    84,    92,   125,
     0,     0,   123,    88,     0,   803,   215,     0,   214,   798,
   821,     0,   372,   393,   373,     0,   797,   799,   828,   810,
     0,     0,   621,     0,     0,   830,     0,     0,   589,   584,
     0,   588,     0,     0,     0,     0,     0,   576,   428,     0,
    77,     0,   576,   596,     0,   379,   380,     0,    76,   428,
   384,   383,   385,   378,   398,   415,   414,   179,   495,   499,
   497,     0,   502,   508,     0,   396,   428,   576,    94,     0,
     0,     0,     0,   576,   100,   577,   610,   634,   664,   172,
     0,     0,   864,   869,   395,   576,   576,     0,   576,   874,
   179,     0,     0,   223,     0,   225,   238,   239,     0,     0,
     0,     0,     0,     0,   276,   222,   219,   218,   220,     0,
     0,     0,     0,     0,   305,     0,     0,     0,   217,   177,
   178,   299,     0,   221,     0,     0,   250,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   315,
     0,   317,   319,   320,   358,   357,     0,     0,     0,     0,
     0,   227,   574,     0,   235,   355,   347,     0,     0,   827,
   336,   339,   340,     0,     0,   367,   684,   680,     0,     0,
   576,   576,   576,   369,   687,     0,   632,   371,     0,     0,
   370,   335,     0,   330,   349,   331,   351,   629,     0,   332,
   176,   176,     0,   166,     0,   393,   164,   484,   571,   568,
     0,   483,   569,   483,     0,   402,     0,     0,   403,   404,
   405,   441,   442,   443,   440,     0,   433,   436,     0,     3,
     0,   648,   179,   651,     0,    41,    42,     0,    53,     0,
     0,    57,    61,    50,   826,   393,    53,   825,    59,   169,
   154,   152,   169,   176,   300,   613,   612,   304,     0,   616,
     0,    18,    20,    89,     9,     9,    73,    72,     0,     0,
   356,     0,   710,    91,   708,   452,     0,   448,   447,     0,
   583,   580,   802,   816,   805,   684,   680,     0,   817,   576,
   820,   822,     0,   818,     0,   819,   581,   801,   815,   804,
   800,   829,   812,   823,   813,   806,   811,   620,     0,   632,
     0,   618,   585,   587,   586,     0,     0,     0,     0,     0,
     0,   576,   595,     0,   423,   422,   410,   594,     0,   830,
   590,   381,   412,   424,   428,     0,   496,   633,   634,   827,
   827,   635,   509,   510,   512,   827,   515,   514,     0,   542,
   634,     0,   533,     0,     0,   545,     0,   121,   116,     0,
   172,   546,   549,     0,     0,   525,     0,   119,   426,   830,
   796,   179,   179,   638,   179,   830,   796,   576,    97,   576,
   103,   873,   872,   836,   836,   836,     0,     0,     0,     0,
     0,     0,     0,     0,   393,     0,     0,     0,   311,     0,
   309,   310,     0,   247,   182,   281,   633,   634,   282,   283,
     0,     0,   453,   481,     0,   274,   273,   788,   787,     0,
   271,   270,   268,   269,   267,   266,   265,   262,   263,   264,
   260,   261,   255,   256,   257,   258,   259,   253,   254,     0,
     0,     0,     0,     0,     0,     0,   229,   244,     0,     0,
   228,   576,   576,     0,   576,   573,   672,     0,     0,     0,
     0,     0,   338,     0,   342,     0,   344,     0,     0,   683,
   682,   675,   679,   678,   826,   392,     0,     0,   697,     0,
     0,   830,   368,   830,   685,   576,   796,     0,   684,   680,
     0,     0,   576,     0,   392,     0,     0,     0,     0,   171,
   175,   285,   169,   162,   160,   169,     0,   472,   484,   567,
     0,   213,   212,   211,   210,   435,     0,     0,    24,     0,
     0,   652,     0,    38,    44,    43,    55,    52,    53,     0,
    48,     0,     0,    54,   491,     0,   159,   169,   169,   157,
   170,   298,    17,    19,    69,    89,   416,   140,   146,   133,
   147,   148,     0,   126,   129,     0,     0,     0,     0,   709,
   703,   449,     0,   124,     0,   683,   679,   684,   680,     0,
   392,   598,     0,   576,   685,   684,   680,     0,   305,     0,
   628,   824,     0,     0,   832,     0,     0,     0,     0,   420,
   593,   592,   419,   176,   517,   516,   827,   827,   827,     0,
   576,   796,   541,   534,   546,   535,   428,   428,   531,   532,
   529,   530,   576,   796,   281,   633,     0,   415,   117,   537,
   547,   552,   553,   415,   415,     0,     0,   415,   115,   538,
   550,   415,     0,   428,     0,   526,   527,   528,   428,    96,
     0,     0,     0,     0,   102,     0,   830,   796,   830,   796,
   838,   837,   839,   286,   322,   224,   226,     0,   328,   329,
     0,     0,     0,     0,   310,   313,     0,     0,     0,     0,
   248,     0,   314,   316,   318,   242,   241,   231,     0,   230,
   246,     0,     0,   669,   667,     0,   670,     0,   236,     0,
     0,   179,   345,     0,     0,     0,   676,   681,   677,   688,
   576,   696,   694,   695,   686,   830,     0,   692,     0,     0,
   630,   631,   684,   680,     0,     0,   334,   167,   169,   169,
   165,   572,   570,   470,   434,   432,   281,     0,    22,    30,
   659,    56,    51,    58,    62,    60,   155,   153,    68,     0,
   131,     0,   135,     0,   137,     0,   139,     0,   763,     0,
   203,   711,     0,   704,   705,     0,   450,     0,   683,   679,
   684,   680,     0,   576,   603,   685,     0,   631,   814,   808,
   809,   807,   833,   834,     0,     0,     0,     0,     0,     0,
   417,   174,     0,   519,   518,   513,   830,     0,   536,   446,
   446,   830,     0,     0,     0,   428,   428,     0,   428,   428,
     0,   428,     0,   524,   477,     0,   446,   576,   288,   287,
   289,   576,    99,     0,   105,     0,     0,     0,     0,     0,
     0,     0,   456,     0,   454,   251,   272,     0,   232,   233,
   243,   245,   668,   666,   673,   671,     0,   237,     0,     0,
   337,   341,   343,   830,   690,   576,   691,   163,   161,     0,
   437,   439,   132,   130,     0,     0,     0,     0,   444,     0,
     0,   281,   633,   634,   712,   725,   728,   731,   736,     0,
     0,     0,     0,     0,     0,     0,     0,   282,   757,   765,
     0,   784,   761,   760,   759,     0,   720,     0,     0,   393,
     0,   699,   718,   724,   698,   719,   758,     0,   706,   451,
   683,   679,     0,   685,   310,     0,   831,   421,     0,   511,
   112,   576,   540,   544,   114,   576,   428,   428,   561,   446,
   281,   633,     0,   548,   554,   555,   415,   415,   446,   446,
     0,   446,   551,   466,   539,   830,   830,   576,   576,   240,
     0,     0,     0,     0,   455,     0,     0,   234,   674,   346,
   287,   693,   830,     0,   134,   136,   138,   770,   764,   768,
     0,   707,   702,   206,   777,   779,   780,     0,     0,   716,
     0,     0,     0,   743,   745,   746,   747,     0,     0,     0,
     0,     0,     0,     0,   778,     0,   364,   785,     0,   721,
   362,   415,     0,   363,     0,   415,     0,     0,     0,   204,
   701,   700,   722,   756,   755,   684,   680,     0,     0,   835,
   418,   830,   830,   560,   557,   559,     0,     0,   428,   428,
   428,   556,   558,   543,     0,    95,   101,   830,   830,   324,
   325,   326,   327,   457,   575,   689,   438,     0,   769,   445,
   195,     0,   713,   726,   715,     0,     0,     0,     0,     0,
   739,     0,   748,     0,   754,    39,   145,    34,   145,     0,
    35,   766,     0,   360,   361,     0,     0,     0,   359,   205,
   716,   392,   111,   113,   428,   428,   566,   446,   446,   468,
     0,   467,   462,    98,   104,     0,   771,   202,     0,   393,
     0,   716,     0,   729,   717,   703,   782,   732,     0,     0,
     0,     0,   744,   753,    40,    36,     0,     0,   723,   565,
   563,   562,   564,     0,     0,   479,     0,     0,     0,   196,
   415,   714,   207,   727,   209,     0,   783,     0,   781,   737,
   741,   740,   767,   789,     0,   465,   464,   458,    86,    89,
   775,   776,   772,   428,   703,   193,     0,     0,   199,     0,
   198,   716,     0,     0,     0,   790,   791,   749,     0,   463,
     0,   208,     0,   730,   733,   738,   742,     0,   789,     0,
     0,   461,     0,   460,   200,   194,     0,     0,     0,   750,
   792,   459,     0,     0,   793,     0,     0,   201,   734,   794,
     0,   751,     0,     0,     0,   735,   795,   752,     0,     0,
     0
};

static const short yydefgoto[] = {  1659,
   437,     2,   438,   165,   723,   333,   181,     3,     4,    37,
   690,   374,  1343,   691,   816,  1344,  1345,   394,  1443,   695,
    41,   817,   403,   701,   987,   702,   703,   704,    43,   172,
   173,    44,   456,   184,   180,    45,    46,   831,  1108,   837,
  1110,    47,   819,   820,   185,   186,   457,   730,  1014,  1015,
   669,  1016,   235,    48,   999,   998,   713,   710,  1180,  1179,
   966,   963,   136,   997,    49,   237,    50,   960,   582,   334,
   335,   336,   337,  1346,  1608,  1503,  1610,  1549,  1643,  1212,
  1584,  1605,   368,   952,   338,   621,   911,   339,   340,   369,
   342,   360,    52,   256,   696,   419,   154,    53,    54,   343,
   577,   344,   345,   346,   347,   458,   348,  1347,   516,   642,
   349,  1348,    56,   218,   472,   350,   219,   485,   220,   198,
   211,    60,   499,   517,  1369,   785,  1240,   199,   212,    61,
   527,   786,    62,    63,   686,   687,   688,  1320,   463,   873,
   874,  1599,  1600,  1576,  1542,  1485,    64,   674,   362,   525,
  1394,  1543,  1130,   670,    65,    66,    67,    68,    69,   243,
    70,    71,   245,   803,   804,   805,   806,   824,  1095,   825,
   826,   827,  1080,  1090,  1081,  1384,  1082,  1083,  1385,  1386,
   671,   672,   673,   622,   942,   352,   192,   497,   490,   201,
    73,    74,    75,   142,   143,   157,    77,   132,   353,   354,
   355,    79,   356,    81,   808,   123,   124,   125,   532,   105,
    82,   357,   916,   917,   937,   932,   645,  1351,  1352,  1213,
  1214,  1215,   734,  1353,  1021,  1354,  1428,  1552,  1506,  1507,
  1355,  1356,  1531,  1429,  1553,  1430,  1586,  1431,  1588,  1637,
  1653,  1432,  1612,  1562,  1613,  1512,   459,   731,  1318,  1357,
  1446,  1567,  1419,  1420,  1498,  1579,  1551,  1547,  1358,  1558,
  1449,   880,  1615,  1616,  1617,  1651,   476,   938,   767,  1044,
  1232,   478,   479,   480,   763,   481,   148,   765,   772,  1234,
  1235,   550,    84,    85
};

static const short yypact[] = {   115,
   148,-32768,-32768,  4190,-32768,    65,    43,   397,   464,    77,
   149,-32768,-32768,  1260,-32768,    76,   139,   177,-32768,-32768,
-32768,   378,   972,  1788,   250,-32768,   275,   565,-32768,  4300,
  4300,-32768,  4980,-32768,  4190,   298,-32768,-32768,   227,-32768,
   172,  4878,-32768,-32768,   301,   908,   445,   422,   430,-32768,
-32768,-32768,-32768,   316,  4016,-32768,  6889,-32768,   991,   213,
-32768,   480,-32768,-32768,  2188,    96,-32768,   453,-32768,-32768,
   466,  6058,-32768,-32768,-32768,   922,-32768,-32768,-32768,  2259,
-32768,-32768,   163,  9650,   459,-32768,-32768, 11336,-32768, 11336,
-32768, 11336,-32768,-32768,-32768,   397,   464,   275,   495,-32768,
   508,   430,-32768,  1035,-32768,   163, 11427, 11427,   488,-32768,
-32768,-32768,-32768,-32768,   483,   528,   681,   705,   784,   547,
   579,-32768,-32768,  1411,-32768,   519,   397,   464,-32768,   275,
   495,-32768,  1486,   715,   497,  7889, 11336,-32768, 11336,  5725,
  4947,-32768,-32768,  2459,   680,  4947,-32768,  1115,  5212,  5212,
  4980,   536,   540,-32768,   316,   416,   554,   561,-32768,-32768,
   660,-32768,   578,-32768,  5192,-32768,-32768,   250,  3765,   631,
-32768,-32768,-32768,   301,  4833, 12316,   385,   673,-32768,-32768,
   656,   480,   750,   112,   323,   698,-32768,-32768,-32768,  8209,
  9742,-32768,-32768,  5557,  5557,  6556,   922,   545,-32768,-32768,
   544,-32768,-32768,  2649,-32768,-32768,-32768,-32768,-32768,   991,
   634,-32768,   480,   922,-32768,-32768,-32768,  1807,   991,-32768,
   480,-32768,  4833,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   699,-32768,   430,-32768,   480,  1421,  1496,
-32768,-32768,   453,-32768,-32768,-32768,-32768,  1581,   163,-32768,
   775,  1243,-32768,   419,-32768,-32768,-32768,-32768,-32768,  5965,
-32768,-32768,   487,-32768,   708,   749,-32768,-32768,-32768,-32768,
   729,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,   704,-32768,-32768,  1581,  6058,  1094,-32768,
-32768,   790,-32768,-32768, 12065, 12156, 12247, 12247,   793,-32768,
-32768,-32768,-32768,-32768,   802,   776,   830,   835,   844,  1066,
   495, 11518,  1575, 12247,-32768,-32768, 12247,-32768,-32768, 12247,
  8485,-32768, 12247,   291,   817,-32768, 12247,-32768, 11609,-32768,
 12517,   438,  2003,  5466, 11700,-32768,   886,   281,-32768,  1328,
  1726,  5368,-32768,   462,-32768,  3060,  2562,   291,   291, 11336,
  7889,  1254,-32768,  1575,-32768,-32768,   813,   864,  3815,   854,
   857,   866,  2071,   578,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   528,   681,   705,  1575,   784,   547,   863,   579,
-32768,   917,-32768,  3102,   397,   464,-32768,-32768,-32768,-32768,
-32768,-32768,  7944,-32768,  4833, 12384,   702,-32768,   291,   553,
-32768,-32768,   718,-32768,   920,   929,-32768,-32768,-32768,  4947,
-32768,-32768,  4947,-32768,   925,-32768,-32768,-32768,   416,   416,
   416,-32768,-32768,-32768,  5965,    88,   932,   934,-32768,-32768,
-32768,-32768,  7889,-32768,   717,   723,-32768,-32768,   660,-32768,
   480,-32768,-32768,-32768,-32768,   118,-32768,-32768,-32768,-32768,
  9036, 11518,-32768,-32768,   938,-32768,   864,   940,  3815,   238,
  3591, 12316,  3591,  4033,  3916,   946,-32768,   199,  7200,   995,
  1001,   790,-32768,   945,   470,   132,  7263,  6456,-32768,-32768,
  6456,-32768,  6778,  6778,  6556,  7512,   954,-32768,   480,  4833,
-32768,  9833,-32768,-32768,  7045,  1807,   991,  4833,-32768,   480,
-32768,-32768,   480,  1807,-32768,  1049,-32768, 11336,   699,-32768,
-32768,  1421,-32768,  1283,  3084,  1581,   480,-32768,-32768,  1003,
  1006,  1028,  1011,-32768,-32768,-32768,-32768,   786,-32768,   485,
   994,   998,-32768,-32768,  1581,-32768,-32768,   736,-32768,-32768,
 11336, 11518,  8485,-32768,  8485,-32768,-32768,-32768, 11518, 11427,
 12429, 12429, 12429, 12429, 12446,-32768,-32768,-32768,-32768,  1005,
 11792, 11792,  8485,  1020,   254,  1023,  1052,  1027,-32768,-32768,
-32768,-32768, 11336,-32768,  8576,  8485,-32768, 11518, 11518,  9127,
 11518, 11518, 11518, 11518, 11518, 11518, 11518, 11518, 11518, 11518,
 11518, 11518, 11518, 11518, 11518, 11518, 11518, 11518, 11518,-32768,
 11518,-32768,-32768,-32768,-32768,-32768, 11518, 11518, 11518, 11427,
  6696,   434,   449,  9924,-32768,-32768,-32768,  1081,  1243,  1131,
   492,   597,   624,  3587,   680,-32768,   610,   610,  5483, 10015,
  1050,  1098,-32768,-32768,   772, 10604,  1062,-32768,   899,   163,
-32768,-32768, 11518,-32768,-32768,-32768,-32768,-32768,   196,   459,
-32768,-32768,   291,-32768,  4833,   885,-32768,-32768,  1085,-32768,
  1059,  1099,-32768,  1254,   863,-32768,  9400,  9491,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   184,-32768,  1065,  1068,   578,
  3102,  1119, 11336,-32768,  1118,-32768,-32768,   715,  1452,  1144,
   231,  1137,  1140,-32768,-32768,  5080,  2188,-32768,  1141,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1072,  1100,-32768,
  1152,-32768,-32768,   301,-32768,-32768,-32768,-32768,    89,   595,
  1155,  1052,-32768,-32768,-32768,-32768,  8391, 12446,-32768,  1113,
-32768,-32768,-32768,-32768,-32768,  2323,  2323,  6121,-32768,-32768,
-32768,-32768,  2649,-32768, 10696,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,  1001,  1162,-32768,-32768,-32768, 10972,  1098,
   678,-32768,-32768,-32768,-32768,  6456,  6456,  7244,  7244,  7512,
   899,-32768,-32768,  7045,-32768,  1164,-32768,-32768,  1111,   132,
-32768,  1807,-32768,-32768,   480,  1159,-32768,   681,   705,-32768,
-32768,   579,  1171,-32768,-32768,   337,-32768,-32768,  1650,-32768,
   997,  1541,-32768, 11518,  6247,-32768,  6247,   195,   195,   371,
   760,  1944,  7449,    91,  3418,-32768,   187,   195,-32768,   132,
  7802, 11336, 11336,-32768, 11336,   132,  7802,-32768,-32768,-32768,
-32768,-32768,-32768,  1157,  1157,  1157,   291,  1129,  1132,  1134,
 12472,  1142,  1148,  1168,  2601,  1169,  1184,  1191,-32768,  1160,
-32768,-32768,  1167,-32768,-32768,  1206,  1000,  1002,   311,   321,
 11518,  1207,-32768,  1217,  1170, 12446, 12446,-32768,-32768,  1221,
  7101, 12534, 10130, 12549, 12563,  5619,  3476,  2055,  2055,  2055,
  1640,  1640,  1308,  1308,   849,   849,   849,-32768,-32768,  1189,
  1194,  1196,  1199,  1197,  1201, 12429,   434,-32768,  9036, 11518,
-32768,-32768,-32768, 11518,-32768,-32768,  1228, 12247,  1215,  1245,
  1261,  1294,-32768, 11518,-32768, 11518,-32768, 11518,  2540,  2050,
-32768,-32768,  2050,-32768,    93,  2540,  1247,  1252,-32768,  1240,
 12429,   132,-32768,   132,  2986,-32768,  7802, 10106, 10788, 10788,
  4654,  1255, 11609,  1258,  1969,  3561,  2562,   936,  1263,-32768,
-32768,-32768,-32768,-32768,-32768,-32768, 11518,-32768,  1575,-32768,
  1264,-32768, 12446,-32768, 12446,  2071,  1266, 11883,-32768,  1271,
  1311,-32768,   291,-32768,-32768,-32768,-32768,-32768,  1899,  7944,
-32768, 12429, 11336,-32768,  1704, 11518,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   301,-32768,-32768,   528,-32768,
   784,   547, 11518,  1324,-32768,   778,   807,   819,  1052,-32768,
    69,-32768,   133,-32768,  3358,  3250,  3250,  3491,  3491,  6121,
  3784,   144,  2649,-32768,  4207, 10880, 10880,  7678,   182,  1288,
   478,-32768,  9036,  8670,-32768, 12429,  1746,  1746,  2980,-32768,
-32768,-32768,  1333,-32768,-32768,-32768,-32768,-32768,-32768,  1671,
-32768,  7802, 12446,-32768,  1625,-32768,   480,   480,-32768,-32768,
-32768,-32768,-32768,  7802,   781,  1082, 11518,  1049,-32768,  1341,
-32768,-32768,-32768,   160,   362,  2259,   680,   598,   195,  1342,
-32768,   687,  1344,   480,  4391,-32768,-32768,-32768,   480,-32768,
  1296,   291,   291,   291,-32768,  1305,   132,  7802,   132,  7802,
-32768,-32768,-32768,-32768,-32768,-32768,-32768, 12429,-32768,-32768,
  1330,  1334,  1338,  1339,  1072,-32768, 12424,  9036,  8763,  1325,
-32768, 11518,-32768,-32768,-32768,-32768,-32768,   770,  1327,-32768,
-32768,  1335,   330,  1348,  1348,  1322,  1348, 11518,-32768, 12247,
  1430, 11336,-32768,  1340,  1345,  1358,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   132,  1359,-32768,  1336,  1969,
-32768,-32768,  4484,  4484,  6385,  4321,-32768,-32768,-32768,-32768,
-32768, 12446,-32768,-32768,-32768,-32768,   235,  1364,-32768,-32768,
-32768,-32768,-32768,-32768,-32768, 12517,-32768,-32768,-32768,  1365,
-32768,   260,-32768, 11518,-32768, 11518,-32768, 11518,-32768,  1575,
-32768,-32768,  8116,  1408,-32768,  8854,-32768,  3784,  3250,  3250,
  4545,  4545,  6651,-32768,   518,  4207,  1366,   400,-32768,-32768,
-32768,-32768,-32768,-32768,   252,  4504,  4504,  1938,  1938,  9036,
-32768,-32768,  1283,-32768,-32768,-32768,   132,  1367,-32768,  1380,
  1380,   132,  1372, 11518, 11518,  7542,   480,  2218,   480,   480,
   966,   480,  2825,-32768,-32768,  4764,  1380,-32768,-32768,  1397,
-32768,-32768,-32768,  1373,-32768,  1375,  1377, 11518, 11518, 11518,
 11518,  9036,-32768,  1431,-32768,-32768, 12446, 11518,-32768,   770,
-32768,-32768,-32768,-32768,-32768,-32768,  1382,-32768,  1463,   291,
-32768,-32768,-32768,   132,-32768,-32768,-32768,-32768,-32768, 11518,
-32768,-32768,-32768,-32768,  1404,  1410,  1415,  1433,-32768,   918,
   350,  1467,  1136,  1161,-32768,-32768,-32768,-32768,-32768, 11518,
  1468,  1471,  1473, 11063,   200,  1575,   697,   795,-32768,-32768,
 11154,  1527,-32768,-32768,-32768,  1476,-32768,  5252,  7794,  2745,
  5837,-32768,-32768,  1522,-32768,-32768,-32768, 10215,-32768,-32768,
  3194,  3194,   899,  3665,   539, 12429,-32768,-32768,  9036,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,  7542,  7542,-32768,  1380,
   810,  1216, 11518,-32768,-32768,-32768,  1049,  1049,  1380,  1380,
   786,  1380,-32768,-32768,-32768,   132,   132,-32768,-32768,-32768,
  1432,  1440,  1451,  1457,-32768,  9036,  1428,-32768,-32768,-32768,
-32768,-32768,   132,  1462,-32768,-32768,-32768,-32768,  1433,-32768,
  1575,-32768,-32768,-32768,-32768,-32768,-32768,   824,   824,  1052,
  1448,  1480,  7312,-32768,-32768,-32768,-32768,  1520, 11518,  1531,
  1509,  1528,  1689,  1696,-32768,  1052,-32768,-32768,  1510,-32768,
-32768,  1049,   951,-32768,  1040,  1049, 11245,  1056,   394,-32768,
-32768,-32768,-32768,-32768,-32768,  3684,  3684,  7027,  3908,-32768,
-32768,   132,   132,-32768,-32768,-32768, 11518, 11518,  7542,   480,
   480,-32768,-32768,-32768,  8007,-32768,-32768,   132,   132,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1511,-32768,-32768,
-32768, 11427,-32768,-32768,-32768,  1590, 10511,  8300, 11427, 11518,
-32768, 10323,-32768,  1552,-32768,-32768,  1559,-32768,  1528,  1689,
-32768,-32768,   660,-32768,-32768, 11974, 11974,  8945,-32768,-32768,
  1052,  3908,-32768,-32768,  7542,  7542,-32768,  1380,  1380,-32768,
  9582,-32768,-32768,-32768,-32768, 12371,-32768,-32768,  1514,   442,
  4833,  1052, 10417,-32768,-32768,    69,-32768,-32768,  1558,  1518,
 12495, 10323,-32768,-32768,-32768,-32768,  1433,    74,-32768,-32768,
-32768,-32768,-32768,  1534,  7352,  1532,  1536,  1542,  1052,-32768,
  1049,-32768,-32768,-32768,-32768,   839,-32768,  9218,-32768,-32768,
-32768,-32768,  1433,  1624,  1591,-32768,-32768,-32768,   445,   301,
-32768,-32768,-32768,   480,    69,-32768, 11518,  1597,-32768,  1598,
-32768,  1052, 10323,  1568,    54,  1602,-32768,-32768,   120,-32768,
  1586,-32768,  1556,-32768,-32768,-32768,-32768, 11518,  1624,  1608,
  1624,-32768,   118,-32768,-32768,-32768,  9309,  1562,   851,-32768,
-32768,-32768,  9036,  1569,-32768,  1673,  1629,-32768,-32768,-32768,
   409,-32768, 10417,  1674,  1630,-32768,-32768,-32768,  1695,  1698,
-32768
};

static const short yypgoto[] = {-32768,
  1702,-32768,  -331,  1539,  -393,     7,    10,  1711,-32768,  1680,
-32768,-32768,   123,-32768,   345,-32768,   414,-32768,   288,  1042,
    45,    12,-32768,-32768,  -648,-32768,-32768,   751,    56,  1570,
  1299,  1584,  -718,   158,  -170,   -19,   -27,-32768,-32768,-32768,
-32768,-32768,   935,-32768,-32768,-32768,-32768,-32768,-32768,   557,
   721,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  1668,  -605,  6850,  1526,   -36,  -622,  -334,   -23,
  1627,  -551,-32768,   822,-32768,   342,-32768, -1398,-32768, -1277,
   122,-32768,  1386,  1794,  -279,-32768,  -861,  6377,  -272,  1930,
  4964,  1478,  -339,   -82,   -38,  1337,  -106,   -70,   758,-32768,
-32768,-32768,  -335,-32768,  -156,-32768,-32768, -1275,   136,  -343,
  2172,    37,  1667,  -128,   103,   236,  -191,    -4,  -141,  -160,
  -167,    -3,   108,    29,-32768,  -380,-32768,-32768,-32768,-32768,
-32768,   383,  1406,   179,-32768,   809,-32768,-32768, -1038,   -93,
  1054,-32768,-32768,-32768,-32768,-32768,   -30,-32768,-32768,-32768,
-32768,-32768,-32768,  1127,  -369,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  1557,-32768,   559,   745,-32768,-32768,-32768,   711,
  -705,-32768,-32768,-32768,-32768,-32768,-32768,   985,-32768,   548,
  1149,-32768,   841,  1204,  3119,    59,  1617,  1932,   258,-32768,
  -496,-32768,    57,   168,   856,  -148,  1143,   -97,  5540,  1474,
-32768,  6413,  2880,  1513,   -17,  -123,-32768,  1706,   -60,-32768,
  5603,  4117,  -445,-32768,  2579,  -228,-32768,-32768,   477,-32768,
-32768,   620,   207,  -449,-32768,-32768,-32768,-32768, -1395,-32768,
 -1207, -1437,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   223,-32768,-32768,-32768,
-32768,-32768,   280, -1357,-32768,-32768,   -28,-32768,-32768,-32768,
-32768, -1427,   222,-32768,   221,-32768,  -667,  -107,  1090,-32768,
-32768,-32768,-32768,  -386,-32768,  -382,  -211,-32768,   761,   489,
-32768,   174,-32768,  -232
};


#define	YYLAST		12648


static const short yytable[] = {    59,
   421,   424,   393,   444,   436,   122,   735,   647,   446,   257,
    35,   178,  1019,    36,   445,    42,   708,   656,   507,   533,
   709,   657,   174,   661,   662,   554,   556,   807,   222,   209,
    59,   865,   524,   707,   557,   558,   401,    59,   177,   961,
    55,    35,   689,   254,    36,  1140,    42,   724,   169,   433,
   398,   567,   210,    42,   568,   299,   526,   569,   994,   587,
   579,  1499,    72,   392,   584,  1447,   358,   248,   359,  1555,
   103,    55,   625,   257,   714,   715,   512,   515,   175,   297,
  1559,   506,   477,   351,   626,   351,   170,   351,   141,   146,
   514,  1001,   708,    72,   399,   400,   764,   171,   626,   626,
    72,  1210,   351,   351,   743,   545,    57,  1000,   404,  1064,
  1560,  1066,   453,   409,    -1,  1585,  1629,    88,   732,  1096,
  1632,   644,   648,   651,   660,    86,    38,   863,  1093,   794,
   647,   407,   351,   257,   351,  1569,  1594,    57,   178,   261,
   536,   770,   298,  1462,   176,   441,   829,    -2,   209,   174,
  1465,    93,   744,   182,   241,   745,  1582,    38,   242,   545,
    59,  1630,   365,  1101,    59,   177,     8,     9,   107,  1106,
  -356,   210,   405,    87,   454,   169,   733,  1211,  -356,   222,
    42,  1595,   454,   250,  -365,   474,    15,   222,   222,  1611,
   197,  -597,  1216,   771,    72,   721,  1007,    94,   147,  1094,
   864,    55,    95,   110,   111,   175,   455,   420,   423,  1644,
   758,  1373,  1374,   170,   455,  1585,  1626,   222,  -365,   130,
   131,    15,  -365,    72,   171,  -415,   540,    72,  1395,  -302,
   163,   108,  1557,  1017,   310,  1499,  -597,  -597,   406,    58,
   225,  1217,   751,   976,   644,   648,   651,  1097,   475,   743,
    26,  -597,   488,   491,  -365,  -415,   112,   113,   759,  -415,
  1008,   760,  1009,   798,   799,   631,   222,    57,   164,   109,
    58,   176,   223,   224,  -302,  -302,  1289,    58,  1587,  1167,
  1439,   627,  1020,   301,   395,   396,    10,   162,   628,  -295,
   990,   977,   729,   248,  1310,  1098,   697,   744,   567,   568,
   745,   610,  -826,  -415,  1563,   261,   991,  1010,   412,   632,
   197,  1366,   200,   414,    26,   623,  1011,  1012,   225,   296,
   222,   510,    21,   657,   135,   692,   351,  1622,   962,   629,
   989,  1005,  1006,   664,   225,    26,   663,    27,   321,   297,
  1192,  1476,  1311,  1058,   421,   424,   611,   248,    39,   137,
  1482,  1483,  1013,  1484,  1592,   351,   666,  1178,   980,  1367,
  1181,  -295,   147,   189,   512,   515,   580,   739,   581,   630,
   460,    58,   512,  -144,  1059,   138,   222,   636,   792,    39,
    95,   110,   111,  -145,   515,   137,  -366,   461,    15,   433,
   161,   225,  1197,  1198,  1248,  1069,   533,   665,   706,   225,
    58,   210,   298,   515,    58,  1627,  1253,   179,   190,   191,
  1423,  -304,   178,   261,   700,   462,   225,    40,   301,    72,
  -366,    10,   769,   726,  -366,   473,  -304,   537,  1408,  1070,
  -304,  1242,   200,  1071,   112,   113,   114,  1292,    59,   177,
  1274,  1195,  1276,   222,   223,   447,    18,  -304,    40,   216,
   217,    89,   127,   128,  1423,    14,  -366,    21,  1424,  -304,
  -304,   475,  -304,   406,  -304,  1072,   534,   210,  1654,   183,
   248,    90,   427,   428,   706,   222,   222,   648,    20,   175,
   200,   908,   187,   222,   188,   610,   429,    23,   821,   636,
     8,   538,  -304,  -304,   796,   222,   430,   818,   909,  1572,
  1573,    72,  1530,    26,    32,   130,   131,  -304,   431,   652,
    18,   535,  1114,   351,   222,   244,  1655,   636,    91,   912,
    59,   116,   117,   118,   246,  -622,   910,   847,   787,   913,
   611,   815,   840,   300,   769,   364,   793,   475,    92,   923,
   711,   375,   914,   130,   131,   176,   351,   376,   351,   138,
   351,   776,   777,  1004,   653,   351,   855,   855,   855,   855,
  1096,   822,   769,   807,   450,  -596,   363,   539,   351,  1209,
  -622,  -622,   402,  1308,  1309,   119,   120,   841,   351,   296,
   373,   351,   377,    72,   924,  -622,  -304,   716,  1055,  1056,
   717,   189,   623,   697,  1060,  1008,    58,  1009,   798,   799,
   986,   381,   720,   708,   500,   501,   749,   709,   754,   756,
  -596,  -596,   583,   127,   128,   351,   297,   656,    13,   138,
   707,   657,  -120,   795,    15,  -596,   648,   823,   580,   225,
   581,  -304,  -304,   382,   706,   222,   190,   502,   473,   139,
    18,   474,  1010,  -295,   925,  1149,  -298,   426,  1191,    26,
   512,  1011,  1012,  -128,  -128,   412,  -120,   636,   414,   985,
  -120,   434,   200,   545,    26,   225,   130,   131,  -617,   983,
   304,   927,   537,   587,   225,   222,   567,   568,    58,   298,
   637,   122,   257,   127,   128,   393,    -7,  1013,   351,   926,
   638,   225,  -120,   508,   509,   930,   933,   475,  1293,  1294,
  1157,  1296,   639,   640,   475,  1017,   261,  1157,   215,   216,
   217,  -118,  1018,    15,   473,    14,   928,   301,   395,   396,
    10,   127,   128,   477,   660,  1045,  1157,   164,   200,   477,
   200,   200,    18,   448,   101,   378,   130,   131,    20,   127,
   128,   129,   115,   706,   773,  -118,   807,    23,   449,  -118,
   474,    26,   452,   773,  1442,    90,    21,   200,   464,   379,
    58,   222,   712,   567,   568,   200,   364,  1269,  1270,  1271,
  1046,    27,   321,   518,   130,   131,   500,   727,   821,    92,
   821,  -118,   508,   728,   364,   234,   821,   818,   821,   818,
   155,   543,   130,   131,  1078,  1088,  1157,   818,   539,   770,
   964,   541,  1157,    32,  1026,  1027,   475,  1073,  1102,  1103,
    59,  1104,    59,   475,   544,  1141,   253,   908,   210,   946,
    59,   815,   528,   815,   222,  1203,   706,   351,   351,    91,
   351,   815,   706,   838,   909,  1199,  1047,  1048,   380,   477,
    91,   756,   542,  1254,   389,  1243,  1244,  1245,   433,    92,
   561,   822,  1074,  1065,  1205,    88,   296,  1445,   137,    76,
    92,   822,   910,  1288,   947,   948,  1207,   529,   417,   137,
  1204,  1501,  1477,    72,   473,    72,   583,  1298,   839,   421,
   424,   473,   552,    72,    88,   559,  1606,   421,   424,   475,
    76,   215,   216,   217,   560,   475,   626,    76,    14,  1206,
  1633,   855,     8,     9,   562,  1143,   155,   155,   155,   563,
   202,  1208,   214,  1646,   147,    18,  1502,   823,   564,   823,
   676,    20,   200,   677,   433,  1067,  1068,   823,   367,   371,
    23,  1607,   608,   609,    15,  1099,   855,   693,  -415,     8,
     9,  1157,   706,   716,   717,   965,   474,   364,    15,  1229,
  1231,   720,  -415,   155,   477,   130,   131,  1079,  1647,   519,
   521,   679,   257,   200,   680,  1411,   477,  -415,  -415,   127,
  1391,   694,   531,   681,   116,   117,   118,  1421,  1422,   253,
  1505,  -415,  -415,   473,   364,   706,  -415,   855,   351,  1157,
   473,   408,   130,   131,    90,   411,  1522,   215,   216,   217,
   477,   700,   477,    92,    14,   475,   770,   930,   933,   475,
   500,  1524,   484,   261,   364,   257,   539,  1111,  1112,  1113,
    76,    18,   130,   131,    76,   706,    26,    20,   119,   120,
   202,   214,   718,   474,  1283,  1285,    23,  1078,     8,     9,
    -6,   855,   722,   566,  1061,   741,   539,   742,   475,   254,
    58,    91,    58,   757,    89,   768,    91,   706,   821,  -825,
    58,   783,  -142,   433,  -143,   766,   473,   818,   579,   706,
  -576,    92,   473,  -576,    90,    15,    92,   832,   202,  1084,
   833,  1505,   834,   364,   675,   835,  1219,  1220,   475,  1062,
    59,   130,   131,   685,  1219,  1220,   475,   127,   128,   508,
  1525,   815,  1505,   706,   842,   706,   675,   225,   843,   943,
   733,   433,   859,   855,   225,   500,  1529,    95,   415,   416,
   475,  -576,  1285,  -576,  -576,  -184,  -576,   861,  1300,  1603,
   862,   822,   475,   225,   864,   920,    89,  -576,   922,  -576,
   137,  -184,   941,  -184,  1255,   943,  1368,   351,    26,   967,
   130,   131,   574,    72,  -576,  -576,    90,   978,   969,   708,
   127,   128,  1505,  1578,   546,   536,   475,   968,   475,  -576,
   706,    98,   113,   982,   547,   158,   979,  1053,   984,  -298,
    20,  1455,   473,   735,  1018,  1257,   473,  1453,  1405,  1458,
    89,  1259,  1260,   412,   414,  1257,  1262,   823,  1426,  1260,
  1079,   992,   537,   225,   993,   996,   770,  1002,  1350,   225,
    90,    26,  1003,   130,   131,    91,   667,   454,   706,  1341,
  1024,  1051,  1342,  1427,   540,   473,  1043,   546,  1050,   821,
  1057,   930,   933,   475,  1054,    92,  1115,   547,   818,  1116,
  1157,  1117,   797,  1121,  1122,    95,   110,   111,   530,  1119,
   155,   155,   155,   567,   568,  1120,    95,   110,   111,  1123,
   202,    59,    95,    96,    97,   473,  1124,  1125,  -141,  1128,
    89,    72,   815,   473,  1126,  1471,  1129,  1131,  1478,  1361,
  1362,   475,   773,  1132,    21,   116,   798,   799,   773,   800,
    90,   158,   158,   158,  1047,  1048,  1133,   473,    76,   112,
   113,  1134,   822,  1157,  1137,   872,  1135,  1136,  1138,   473,
   112,   113,  1494,   668,    26,  1349,    98,    99,   100,   222,
   801,  1148,  1084,   789,    72,  1150,   202,   752,   202,   202,
    58,   127,   128,  1151,   762,  1152,  1350,    26,   158,   119,
   120,  1153,   411,   473,   210,   473,  1350,  1341,   225,   921,
  1162,   127,   128,  1350,  1160,   202,   536,  1341,   545,  1161,
  1342,   855,  1171,   202,  1341,  1172,  1568,  1342,   823,   153,
  1177,  1190,  1184,  1186,   574,   636,   574,   421,   424,  1189,
   828,   852,    26,  1202,   130,   131,   716,   717,   605,   606,
   607,   608,   609,   720,   574,  1228,   225,  1241,   637,    72,
  1258,  1263,    26,  1268,   130,   131,  1264,   574,   638,    72,
   473,   879,  1272,   383,   384,   385,    72,   225,   912,   988,
   639,   640,  1278,    95,    96,    97,  1279,   995,   913,  1620,
  1280,  1281,  1295,  1286,  1290,   140,   140,  1299,   156,   902,
  1210,   914,  1291,  1349,   461,   919,  1307,  1301,    58,  1250,
  1251,  -659,  1302,  1349,   383,   384,   385,   872,   473,   386,
  1349,   940,   213,   706,   221,  1303,  1306,   387,   388,   364,
   238,  1312,  1313,  1365,  1372,   773,  1265,    98,    99,  1376,
  1398,  1267,  1399,  1452,  1400,  1452,   422,   425,   301,   395,
   396,    10,  1409,  1406,  1480,  1481,   773,  1550,    95,    96,
    97,    58,  1350,  1350,  1550,   155,    26,  1350,   387,   388,
  1410,  1415,   155,  1341,  1341,  1387,  1342,  1416,  1341,   222,
   202,  1342,  1417,   351,  1361,  1362,   475,    21,  1418,  1425,
  1434,  1435,   153,  1436,   252,  1448,  1450,  1463,  1495,  1490,
  1508,   706,    27,   321,   127,   128,   140,  1491,  1350,  1648,
  1052,   140,    98,    99,   156,   156,   156,  1350,  1492,  1341,
   298,   202,  1342,   510,  1493,    72,    72,   298,  1341,  1497,
    72,  1342,  1509,   376,    32,   467,    58,    95,   110,   111,
  1513,   213,  1516,  1550,   776,   777,    58,   451,   216,   217,
  1100,  1515,   259,    58,    14,    26,  1105,   130,   131,   487,
   487,   496,  1523,  1546,   475,   200,  1554,   200,  1350,  1349,
  1349,    72,  1564,  1565,  1349,   221,   259,    20,  1589,  1341,
    72,  1580,  1342,   513,   221,  1590,    23,  1075,  1076,     9,
    10,   112,   113,  1598,  1614,   158,   158,   158,  1379,  1380,
  1596,  1389,  1390,  1601,  1392,   259,   298,   225,  1350,  1602,
  1635,  1618,   116,   798,   799,  1349,   259,  1624,  1625,  1341,
  1628,  1631,  1342,  1636,  1349,   140,    21,   576,  1640,  1645,
   828,    72,   828,   116,   798,   799,  1649,  1085,  1092,    26,
   828,    27,    28,  1650,  1657,  1249,  1581,  1077,  1604,  1652,
  1658,    95,   110,   111,  1660,   194,   685,  1661,    95,   110,
   111,     1,  1163,   473,  1164,   195,   119,   120,   443,   988,
   225,    72,     5,    32,   160,  1349,   259,   196,   603,   604,
   605,   606,   607,   608,   609,    26,   773,   119,   120,   127,
   128,  1520,   981,   216,   217,  1146,   156,   296,   442,    14,
  1193,   725,    58,    58,   296,   112,  1517,    58,   440,     8,
     9,   259,   112,  1519,   247,  1349,  1619,  1089,  1314,  1474,
  1475,   361,    20,   -52,   520,   410,   422,   719,   -52,  1169,
  1504,    23,   574,   636,  1656,   259,    18,   551,   518,   -52,
    26,   473,   130,   131,  1185,   155,   155,   155,    58,   773,
  1023,   127,   128,   155,   155,   155,   637,    58,   970,   523,
    26,  1370,   130,   131,  1246,  1266,   638,  1091,   200,  1183,
  1393,   213,   221,   511,   216,   217,  1236,   503,   646,   640,
    14,   633,   971,   296,   907,   140,  1237,  1461,   140,   391,
   422,   425,   129,  1359,   156,   156,   156,    18,  1238,  1642,
   140,  1634,    26,    20,   130,   131,  1593,   467,    58,  1284,
  1639,  1641,    23,  1042,  1470,     0,   471,     0,     0,   574,
     0,  1537,  1538,  1539,     0,     0,     0,  1273,   259,  1275,
     0,     0,     0,     0,     0,     0,     0,   213,     0,   221,
   411,     0,     0,     0,     0,     0,     0,     0,    58,   576,
   158,   576,     0,   487,     0,     0,   487,   158,   496,   496,
   496,    95,   110,   111,   451,   226,   227,   228,   422,   860,
   487,   513,   221,     0,     0,   451,     0,  1570,  1571,   513,
  1085,     0,   576,     0,     0,   259,  1305,     0,     0,    18,
  1319,     0,   451,     0,     0,   229,  1284,   467,     0,     0,
     0,     8,     9,     0,     0,     0,  1075,  1076,     9,    10,
   828,     0,     0,     0,     0,   112,   113,     0,   156,     0,
   156,     0,     0,     0,     0,     0,     0,     0,    18,  1297,
     0,   301,   127,   128,    10,     0,   156,   156,   156,     0,
     0,     0,   954,   468,     0,    21,  1621,     0,     0,     0,
     0,   156,    26,     0,   130,   131,   467,     0,    26,    18,
    27,    28,   467,     0,   467,   467,  1077,  1371,  1236,     0,
    21,     0,  1375,     0,   194,     0,   636,   341,  1237,   341,
     0,   341,     0,    26,   195,    27,   321,     0,     0,     0,
  1238,   467,    32,     0,   259,     0,   196,     0,   467,  1173,
     0,     0,   929,   929,   936,     0,     0,     0,     0,  1174,
   612,   955,     0,   127,   128,  1440,  1441,    32,   247,     0,
   259,  1175,   640,     0,  1412,     0,   341,     0,   341,   471,
     0,   221,     0,    95,   110,   111,     0,   682,   683,   684,
    18,     0,     0,     0,   153,     0,     0,     0,     0,   613,
   614,  1040,     0,   615,   616,   617,   618,   636,     0,  1401,
  1402,  1403,  1404,     0,    26,   954,   130,   131,     0,  1407,
     0,   221,   238,  1388,     0,   422,   719,     0,  1388,   469,
   637,   828,     0,     0,     0,   489,   492,   112,   113,     0,
   638,   601,   602,   603,   604,   605,   606,   607,   608,   609,
   467,  1500,   639,   640,     0,   471,   259,     0,     0,     0,
     0,  1025,  1025,  1031,   467,  1438,  1486,  1487,     0,     0,
  1031,   259,     0,  1518,  1521,     0,     0,     0,     0,     0,
   158,   158,   158,  1496,   156,     0,     0,     0,   158,   158,
   158,   487,   487,   496,   496,   496,     0,     0,     0,   487,
    95,    96,    97,     0,   226,   227,   228,   513,     0,     0,
   451,     0,     0,   202,  1456,   202,     0,     0,     0,     0,
     0,     0,     0,     0,   155,     0,     0,     0,    18,     0,
  1381,  1382,     9,    10,   229,     0,     0,     0,   213,     0,
     0,     0,  1533,  1534,     0,     0,     0,     0,     0,     0,
  1566,     0,    26,     0,    98,    99,   230,     0,  1544,  1545,
     0,   565,     0,     0,     0,   740,     0,     0,     0,    21,
  1514,     7,     8,   251,    10,   259,     0,     0,     0,     0,
     0,     0,    26,     0,    27,    28,     0,     0,   370,   372,
  1383,     0,     0,   155,   155,   155,   422,   860,   194,   341,
   231,   232,   233,   259,     0,   467,     0,     0,   195,     0,
    21,     0,     0,     0,     0,   471,    32,   252,     0,   467,
   196,   467,   471,   467,     0,    27,    28,     0,     0,     0,
     0,     0,     0,  1548,     0,     7,     8,     9,    10,   879,
  1548,    13,     0,     0,     0,   929,     0,     0,   929,   253,
     0,     0,     0,     0,     0,   848,     0,    32,     0,   574,
   929,     0,     0,    18,  1170,  1170,   955,     0,     0,     0,
     0,   470,     0,   467,    21,   422,   425,     0,     0,     0,
   636,     0,     0,   422,  1227,     0,     0,    26,     0,    27,
    28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   738,   469,     0,   746,   238,     0,     0,     0,   467,     0,
     0,     0,     0,   747,   900,     0,   202,     0,     0,  1548,
   901,    32,   903,   904,   471,   748,   640,     0,     0,   774,
     0,   471,   775,     0,   489,   492,     0,     0,  1623,     0,
     0,  1025,  1025,  1218,  1218,  1031,   791,     0,     0,     0,
  1025,  1218,  1218,  1031,     0,     0,   959,   341,     0,  1638,
     0,     0,  1239,  1239,  1239,     0,     0,     0,   879,     0,
     0,     7,   127,   128,    10,     0,     0,     0,   259,     0,
   259,     0,   451,   451,     0,     0,     0,     0,     0,     0,
   341,   469,     0,     0,     0,     0,     0,     0,   851,     0,
     0,     0,     0,     0,     0,     0,     0,   471,     0,   451,
    21,     0,   578,   471,   451,     0,     0,   252,     0,     0,
   422,   719,   341,     0,   738,    27,    28,   876,   877,     0,
   881,   882,   883,   884,   885,   886,   887,   888,   889,   890,
   891,   892,   893,   894,   895,   896,   897,   898,   899,   253,
   469,     0,     0,   127,   128,   259,   469,    32,   469,   469,
     0,     0,     0,     0,     0,     0,     0,     0,   422,   719,
     0,     0,     0,     0,   654,     8,     9,    10,     0,     0,
    18,     0,     0,     0,   705,   469,     0,     0,  1170,  1170,
   955,     0,   469,     0,     0,     0,     0,   636,     0,   467,
     0,   467,     0,   467,    26,     0,   130,   131,   259,   158,
   310,   655,     0,    21,   127,   128,   973,   975,   216,   217,
   637,     0,     0,   471,    14,     0,    26,   471,   130,   131,
   638,     0,   341,     0,  1025,  1025,  1218,  1218,  1031,     0,
     0,  1025,   639,   640,     0,     0,     0,    20,     0,     0,
     0,  1239,  1239,  1239,     0,     0,    23,     0,   636,     0,
   705,     7,     8,     9,    10,    26,   471,   130,   131,     0,
     0,   451,   451,     0,   451,   451,   738,   451,   158,   158,
   158,   637,     0,     0,     0,     0,     0,   489,   492,     0,
     0,   638,     0,     0,   469,     0,     0,     0,   259,     0,
    21,     0,     0,   639,   640,   467,   471,   252,   469,     0,
     0,     0,     0,  1142,   471,    27,    28,   774,   775,   489,
   492,     0,     0,     0,     0,   791,     0,  1154,     0,  1155,
     0,  1156,     0,     0,   849,     0,   850,     0,   471,   253,
     0,   853,   854,   856,   857,   858,     0,    32,     0,     0,
   471,     0,     0,  1063,   578,     0,     0,     7,     8,     9,
    10,   215,   216,   217,   213,   221,     0,   875,    14,     0,
     0,   341,   341,     0,   341,     0,  1469,  1469,     0,  1469,
     0,  1188,     0,   259,   471,    18,   471,     0,     0,     0,
     0,    20,   451,   451,     0,     0,    21,     0,     0,     0,
    23,   905,   636,  1040,     0,     0,     0,     0,     0,    26,
  1127,    27,    28,     0,     0,     0,  1200,     0,     0,     0,
   935,     0,     0,     0,     0,   194,     0,   935,     0,     0,
     0,     0,     0,     0,     0,   195,     0,  1381,   127,   128,
    10,     0,     0,    32,     0,     0,     0,  1457,   738,   469,
     0,   471,   467,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   469,     0,   469,     0,   469,     0,     0,
     0,     0,   496,   422,  1227,     0,    21,     0,     0,     0,
     0,  1469,  1469,  1532,     0,   259,     0,     0,     0,    26,
     0,    27,    28,    80,   451,   451,   451,  1383,     0,   471,
     0,     0,     0,   104,     0,    30,  1182,     0,     0,     0,
     0,     0,     0,   133,     0,    31,     0,   469,     0,   144,
   144,     0,   144,    32,    80,     0,     0,    33,     0,   935,
     0,    80,   341,     0,     0,  1196,   935,     0,     0,     0,
     0,   496,   496,   496,   204,     0,    80,     0,     0,     0,
   451,   451,   469,     0,   239,     0,     0,     0,     0,     0,
     0,   104,     0,     0,     0,     0,     0,   774,   775,   489,
   492,     0,   263,   104,     0,     0,   791,   489,   492,     0,
     0,     0,   738,   738,     0,     0,     0,     0,   774,   775,
   791,     0,     0,     8,     9,   104,     0,     0,   536,   127,
   128,     0,     0,     0,   536,     0,     0,  1315,     0,  1316,
     0,  1317,   470,     0,     0,     0,  1256,     0,   470,   451,
    18,     0,     0,   133,     0,    80,    18,     0,     0,   144,
   144,     0,     0,     0,   413,   144,     0,     0,   144,   144,
   144,     0,     0,   636,    26,     0,   130,   131,     0,     0,
    26,     0,   130,   131,    80,     0,     0,     0,    80,     0,
  1236,     0,     0,     0,   204,    80,   637,   738,   738,     0,
  1237,  1287,   301,     8,     9,    10,   638,     0,     0,     0,
     0,     0,  1238,   204,   204,   204,     0,  1139,   639,   640,
     0,   341,     0,     0,   810,     0,     7,     8,   811,    10,
   167,    12,    13,     0,     0,     0,     0,    14,     0,     0,
     0,    21,   204,  1414,   301,   395,   396,    10,   252,     0,
     0,    16,   875,    17,    18,    19,    27,   321,   470,   522,
    20,  -520,   935,     0,     0,    21,     0,     0,   104,    23,
   812,     0,   168,   469,   471,   469,     0,   469,    26,   144,
    27,    28,     0,    21,   813,   738,   814,     0,    32,     0,
   774,   775,   489,   492,    30,     0,    26,   791,    27,   321,
     0,   705,     0,  1194,    31,     0,     0,   489,   492,   738,
     0,     0,    32,     0,     0,     0,    33,   104,   548,     0,
     0,     0,     0,  1377,  1378,     0,     0,     0,     0,     0,
    32,     0,  -520,     0,     0,     0,     0,     8,     9,     0,
   260,   935,   247,     0,     0,     0,     0,     0,     0,   935,
     0,   738,   471,     0,     0,   931,   934,  1233,     0,     0,
     0,     0,     0,   104,    18,     0,     0,   634,     0,   548,
   548,   649,     0,   470,     0,     0,     0,     0,     0,   469,
    80,   636,     0,     0,     0,   470,     0,     0,    26,     0,
   130,   131,     7,     8,     9,    10,     0,     0,   247,  1433,
     0,     0,     0,     0,  1466,     0,     0,     0,     0,     0,
     0,     0,     0,   133,  1467,     0,     0,   435,     0,   470,
    18,   470,   104,     0,   204,   104,  1468,   640,     0,  1277,
     0,    21,   774,   775,     0,   791,     0,   636,   738,   144,
     0,     0,   144,     0,    26,     0,    27,    28,     0,     0,
   486,     0,  1479,     0,   144,     0,     0,     0,     0,     0,
   746,     0,    80,   505,   931,   934,     0,     0,     0,     0,
   747,     0,     0,     0,     0,   738,     0,     0,    32,     0,
     0,     0,   748,   640,     0,     0,   935,     0,     0,     0,
   204,   753,   204,   204,   649,     0,     0,     0,   753,     0,
     7,     8,     9,    10,     0,     0,   204,   204,     0,     0,
   204,     0,   204,   204,   204,   781,     0,     0,     0,   204,
     0,     0,     0,     0,   204,     0,   469,   204,    18,     0,
     0,     0,     0,     0,   935,     0,     0,   489,   492,    21,
     0,     0,     0,     0,    80,   636,  1535,  1536,     0,     0,
     0,     0,    26,     0,    27,    28,     0,     0,   810,     0,
     7,     8,   811,    10,   167,    12,    13,     0,   746,     0,
     0,    14,     0,     0,     0,     0,     0,     0,   747,  1561,
   104,   104,   104,   104,     0,    16,    32,    17,    18,    19,
   748,   640,     0,     0,    20,  -521,     0,   489,   492,    21,
     0,     0,     0,    23,   812,     0,   168,     0,     0,     0,
  1575,     0,    26,     0,    27,    28,     0,     0,   813,     0,
   814,     0,     0,     0,     0,     0,     0,     0,    30,     0,
     0,     0,     0,     7,     8,     9,    10,     0,    31,    13,
   104,     0,   548,     0,     0,     0,    32,     0,  1158,     0,
    33,  1159,     0,     0,   634,     0,   548,   548,   649,     0,
     0,    18,     0,  1165,     0,   956,  -521,   931,   934,   958,
     0,     0,    21,     0,     0,     0,     0,  1233,   636,     0,
     0,     0,     0,     0,   204,    26,     0,    27,    28,   598,
   599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
   609,  1028,     0,   301,     8,     9,    10,     0,     0,     0,
   133,  1029,   738,     0,     0,     0,     0,   133,     0,    32,
     0,     0,     0,  1030,   640,   204,   239,     0,     0,   301,
   127,   128,    10,     7,     8,     9,    10,     0,     0,     0,
     0,     0,    21,     0,  1158,  1159,   931,   934,     0,   252,
     0,     0,     0,  1165,   931,   934,   784,    27,   321,     0,
     0,   790,     0,     0,     0,   204,   204,  1033,    21,     0,
     0,     0,    21,     0,  1033,   252,     0,     0,   636,   935,
     0,   253,     0,    27,   321,    26,   830,    27,    28,    32,
     0,     0,   836,     0,     0,   204,   204,   781,   781,   781,
     0,   746,     0,   204,   844,   845,     0,   846,     8,     9,
     0,   747,     0,   536,     0,    32,     0,     0,     0,    32,
     0,     0,     0,   748,   640,     0,     0,     8,     9,     0,
     0,   133,    13,     0,    80,    18,    80,     0,     0,   578,
     0,  1086,    80,     0,    80,     0,     0,     0,     0,     0,
   104,     0,   636,     0,    18,     0,   104,   705,     0,    26,
     0,   130,   131,   548,   548,   548,     0,     0,     0,     0,
     0,   636,     0,     0,   548,  1466,     0,     0,    26,     0,
   130,   131,     0,     0,     0,  1467,     0,     0,     0,     0,
     0,   931,   934,     0,  1466,     0,     0,  1468,   640,     0,
   944,   945,     0,     0,  1467,   944,     0,     7,     8,     9,
    10,   167,    12,    13,     0,     0,  1468,   640,    14,     0,
     0,     0,     0,     0,     0,   104,   301,     8,     9,    10,
     0,     0,    16,     0,    17,    18,    19,  1158,  1159,   931,
   934,    20,     0,     0,  1165,     0,    21,     0,   548,   548,
    23,     0,   548,   168,    18,   548,     0,     0,     0,    26,
   104,    27,    28,     0,   548,    21,   104,     0,   956,   956,
   956,   636,     0,     0,   548,    30,  1176,     0,    26,     0,
    27,   321,     0,     0,     0,    31,     0,     0,     0,     0,
     0,     0,     0,    32,  1221,     0,     0,    33,     0,     0,
     0,    34,     0,     0,  1222,     0,     0,     0,  1035,   104,
     0,   104,    32,     0,   678,     0,  1223,   640,   588,   589,
   590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
   600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
  1049,     0,     0,     0,   204,   204,   204,   204,   204,  1033,
   781,     8,     9,     0,   204,  1033,  1033,  1033,  -387,     8,
     9,  -387,  -387,    12,   247,   104,   781,   781,   781,    14,
     0,     0,     0,     0,     0,     0,     0,     0,    18,  1158,
  1159,   104,  1165,    16,  1086,    17,  -387,     0,     0,     0,
     0,     0,    20,   104,     0,   636,  1107,  -387,  1109,     0,
     0,    23,    26,   636,   130,   131,  1261,     0,     0,     0,
    26,     0,   130,   131,    80,     0,     0,     0,  1466,     0,
     0,     0,     0,     0,     0,     0,   637,   104,  1467,   104,
     0,     0,     0,     0,     0,     0,   638,   104,     0,     0,
  1468,   640,     0,     0,  -387,     0,     0,     0,   639,   640,
     0,     0,     0,     0,     0,     0,     0,     0,     7,     8,
     9,    10,     0,   548,   548,     0,   548,     0,     0,     0,
  1144,  1145,     0,  1147,     0,     7,     8,     9,    10,   215,
   216,   217,     0,     0,   931,   934,    14,     0,     0,   548,
     0,     0,   548,   548,   649,     0,     0,    21,     0,     0,
     0,     0,     0,    18,  1166,     0,     0,     0,     0,    20,
    26,     0,    27,    28,    21,     0,   193,     0,    23,     0,
   636,     0,     0,     0,     0,     0,   194,    26,     0,    27,
    28,     0,     0,     0,     0,     0,   195,   781,   204,   204,
   781,   781,  1363,   746,    32,   204,     0,     0,   196,     0,
     0,     0,     0,   747,     0,   781,   781,   781,   781,     0,
    83,    32,     0,     0,     0,   755,   640,     0,     0,     0,
   106,     0,     0,     0,     0,     0,     0,   204,     0,   126,
   134,     0,   144,     0,     0,    80,   145,   145,     0,   145,
     0,    83,  1226,     0,     0,     0,     0,     0,    83,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   145,     0,    83,     0,     0,     0,     0,     0,  1247,
     0,   240,     0,     0,     0,     0,     0,     0,   249,     0,
     6,  1252,     7,     8,     9,    10,    11,    12,    13,     0,
   249,     0,     0,    14,     0,     0,     0,     0,     0,     7,
     8,     9,    10,     0,     0,   536,    15,    16,     0,    17,
    18,    19,     0,     0,     0,     0,    20,   204,   753,   204,
     0,    21,     0,     0,    22,    23,    24,    18,    25,     0,
   781,   781,     0,   781,    26,   104,    27,    28,    21,     0,
    29,     0,    83,     0,   636,     0,   145,   145,     0,     0,
    30,    26,   145,    27,    28,   145,   145,   145,     0,     0,
    31,     0,     0,     0,     0,     0,     0,   746,    32,  1304,
     0,    83,    33,     0,     0,    83,    34,   747,     0,     0,
     0,   145,    83,     0,     0,    32,     0,     0,     0,   748,
   640,     0,     7,   127,   128,    10,     0,     0,    13,     0,
   145,   145,   145,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   301,     8,     9,    10,     0,     0,     0,
    18,     0,     0,     0,     0,     0,  1033,     0,     0,   145,
     0,    21,  1364,     0,     0,   781,   781,  1363,   781,     0,
     0,     0,     0,     0,    26,     0,    27,    28,     0,     0,
     0,     0,    21,     0,     0,     0,     0,     0,     0,   252,
    30,     0,     0,     0,     0,     0,   145,    27,   321,     0,
    31,     0,     0,     0,     0,     0,  1396,     0,    32,     0,
  1397,   810,    33,     7,     8,   811,    10,   167,    12,    13,
     0,   539,     0,     0,    14,  1033,  1033,  1033,     0,    32,
     0,   781,     0,     0,   249,   145,     0,     0,    16,     0,
    17,    18,    19,     0,  1413,   104,     0,    20,  -523,     0,
   204,     0,    21,     0,     0,     0,    23,   812,     0,   168,
     0,     0,     0,     0,     0,    26,     0,    27,    28,     0,
     0,   813,     0,   814,     0,     0,     0,     0,     0,     0,
   249,    30,     0,     0,   635,     0,   145,   145,   650,     0,
     0,    31,     0,   659,     0,     0,     0,    83,     0,    32,
     0,     0,     0,    33,     0,     0,   301,   127,   128,    10,
  1472,     0,    13,     0,  1473,     0,     0,     0,     0,  -523,
     0,     0,     0,     0,     0,     0,     0,     8,     9,     0,
   698,     0,    13,     0,    18,     0,  1488,  1489,     0,   249,
     0,   145,   249,     0,     0,    21,     0,     0,     0,     0,
     0,   636,     0,     0,    18,     0,   145,     0,    26,   145,
    27,   321,     0,     0,     0,     0,     0,   301,     8,     9,
    10,   145,     0,    13,  1173,     0,     0,     0,    26,    83,
   130,   131,     0,     0,  1174,     0,     0,     0,     0,     0,
     0,     0,    32,     0,  1236,    18,  1175,   640,     0,     0,
     0,     0,     0,     0,  1237,     0,    21,   145,   650,   145,
   145,   650,   636,     0,     0,   650,  1238,     0,     0,    26,
     0,    27,   321,   145,   145,     0,     0,   145,     0,   145,
   145,   145,   145,     0,     0,  1221,   145,     0,     0,     0,
     0,   145,     0,     0,   145,  1222,     0,     0,     0,     0,
     0,     0,     0,    32,     0,     0,     0,  1223,   640,     0,
   809,    83,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   570,     0,   301,     8,     9,    10,
   167,    12,   302,   303,   304,   466,   305,    14,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   249,   249,   249,
   249,    16,   306,    17,    18,    19,     0,   307,   308,   309,
    20,     0,   310,   311,   312,    21,   313,   314,     0,    23,
     0,   636,     0,   315,   316,   317,   318,   319,    26,     0,
    27,   321,  -312,     0,     0,   322,     0,     0,     0,     0,
     0,   323,     0,     0,   949,     0,     0,     0,     0,     0,
     0,     0,   325,   326,   950,     0,     0,   249,     0,   145,
   328,   329,   330,     0,     0,     0,   951,   640,     0,     0,
     0,     0,     0,   145,   145,   650,     0,     0,     0,     0,
     0,     0,   957,   332,   810,     0,     7,     8,   811,    10,
   167,    12,    13,     0,     0,   659,     0,    14,     0,     0,
     0,   145,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    16,     0,    17,    18,    19,     0,     0,     0,     0,
    20,  -522,     0,     0,     0,    21,     0,   698,     0,    23,
   812,     0,   168,     0,     0,   126,     0,     0,    26,     0,
    27,    28,   145,   240,   813,     0,   814,     0,     0,     0,
     0,     0,     0,     0,    30,     7,     8,     9,    10,     0,
     0,     0,     0,     0,    31,     0,   809,     0,     0,     0,
     0,     0,    32,     0,     0,     0,    33,     0,     0,     0,
     0,     0,   145,   145,   650,     0,     0,     0,     0,     0,
     0,   957,  -522,     0,    21,     0,     0,     0,   166,     0,
     7,     8,     9,    10,   167,    12,    13,    26,     0,    27,
    28,    14,   145,   145,   145,   145,   145,     0,     0,     0,
   145,     0,     0,   194,     0,    16,     0,    17,    18,    19,
     0,     0,     0,   195,    20,     0,     0,     0,     0,    21,
     0,    32,     0,    23,     0,   196,   168,     0,   134,     0,
     0,    83,    26,    83,    27,    28,     0,     0,  1087,    83,
     0,    83,     0,     0,     0,     0,     0,   249,    30,     7,
   127,   128,    10,   249,     0,   247,     0,     0,    31,     0,
   145,   145,   145,     0,     0,     0,    32,    51,     0,     0,
    33,   145,     0,     0,    34,     0,     0,    18,     0,     0,
     0,     0,     7,   127,   128,    10,     0,     0,    21,     0,
     0,     0,     0,    51,    51,     0,   152,     0,    51,     0,
     0,    26,     0,    27,    28,    51,     0,     0,     0,     0,
    18,     0,     0,     0,     0,     0,     0,    30,    51,     0,
    51,    21,   249,     0,     0,     0,     0,    31,     0,     0,
     0,     0,     0,     0,    26,    32,    27,    28,     0,    33,
     0,     0,     0,   255,     0,   145,   145,     0,     0,   145,
   149,     0,   145,     0,     0,     0,     0,   249,     0,     0,
   150,   145,     0,   249,     0,   957,   957,   957,    32,     0,
     0,   145,   151,   659,     0,     0,     0,     0,     0,     0,
     0,     0,     7,     8,     9,    10,   215,   216,   217,     0,
     0,     0,     0,    14,     0,     0,   397,   397,     0,    51,
     0,     0,     0,    51,    51,     0,   249,   255,   249,    51,
    18,     0,   152,   152,   152,     0,    20,     0,     0,   432,
     0,    21,     0,     0,     0,    23,     0,   636,    51,     0,
     0,     0,    51,     0,    26,     0,    27,    28,    51,    51,
     0,   145,   145,   145,   145,   145,   650,   145,     0,     0,
   746,   145,   957,   957,   957,     0,     0,    51,    51,   152,
   747,     0,   249,   145,   145,   145,     0,   255,    32,     0,
     0,     0,   748,   640,     0,     0,   809,     0,   249,     0,
     0,  1087,     0,     0,     0,     0,    51,     0,     0,     0,
   249,     0,     6,     0,     7,     8,     9,    10,    11,    12,
    13,     0,     0,     0,     0,    14,     0,     0,     0,     0,
     0,    83,     0,     0,     7,   127,   128,    10,     0,    16,
    13,    17,    18,    51,   249,     0,   249,     0,    20,     0,
     0,     0,     0,    21,   249,     0,     0,    23,     0,     0,
   439,     0,    18,     0,     0,     0,    26,     0,    27,    28,
     0,     0,    29,    21,     7,     8,     9,    10,     0,     0,
   145,   145,    30,   145,     0,     0,    26,     0,    27,    28,
     0,     0,    31,     0,     0,     0,     0,     0,     0,     0,
    32,     0,   149,     0,    33,     0,   145,     0,     0,   145,
   145,   650,   150,    21,   575,     0,     0,     0,     0,     0,
    32,     0,     0,     0,   151,     0,    26,     0,    27,    28,
     0,   397,  1451,     0,     0,     0,     0,     0,   809,   255,
     0,     0,   194,     0,    51,     0,     0,     0,     0,     0,
     0,     0,   195,     0,   145,   145,   145,   145,   145,   650,
    32,     0,   145,     0,   196,     0,     0,     0,     0,     0,
     0,     0,   145,   145,   145,   145,     0,   397,     0,   809,
     0,     0,     0,     0,     0,     0,     0,     0,    51,     0,
     0,     8,     9,     0,   145,    12,   247,     0,     0,   145,
     0,    14,    83,    51,     0,     0,    51,     0,     0,     0,
     0,     0,   432,   432,   432,    16,     0,    17,    51,     0,
     0,     0,     0,     0,    20,     0,    51,     0,     0,     0,
     0,     0,     0,    23,     0,   636,     0,     0,     0,     0,
     0,     0,    26,     0,   130,   131,     0,     0,     0,     0,
     0,     0,     0,     0,    51,    51,    51,    51,   637,     0,
     0,     0,    51,     0,     0,     0,     0,     0,   638,     0,
    51,    51,     0,  1444,    51,     0,   152,   152,   152,   432,
   639,   640,     0,    51,   145,   650,   145,     0,    51,     8,
     9,    51,     0,    12,    13,     0,     0,   145,   145,    14,
   145,     0,   249,     0,     0,     0,     8,     9,    51,   167,
    12,    13,     0,    16,   466,    17,    14,     0,     0,     0,
     0,     0,    20,     0,     0,     0,     0,     0,     0,     0,
    16,    23,    17,    18,     0,     0,   575,     0,   575,    20,
    26,     0,   130,   131,   619,     0,     0,     0,    23,     0,
   636,     0,     0,     0,   575,   575,   575,    26,     0,   130,
   131,     0,     0,    78,     0,     0,     0,     0,     0,   575,
     0,     0,     0,   637,     0,     0,     0,     0,   620,     7,
     8,     9,    10,   638,     0,    13,     0,     0,     0,    78,
    78,     0,    78,   957,    78,   639,   640,     0,     0,     0,
     0,    78,   145,   145,   650,   145,     0,    18,     0,     0,
     0,     0,     0,     0,    78,     0,    78,   255,    21,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   575,
     0,    26,     0,    27,    28,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   194,    51,     0,
     0,     0,     0,     0,     0,   159,     0,   195,     0,     0,
     0,     0,   957,   957,   957,    32,     0,     0,   145,   196,
     0,     0,     0,     0,   397,     0,     0,   205,     0,     0,
     0,   397,   249,     0,     0,     0,     0,   145,     0,    51,
     0,     0,     0,     0,     0,    78,     0,     0,     0,    78,
    78,     0,     0,     0,     0,    78,     0,     0,    78,    78,
    78,   597,   598,   599,   600,   601,   602,   603,   604,   605,
   606,   607,   608,   609,    78,     0,     0,     0,    78,    51,
    51,   152,     0,     0,    78,    78,   255,     0,  1039,     0,
     0,     0,     0,     0,     0,     0,     0,     7,   127,   128,
    10,     0,   575,    78,    78,    78,     0,     0,     0,    51,
    51,   432,   432,   432,     0,     0,     0,    51,     0,     0,
     0,   159,   159,   159,     0,    18,     0,     0,     0,     0,
     0,     0,    78,     0,     0,     0,    21,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   205,    51,    26,
    51,    27,    28,     0,     0,    51,    51,     0,    51,     0,
     0,     0,     0,     0,     0,    30,   205,   205,   498,    78,
     0,     0,     0,     0,     0,    31,     0,     0,     0,     0,
     0,     0,     0,    32,     0,     0,     0,    33,     0,     0,
     0,     0,     0,     0,     0,   205,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,  1459,     0,  1322,
  1323,  1324,    10,   167,    12,   302,   303,   304,     0,   305,
    14,  1325,     0,  1326,  1327,  1328,  1329,  1330,  1331,  1332,
  1333,  1334,  1335,    15,    16,   306,    17,    18,    19,     0,
   307,   308,   309,    20,     0,   310,   311,   312,    21,   313,
   314,  1336,    23,  1337,     0,     0,   315,   316,   317,   318,
   319,    26,     0,  1338,   321,   733,   658,  1339,   322,     0,
    78,   549,     0,     0,   323,     0,     0,   324,     0,     0,
     0,     0,   575,   575,   575,   325,   326,   327,   432,   255,
     0,     0,     0,   328,   329,   330,     0,     0,     0,   331,
     0,  1340,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    78,  1460,   332,     0,     0,     0,
     0,     0,   643,   643,   643,     0,     0,     0,     0,    78,
     0,     0,    78,     0,     0,     0,     0,     7,   127,   128,
    10,     0,     0,   536,    78,     0,     0,     0,     0,     0,
     0,     0,    78,     0,     0,     0,     0,     0,    51,    51,
    51,   152,   152,   152,   432,    18,   255,     0,    51,  1039,
  1039,  1039,     0,     0,     0,     0,    21,   205,     0,     0,
    78,    78,    78,    78,     0,     0,     0,     0,    78,    26,
     0,    27,    28,     0,     0,     0,    78,    78,    51,     0,
    78,     0,    78,    78,    78,    30,     0,     0,     0,    78,
     0,     0,     0,     0,    78,    31,     0,    78,     0,   255,
     0,     0,     0,    32,     0,     0,     0,    33,    51,     0,
     0,     8,     9,     0,    78,    12,   247,     0,     0,     0,
     0,    14,     0,   750,     0,   750,   750,   643,     0,     0,
     0,     0,     0,     0,     0,    16,     0,    17,     0,   205,
   205,     0,     0,   205,    20,   498,   498,   498,   782,     0,
     0,     0,   205,    23,     0,     0,     0,   205,     0,     0,
   205,     0,    26,     0,   130,   131,     0,     0,     0,     0,
     0,     0,     0,     7,     8,     9,    10,   167,    12,    13,
     0,     0,   466,   432,    14,     0,   432,   432,   432,   255,
     0,     0,     0,     0,     0,     0,     0,     0,    16,     0,
    17,    18,     0,     0,     0,     0,     0,    20,     0,     0,
     0,     0,    21,     0,     0,     0,    23,     0,   636,     0,
     0,     0,     0,     0,   658,    26,     0,    27,    28,     0,
     0,   432,    51,    51,   432,   432,   432,     0,     0,    51,
     0,  1028,     0,     0,     0,     0,     0,     0,     0,     0,
     0,  1029,     0,     0,    78,     0,     0,     0,     0,    32,
     0,     0,     0,  1030,   640,     0,     0,     0,     0,     0,
     0,    51,     0,     0,     0,   915,    51,     0,     0,    51,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   643,
   643,   643,     0,     0,     0,    78,     0,   810,   643,     7,
     8,   811,    10,   167,    12,    13,     0,     0,     0,     0,
    14,     0,     0,     0,     0,     0,     0,   205,     0,     0,
     0,     0,     0,     0,    16,     0,    17,    18,    19,     0,
     0,     0,     0,    20,     0,    78,    78,    78,    21,     0,
     0,     0,    23,   812,  1041,   168,     0,     0,     0,     0,
     0,    26,     0,    27,    28,     0,     0,   813,   750,   814,
     0,    51,    51,    51,     0,    78,    78,    30,     0,     0,
     0,     0,     0,    78,     0,     0,     0,    31,     0,     0,
     0,     0,     0,     0,     0,    32,     0,     0,     0,    33,
     0,     0,     0,     0,     0,     0,     0,     0,   750,   750,
  1034,     0,     0,     0,    78,     0,    78,  1034,     0,     0,
     0,    78,    78,     0,    78,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   205,   205,
   782,   782,   782,     0,     0,     0,   205,   301,     8,     9,
    10,   167,    12,    13,     0,     0,   466,     0,    14,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    16,     0,    17,    18,     0,     0,     0,     0,
  1039,    20,     0,     0,   205,     0,    21,     0,     0,     0,
    23,     0,   636,     0,     0,     0,     0,     0,     0,    26,
     0,    27,   321,     0,     0,     0,   549,   549,   549,     0,
     0,     0,     0,     0,     0,  1173,     0,   643,     7,     8,
     9,    10,     0,     0,   247,  1174,     0,   203,     0,     0,
     0,     0,     0,    32,     0,     0,     0,  1175,   640,     0,
     0,     0,     0,     0,     0,     0,    18,     0,     0,  1039,
  1039,  1039,   258,     0,     0,   262,   658,    21,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    26,     0,    27,    28,    51,     0,   258,     0,   366,     0,
     0,     0,     0,     0,     0,     0,   194,     0,     0,     0,
     0,   643,   643,     0,     0,   643,   195,     0,   643,     0,
     0,     0,     0,     0,    32,     0,     0,   643,   196,     0,
     0,   643,   643,   643,     0,     0,     0,   643,     7,     8,
     9,    10,     0,     0,    78,    78,    78,    78,    78,    78,
     0,     0,     0,     0,    78,  1041,  1041,  1041,     0,     0,
     0,     0,     0,     0,     0,     0,    18,   203,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    21,     0,     0,
     0,     0,     0,     0,    78,     0,   203,   203,   203,     0,
    26,     0,    27,    28,     0,     0,   504,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   493,   750,   750,   750,
  1034,  1034,  1034,  1224,    78,   203,   494,   750,  1034,  1034,
  1034,     0,     0,     0,    32,     0,     0,     0,   495,   782,
   782,   782,     0,   301,     8,     9,    10,   167,    12,    13,
     0,   262,   466,     0,    14,     0,     0,   205,     0,     0,
     0,     0,     0,     0,     0,   258,     0,     0,    16,     0,
    17,    18,     0,     0,     0,     0,     0,    20,     0,     0,
     0,     0,    21,     0,     0,     0,    23,     0,   636,     8,
     9,     0,     0,    12,    13,    26,     0,    27,   321,    14,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,  1221,     0,    16,     0,    17,   641,   641,   641,     0,
     0,  1222,    20,     0,     0,     0,     0,     0,     0,    32,
     0,    23,     0,  1223,   640,     0,   915,   915,     0,   915,
    26,     0,   130,   131,     0,     0,     0,     0,    78,    78,
     0,     0,     0,     0,     0,    78,     0,     0,   258,   262,
     0,     0,   643,     0,     0,   643,   643,   643,     0,     0,
     7,     8,     9,    10,     0,     0,    13,     0,   906,     0,
     0,     0,     0,     0,     0,     0,     0,    78,     0,     0,
     0,     0,    78,     0,     0,    78,     0,     0,    18,     0,
     0,     0,     0,     0,     0,     0,     0,   203,     0,    21,
  1224,   750,   750,  1224,  1224,  1224,     0,     0,   750,     0,
     0,     0,    26,     0,    27,    28,     0,     0,   782,   782,
   782,   782,     0,     0,     0,     0,     0,   641,   493,   641,
   641,   641,     0,     0,     0,     0,     0,     0,   494,     0,
   205,     0,     0,   102,     0,     0,    32,     0,     0,     0,
   495,     0,   121,   102,     0,     0,     0,     0,     0,   102,
   102,     0,   102,   203,     0,   203,   203,    78,    78,    78,
     0,     7,     8,     9,    10,   206,    12,   207,     0,   203,
   203,     0,    14,   203,     0,   203,   203,   203,   203,     0,
     0,     0,   203,     0,   236,     0,    16,   203,    17,    18,
   203,     0,     0,     0,     0,    20,     0,     0,     0,     0,
    21,     0,     0,     0,    23,     0,     0,     0,     0,     0,
     0,     0,     0,    26,     0,    27,    28,     0,     0,   208,
   205,     0,   205,     0,     0,     0,     0,     0,     0,    30,
     0,     0,     0,  1224,  1224,     0,  1224,     0,     0,    31,
     0,     0,     0,   390,     0,   121,     0,    32,     0,     0,
     0,    33,   102,   102,     0,     0,     0,     0,     0,   102,
   102,     0,     0,   102,   102,   102,  1041,   418,   102,   102,
   102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   641,   641,   641,     0,     0,     0,     0,
     0,     0,   953,     0,     0,     0,     0,     0,     0,     0,
     8,     9,     0,   167,    12,    13,     0,     0,   466,     0,
    14,     0,     0,     0,     0,     0,     0,     7,     8,     9,
    10,     0,     0,   536,    16,     0,    17,    18,     0,   498,
     0,   258,   262,    20,     0,  1041,  1041,  1041,  1224,  1224,
  1224,  1224,    23,     0,   636,    18,     0,   203,     0,     0,
     0,    26,   641,   130,   131,     0,    21,     0,   236,   102,
    78,     0,     0,     0,     0,     0,     0,  1466,     0,    26,
     0,    27,    28,     0,     0,     0,     0,  1467,     0,   102,
     0,     0,     0,     0,     0,   194,     0,     0,   203,  1468,
   640,     0,   641,   641,   641,   195,     0,     0,   498,   498,
   498,   953,     0,    32,  1224,     0,     0,   196,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   102,     0,
     0,     0,     0,   205,     0,     0,     0,     0,   203,   203,
  1032,     0,     0,     0,     0,   258,     0,  1032,   592,   593,
   594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
   604,   605,   606,   607,   608,   609,     0,     0,   203,   203,
   203,   203,   203,   504,     0,     0,   203,   102,     0,   102,
   102,     0,     7,     8,     9,    10,   167,    12,    13,     0,
     0,   761,     0,    14,     0,     0,     0,     0,     0,     0,
     0,   262,     0,     0,     0,     0,     0,    16,     0,    17,
    18,   641,     0,     0,   203,     0,    20,     0,     0,     0,
     0,    21,     0,   102,     0,    23,   301,     8,     9,    10,
     0,     0,    13,     0,    26,     0,    27,    28,     0,     0,
     0,     0,   102,     0,     0,     7,     8,     9,    10,   102,
    30,     0,   102,     0,    18,     0,     0,     0,     0,     0,
    31,     0,     0,     0,   102,    21,     0,     0,    32,     0,
     0,     0,    33,    18,     0,     0,     0,     0,    26,     0,
    27,   321,     0,     0,    21,   641,   641,     0,     0,   641,
     0,     0,   641,     0,   778,     0,     0,    26,     0,    27,
    28,   641,     0,  1510,   779,   953,   953,   953,     0,     0,
     0,   641,    32,   194,     0,     0,   780,     0,     0,     0,
     0,     0,     0,   195,     0,     0,     0,     0,     0,     0,
     0,    32,     0,     0,     0,   196,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   258,   262,
   258,   102,     0,   802,  1511,   588,   589,   590,   591,   592,
   593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
   603,   604,   605,   606,   607,   608,   609,   102,     0,     0,
     0,   641,   641,   641,   641,   641,   641,   641,     0,     0,
     0,   641,   953,   953,   953,   588,   589,   590,   591,   592,
   593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
   603,   604,   605,   606,   607,   608,   609,   203,   203,   203,
   203,   203,  1032,   203,     0,  1225,     0,   203,  1032,  1032,
  1032,  1075,     8,   811,    10,   206,    12,   207,  1597,   203,
   203,   203,    14,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   102,     0,     0,     0,    16,   203,    17,    18,
     0,     0,     0,   102,   102,    20,   102,   102,     0,     0,
    21,     0,     0,     0,    23,     0,     0,     0,   504,     0,
     0,     0,     0,    26,     0,    27,    28,     0,     0,     0,
     0,  1077,     0,     0,   301,     8,     9,    10,     0,    30,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    31,
     0,     0,     0,     0,     0,     0,     0,    32,     0,     0,
   102,    33,    18,     0,     0,     0,   641,   102,   121,   641,
   641,   641,     0,    21,     0,     0,   236,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    26,     0,    27,   321,
     0,     0,    18,     0,     0,     0,     0,     0,     0,   802,
     0,     0,   778,     0,     0,     0,     0,     0,   258,     0,
     0,     0,   779,     0,   641,   641,   641,   641,   641,   641,
    32,     0,   641,     0,   780,   588,   589,   590,   591,   592,
   593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
   603,   604,   605,   606,   607,   608,   609,     0,     0,     0,
   203,   203,   203,   203,   203,  1032,     0,     0,   203,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   203,   203,
   203,   203,     0,     0,     0,     0,     0,     0,   802,     0,
     0,   102,     0,     0,     0,     0,     0,     0,     0,     0,
   203,     0,     0,     0,     0,     0,     0,     0,   570,     0,
     7,     8,     9,    10,   167,    12,   302,   303,   304,   466,
   305,    14,     0,   102,   102,   102,     0,     0,     0,     0,
     0,     0,     0,     0,   102,    16,   306,    17,    18,    19,
     0,   307,   308,   309,    20,     0,   310,   311,   312,    21,
   313,   314,     0,    23,     0,   636,     0,   315,   316,   317,
   318,   319,    26,     0,    27,    28,  -312,   641,   641,   322,
   641,     0,     0,     0,     0,   323,     0,     0,  1036,     0,
     0,     0,     0,     0,     0,     0,   325,   326,  1037,     0,
   203,     0,   203,     0,   328,   329,   330,     0,     0,     0,
  1038,   640,     0,   203,   203,  1225,   203,     0,   102,   102,
     0,     0,   102,     0,     0,   102,     0,   332,     0,     0,
     0,     0,     0,     0,   102,     0,     7,     8,     9,    10,
   206,    12,   207,     0,   102,     8,     9,    14,   167,    12,
    13,     0,     0,   466,     0,    14,     0,     0,     0,     0,
     0,    16,     0,    17,    18,     0,     0,     0,     0,    16,
    20,    17,    18,     0,     0,    21,     0,     0,    20,    23,
     0,     0,   641,   641,   641,   641,     0,    23,    26,     0,
    27,    28,     0,     0,  1454,     0,    26,     0,   130,   131,
     0,     0,     0,     0,    30,     0,     0,     0,     0,  1032,
     0,     0,     0,     0,    31,     0,     0,     0,   203,   203,
  1032,   203,    32,     0,     0,     0,    33,     0,     0,     0,
     0,     7,     8,     9,    10,   167,    12,    13,     0,     0,
     0,     0,    14,     0,     0,     0,     0,     0,   641,   802,
     0,     0,     0,     0,     0,     0,    16,     0,    17,    18,
     0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
    21,     0,     0,     0,    23,     0,   102,     0,  1032,  1032,
  1032,     0,     0,    26,   203,    27,    28,     8,     9,     0,
   167,    12,    13,     0,     0,     0,     0,    14,     0,    30,
     0,     0,     0,   203,     0,     0,     0,     0,     0,    31,
     0,    16,     0,    17,    18,     0,     0,    32,     0,     0,
    20,    33,     0,     0,     0,     0,     0,     0,     0,   699,
     0,     0,   168,   102,   102,     0,   102,     0,    26,     0,
   130,   131,     0,     0,     0,     0,     0,  1540,     0,  -478,
  -478,  -478,  -478,  -478,  -478,  -478,     0,     0,  -478,   102,
  -478,     0,   102,   102,     0,     0,     0,     0,     0,     0,
     0,  -478,     0,  -478,     0,     0,     0,  -478,     0,     0,
     0,     0,     0,  -478,     0,     0,     0,     0,  -478,     0,
     0,   802,  -478,     0,  -478,     0,     0,     0,     0,     0,
     0,  -478,     0,  -478,  -478,  -478,  -478,  -478,     0,  -478,
  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,  -478,
  -478,  -478,   802,  -478,  -478,  -478,     0,  -478,  -478,  -478,
  -478,  -478,     0,     0,     0,     0,     0,  1541,  -478,     0,
   102,     0,   102,  -478,  -478,  -478,  1321,  -478,  1322,  1323,
  1324,    10,   167,    12,   302,   303,   304,     0,   305,    14,
  1325,     0,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,
  1334,  1335,    15,    16,   306,    17,    18,    19,     0,   307,
   308,   309,    20,     0,   310,   311,   312,    21,   313,   314,
  1336,    23,  1337,     0,     0,   315,   316,   317,   318,   319,
    26,     0,  1338,   321,   733,     0,  1339,   322,     0,     0,
     0,     0,     0,   323,     0,     0,   324,     0,     0,     0,
     0,     0,     0,     0,   325,   326,   327,     0,     0,     0,
     0,     0,   328,   329,   330,     0,     0,     0,   331,   465,
  1340,   301,     8,     9,    10,   167,    12,   302,   303,   304,
   466,   305,    14,     0,     0,   332,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    16,   306,    17,    18,
    19,     0,   307,   308,   309,    20,     0,   310,   311,   312,
    21,   313,   314,     0,    23,     0,     0,     0,   315,   316,
   317,   318,   319,    26,     0,    27,   321,     0,     0,     0,
   322,     0,     0,     0,     0,     0,   323,     0,     0,   324,
     0,     0,     0,     0,     0,     0,     0,   325,   326,   327,
     0,     0,     0,     0,     0,   328,   329,   330,     0,     0,
   878,   331,   301,     8,     9,    10,   167,    12,   302,   303,
   304,     0,   305,    14,     0,     0,  -796,     0,   332,     0,
     0,     0,     0,     0,     0,     0,     0,    16,   306,    17,
    18,    19,     0,   307,   308,   309,    20,     0,   310,   311,
   312,    21,   313,   314,     0,    23,     0,     0,     0,   315,
   316,   317,   318,   319,    26,     0,    27,   321,  1556,     0,
  -786,   322,     0,     0,     0,     0,     0,   323,     0,     0,
   324,     0,     0,     0,     0,     0,     0,     0,   325,   326,
   327,     0,     0,     0,     0,     0,   328,   329,   330,     0,
     0,   736,   331,   866,   867,   868,    10,     0,    12,   482,
   303,   304,     0,   305,    14,     0,     0,     0,     0,   332,
     0,     0,     0,     0,     0,     0,     0,     0,    16,   306,
    17,     0,    19,     0,   307,   308,   309,    20,     0,   310,
   311,   312,    21,   313,   314,     0,    23,     0,     0,     0,
   315,   316,   317,   318,   319,    26,     0,   869,   870,   737,
     0,     0,   322,     0,     0,     0,     0,     0,   323,     0,
     0,   324,     0,     0,     0,     0,     0,     0,     0,   325,
   326,   327,     0,     0,     0,     0,     0,   328,   329,   330,
     0,     0,     0,   331,   871,   570,     0,   301,     8,     9,
    10,     0,    12,   302,   303,   304,     0,   305,    14,  1022,
   332,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    16,   306,    17,    18,    19,     0,   307,   308,
   309,    20,     0,   310,   311,   312,    21,   313,   314,     0,
    23,     0,     0,     0,   315,   316,   317,   318,   319,    26,
     0,    27,   321,  -312,     0,     0,   322,     0,     0,     0,
     0,     0,   323,     0,     0,   571,     0,     0,     0,     0,
     0,     0,     0,   325,   326,   572,     0,     0,     0,     0,
     0,   328,   329,   330,     0,     0,   736,   573,   866,   867,
   868,    10,     0,    12,   482,   303,   304,     0,   305,    14,
     0,     0,     0,     0,   332,     0,     0,     0,     0,     0,
     0,     0,     0,    16,   306,    17,     0,    19,     0,   307,
   308,   309,    20,     0,   310,   311,   312,    21,   313,   314,
     0,    23,     0,     0,     0,   315,   316,   317,   318,   319,
    26,     0,   869,   870,   737,     0,     0,   322,     0,     0,
     0,     0,     0,   323,     0,     0,   324,     0,     0,     0,
     0,     0,     0,     0,   325,   326,   327,     0,     0,     0,
     0,     0,   328,   329,   330,     0,     0,     0,   331,   871,
   736,     0,   301,     8,     9,    10,     0,    12,   482,   303,
   304,     0,   305,    14,     0,   332,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    16,   306,    17,
     0,    19,     0,   307,   308,   309,    20,     0,   310,   311,
   312,    21,   313,   314,     0,    23,     0,     0,     0,   315,
   316,   317,   318,   319,    26,     0,    27,   321,   737,     0,
     0,   322,     0,     0,     0,     0,     0,   323,     0,     0,
   324,     0,     0,     0,     0,     0,     0,     0,   325,   326,
   327,     0,     0,     0,     0,     0,   328,   329,   330,     0,
     0,     0,   331,   736,     0,   866,   867,   868,    10,  1230,
    12,   482,   303,   304,     0,   305,    14,     0,     0,   332,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    16,   306,    17,     0,    19,     0,   307,   308,   309,    20,
     0,   310,   311,   312,    21,   313,   314,     0,    23,     0,
     0,     0,   315,   316,   317,   318,   319,    26,     0,   869,
   870,   737,     0,     0,   322,     0,     0,     0,     0,     0,
   323,     0,     0,   324,     0,     0,     0,     0,     0,     0,
     0,   325,   326,   327,     0,     0,     0,     0,     0,   328,
   329,   330,     0,     0,   736,   331,   866,   867,   868,    10,
     0,    12,   482,   303,   304,     0,   305,    14,     0,     0,
     0,  -482,   332,     0,     0,     0,     0,     0,     0,     0,
     0,    16,   306,    17,     0,    19,     0,   307,   308,   309,
    20,     0,   310,   311,   312,    21,   313,   314,     0,    23,
     0,     0,     0,   315,   316,   317,   318,   319,    26,     0,
   869,   870,   737,     0,     0,   322,     0,     0,     0,     0,
     0,   323,     0,     0,   324,     0,     0,     0,     0,     0,
     0,     0,   325,   326,   327,     0,     0,     0,     0,     0,
   328,   329,   330,     0,     0,   570,   331,     7,     8,     9,
    10,     0,    12,   302,   303,   304,     0,   305,    14,     0,
     0,     0,  1360,   332,     0,     0,     0,     0,     0,     0,
     0,     0,    16,   306,    17,    18,    19,     0,   307,   308,
   309,    20,     0,   310,   311,   312,    21,   313,   314,     0,
    23,     0,     0,     0,   315,   316,   317,   318,   319,    26,
     0,    27,    28,  -312,     0,     0,   322,     0,     0,     0,
     0,     0,   323,     0,     0,  1526,     0,     0,     0,     0,
     0,     0,     0,   325,   326,  1527,     0,     0,     0,     0,
     0,   328,   329,   330,     0,     0,   736,  1528,   301,     8,
     9,    10,     0,    12,   482,   303,   304,     0,   305,    14,
     0,     0,     0,     0,   332,     0,     0,     0,     0,     0,
     0,     0,     0,    16,   306,    17,     0,    19,     0,   307,
   308,   309,    20,     0,   310,   311,   312,    21,   313,   314,
     0,    23,     0,     0,     0,   315,   316,   317,   318,   319,
    26,     0,    27,   321,   737,     0,     0,   322,     0,     0,
     0,     0,     0,   323,     0,     0,   324,     0,     0,     0,
     0,     0,     0,     0,   325,   326,   327,     0,     0,     0,
     0,     0,   328,   329,   330,     0,     0,   878,   331,   301,
     8,     9,    10,     0,    12,   482,   303,   304,     0,   305,
    14,     0,     0,     0,     0,   332,     0,     0,     0,     0,
     0,     0,     0,     0,    16,   306,    17,     0,    19,     0,
   307,   308,   309,    20,     0,   310,   311,   312,    21,   313,
   314,     0,    23,     0,     0,     0,   315,   316,   317,   318,
   319,    26,     0,    27,   321,     0,     0,     0,   322,  -786,
     0,     0,     0,     0,   323,     0,     0,   324,     0,     0,
     0,     0,     0,     0,     0,   325,   326,   327,     0,     0,
     0,     0,     0,   328,   329,   330,     0,     0,  1609,   331,
   301,     8,     9,    10,     0,    12,   302,   303,   304,     0,
   305,    14,     0,     0,     0,     0,   332,     0,     0,     0,
     0,     0,     0,     0,     0,    16,   306,    17,     0,    19,
     0,   307,   308,   309,    20,     0,   310,   311,   312,    21,
   313,   314,     0,    23,     0,     0,     0,   315,   316,   317,
   318,   319,    26,     0,    27,   321,     0,     0,  -197,   322,
     0,     0,     0,     0,     0,   323,     0,     0,   324,     0,
     0,     0,     0,     0,     0,     0,   325,   326,   327,     0,
     0,     0,     0,     0,   328,   329,   330,     0,     0,   878,
   331,   301,     8,     9,    10,     0,    12,   482,   303,   304,
     0,   305,    14,     0,     0,     0,     0,   332,     0,     0,
     0,     0,     0,     0,     0,     0,    16,   306,    17,     0,
    19,     0,   307,   308,   309,    20,     0,   310,   311,   312,
    21,   313,   314,     0,    23,     0,     0,     0,   315,   316,
   317,   318,   319,    26,     0,    27,   321,     0,     0,     0,
   322,     0,     0,     0,     0,     0,   323,     0,     0,   324,
     0,     0,     0,     0,     0,     0,     0,   325,   326,   327,
     0,     0,     0,     0,     0,   328,   329,   330,     0,     0,
   972,   331,   301,     8,     9,    10,     0,    12,   482,   303,
   304,     0,   305,    14,     0,     0,  -786,     0,   332,     0,
     0,     0,     0,     0,     0,     0,     0,    16,   306,    17,
     0,    19,     0,   307,   308,   309,    20,     0,   310,   311,
   312,    21,   313,   314,     0,    23,     0,     0,     0,   315,
   316,   317,   318,   319,    26,     0,    27,   321,     0,     0,
     0,   322,     0,     0,     0,     0,     0,   323,     0,     0,
   324,     0,     0,     0,     0,     0,     0,     0,   325,   326,
   327,     0,     0,     0,     0,     0,   328,   329,   330,     0,
     0,   974,   331,   301,     8,     9,    10,     0,    12,   482,
   303,   304,     0,   305,    14,     0,     0,     0,     0,   332,
     0,     0,     0,     0,     0,     0,     0,     0,    16,   306,
    17,     0,    19,     0,   307,   308,   309,    20,     0,   310,
   311,   312,    21,   313,   314,     0,    23,     0,     0,     0,
   315,   316,   317,   318,   319,    26,     0,    27,   321,     0,
     0,     0,   322,     0,     0,     0,     0,     0,   323,     0,
     0,   324,     0,     0,     0,     0,     0,     0,     0,   325,
   326,   327,     0,     0,     0,     0,     0,   328,   329,   330,
     0,     0,  1574,   331,   301,     8,     9,    10,     0,    12,
   482,   303,   304,     0,   305,    14,     0,     0,     0,     0,
   332,     0,     0,     0,     0,     0,     0,     0,     0,    16,
   306,    17,     0,    19,     0,   307,   308,   309,    20,     0,
   310,   311,   312,    21,   313,   314,     0,    23,     0,     0,
     0,   315,   316,   317,   318,   319,    26,     0,    27,   321,
     0,     0,     0,   322,     0,     0,     0,     0,     0,   323,
   264,     0,   324,     8,     9,     0,     0,    12,    13,     0,
   325,   326,   327,    14,     0,     0,     0,     0,   328,   329,
   330,     0,     0,     0,   331,     0,     0,    16,     0,    17,
     0,     0,     0,     0,     0,     0,    20,     0,   265,   266,
     0,   332,     0,     0,     0,    23,     0,   267,     0,     0,
     0,     0,     0,     0,    26,     0,   130,   131,     0,   268,
     0,     0,     0,   269,   270,   271,   272,   273,   274,   275,
   276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
   286,   287,   288,   289,     0,     0,   290,   291,   292,     0,
   293,     0,     0,   294,   301,     8,     9,    10,     0,    12,
   482,   303,   304,     0,   305,    14,     0,     0,     0,   295,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
   306,    17,     0,    19,     0,   307,   308,   309,    20,     0,
   310,   311,   312,    21,   313,   314,     0,    23,     0,     0,
     0,   315,   316,   317,   318,   319,    26,     0,    27,   321,
     0,     0,     0,   322,     0,     0,     0,     0,     0,   323,
     0,     0,   324,     0,     0,     0,     0,     0,     0,     0,
   325,   326,   327,     0,     0,     0,     0,     0,   328,   329,
   330,     0,     0,     0,   331,   301,     8,     9,    10,     0,
    12,   482,   303,   304,     0,   305,    14,     0,     0,     0,
     0,   332,   483,     0,     0,     0,     0,     0,     0,     0,
    16,   306,    17,     0,    19,     0,   307,   308,   309,    20,
     0,   310,   311,   312,    21,   313,   314,     0,    23,     0,
     0,     0,   315,   316,   317,   318,   319,    26,     0,    27,
   321,     0,     0,     0,   322,     0,     0,     0,     0,     0,
   323,     0,     0,   324,     0,     0,     0,     0,     0,     0,
     0,   325,   326,   327,     0,     0,     0,     0,     0,   328,
   329,   330,     0,     0,     0,   331,   301,     8,     9,    10,
     0,    12,   482,   303,   304,     0,   305,    14,     0,     0,
     0,     0,   332,   788,     0,     0,     0,     0,     0,     0,
     0,    16,   306,    17,     0,    19,     0,   307,   308,   309,
    20,     0,   310,   311,   312,    21,   313,   314,     0,    23,
     0,     0,     0,   315,   316,   317,   318,   319,    26,     0,
    27,   321,     0,     0,     0,   322,     0,     0,     0,     0,
     0,   323,     0,     0,   324,     0,     0,     0,     0,     0,
     0,     0,   325,   326,   327,     0,     0,     0,     0,     0,
   328,   329,   330,     0,     0,     0,   331,   301,     8,     9,
    10,     0,    12,   482,   303,   304,     0,   305,    14,     0,
     0,     0,     0,   332,   918,     0,     0,     0,     0,     0,
     0,     0,    16,   306,    17,     0,    19,     0,   307,   308,
   309,    20,     0,   310,   311,   312,    21,   313,   314,     0,
    23,     0,     0,     0,   315,   316,   317,   318,   319,    26,
     0,    27,   321,     0,     0,     0,   322,     0,     0,     0,
     0,     0,   323,     0,     0,   324,     0,     0,     0,     0,
     0,     0,     0,   325,   326,   327,     0,     0,     0,     0,
     0,   328,   329,   330,     0,     0,     0,   331,   301,     8,
     9,    10,     0,    12,   482,   303,   304,     0,   305,    14,
     0,     0,     0,     0,   332,   939,     0,     0,     0,     0,
     0,     0,     0,    16,   306,    17,     0,    19,     0,   307,
   308,   309,    20,     0,   310,   311,   312,    21,   313,   314,
     0,    23,     0,     0,     0,   315,   316,   317,   318,   319,
    26,     0,    27,   321,     0,     0,     0,   322,     0,     0,
     0,     0,     0,   323,     0,     0,   324,     0,     0,     0,
     0,     0,     0,     0,   325,   326,   327,     0,     0,     0,
     0,     0,   328,   329,   330,     0,     0,     0,   331,   594,
   595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
   605,   606,   607,   608,   609,   332,  1168,  1322,  1323,  1324,
    10,   167,    12,   302,   303,   304,     0,   305,    14,  1325,
     0,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
  1335,    15,    16,   306,    17,    18,    19,     0,   307,   308,
   309,    20,     0,   310,   311,   312,    21,   313,   314,  1336,
    23,  1337,     0,     0,   315,   316,   317,   318,   319,    26,
     0,  1338,   321,   733,     0,  1339,   322,     0,     0,     0,
     0,     0,   323,     0,     0,   324,     0,     0,     0,     0,
     0,     0,     0,   325,   326,   327,     0,     0,     0,     0,
     0,   328,   329,   330,     0,     0,     0,   331,     0,  1340,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,  1464,   332,  1322,  1323,  1324,    10,   167,
    12,   302,   303,   304,     0,   305,    14,  1325,     0,  1326,
  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,    15,
    16,   306,    17,    18,    19,     0,   307,   308,   309,    20,
     0,   310,   311,   312,    21,   313,   314,  1336,    23,  1337,
     0,     0,   315,   316,   317,   318,   319,    26,     0,  1338,
   321,   733,     0,  1339,   322,     0,     0,     0,     0,     0,
   323,     0,     0,   324,     0,     0,     0,     0,     0,     0,
     0,   325,   326,   327,     0,     0,     0,     0,     0,   328,
   329,   330,     0,     0,     0,   331,     0,  1340,     0,  1322,
  1323,  1324,    10,   167,    12,   302,   303,   304,     0,   305,
    14,  1325,   332,  1326,  1327,  1328,  1329,  1330,  1331,  1332,
  1333,  1334,  1335,    15,    16,   306,    17,    18,    19,     0,
   307,   308,   309,    20,     0,   310,   311,   312,    21,   313,
   314,  1336,    23,  1337,     0,     0,   315,   316,   317,   318,
   319,    26,     0,  1338,   321,  1583,     0,  1339,   322,     0,
     0,     0,     0,     0,   323,     0,     0,   324,     0,     0,
     0,     0,     0,     0,     0,   325,   326,   327,     0,     0,
     0,     0,     0,   328,   329,   330,     0,     0,     0,   331,
     0,  1340,     0,  1322,  1323,  1324,    10,   167,    12,   302,
   303,   304,     0,   305,    14,  1325,   332,  1326,  1327,  1328,
  1329,  1330,  1331,  1332,  1333,  1334,  1335,    15,    16,   306,
    17,    18,    19,     0,   307,   308,   309,    20,     0,   310,
   311,   312,    21,   313,   314,  1336,    23,  1337,     0,     0,
   315,   316,   317,   318,   319,    26,     0,  1338,   321,     0,
     0,  1339,   322,     0,     0,     0,     0,     0,   323,     0,
     0,   324,     0,     0,     0,     0,     0,     0,     0,   325,
   326,   327,     0,     0,     0,     0,     0,   328,   329,   330,
     0,     0,     0,   331,     0,  1340,   301,     8,     9,    10,
   167,    12,   302,   303,   304,   466,   305,    14,     0,     0,
   332,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    16,   306,    17,    18,    19,     0,   307,   308,   309,
    20,     0,   310,   311,   312,    21,   313,   314,     0,    23,
     0,   636,     0,   315,   316,   317,   318,   319,    26,     0,
    27,   321,     0,     0,     0,   322,     0,     0,     0,     0,
     0,   323,     0,     0,   949,     0,     0,     0,     0,     0,
     0,     0,   325,   326,   950,     0,     0,     0,     0,     0,
   328,   329,   330,     0,     0,     0,   951,   640,     7,     8,
     9,    10,   167,    12,   302,   303,   304,   466,   305,    14,
     0,     0,     0,   332,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    16,   306,    17,    18,    19,     0,   307,
   308,   309,    20,     0,   310,   311,   312,    21,   313,   314,
     0,    23,     0,   636,     0,   315,   316,   317,   318,   319,
    26,     0,    27,    28,     0,     0,     0,   322,     0,     0,
     0,     0,     0,   323,     0,     0,  1036,     0,     0,     0,
     0,     0,     0,     0,   325,   326,  1037,     0,     0,     0,
     0,     0,   328,   329,   330,     0,     0,     0,  1038,   640,
   301,     8,     9,    10,     0,    12,   302,   303,   304,     0,
   305,    14,     0,     0,     0,   332,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    16,   306,    17,    18,    19,
     0,   307,   308,   309,    20,     0,   310,   311,   312,    21,
   313,   314,     0,    23,     0,   636,     0,   315,   316,   317,
   318,   319,    26,     0,    27,   321,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   323,     0,     0,   949,     0,
     0,     0,     0,     0,     0,     0,   325,   326,   950,     0,
     0,     0,     0,     0,   328,   329,   330,     0,     0,     0,
   951,   640,     7,     8,     9,    10,     0,    12,   302,   303,
   304,     0,   305,    14,     0,     0,     0,   332,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    16,   306,    17,
    18,    19,     0,   307,   308,   309,    20,     0,   310,   311,
   312,    21,   313,   314,     0,    23,     0,   636,     0,   315,
   316,   317,   318,   319,    26,     0,    27,    28,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   323,     0,     0,
  1036,     0,     0,     0,     0,     0,     0,     0,   325,   326,
  1037,     0,     0,     0,     0,     0,   328,   329,   330,     0,
     0,     0,  1038,   640,   301,     8,     9,    10,     0,    12,
   482,   303,   304,     0,   305,    14,     0,     0,     0,   332,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
   306,    17,    18,    19,     0,   307,   308,   309,    20,     0,
   310,   311,   312,    21,   313,   314,     0,    23,     0,     0,
     0,   315,   316,   317,   318,   319,    26,     0,    27,   321,
     0,     0,     0,   322,     0,     0,     0,     0,     0,   323,
     0,     0,   571,     0,     0,     0,     0,     0,     0,     0,
   325,   326,   572,     0,     0,     0,     0,     0,   328,   329,
   330,     0,     0,     0,   573,   301,     8,     9,    10,     0,
    12,   482,   303,   304,     0,   305,    14,     0,     0,     0,
     0,   332,     0,     0,     0,     0,     0,     0,     0,     0,
    16,   306,    17,     0,    19,     0,   307,   308,   309,    20,
     0,   310,   311,   312,    21,   313,   314,     0,    23,     0,
     0,     0,   315,   316,   317,   318,   319,    26,     0,    27,
   321,     0,     0,  1437,   322,     0,     0,     0,     0,     0,
   323,     0,     0,   324,     0,     0,     0,     0,     0,     0,
     0,   325,   326,   327,     0,     0,     0,     0,     0,   328,
   329,   330,     0,     0,     0,   331,   301,     8,     9,    10,
   167,    12,   302,   303,   304,     0,   305,    14,     0,     0,
     0,     0,   332,     0,     0,     0,     0,     0,     0,     0,
     0,    16,   306,    17,    18,    19,     0,   307,   308,   309,
    20,     0,   310,   311,   312,    21,   313,   314,     0,    23,
     0,     0,     0,   315,   316,   317,   318,   319,    26,     0,
    27,   321,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   323,     0,     0,   324,     0,     0,     0,     0,     0,
     0,     0,   325,   326,   327,     0,     0,     0,     0,     0,
   328,   329,   330,     0,     0,     0,   331,     7,     8,     9,
    10,     0,    12,   482,   303,   304,     0,   305,    14,     0,
     0,     0,     0,   332,     0,     0,     0,     0,     0,     0,
     0,     0,    16,   306,    17,    18,    19,     0,   307,   308,
   309,    20,     0,   310,   311,   312,    21,   313,   314,     0,
    23,     0,     0,     0,   315,   316,   317,   318,   319,    26,
     0,    27,    28,     0,     0,     0,   322,     0,     0,     0,
     0,     0,   323,     0,     0,  1526,     0,     0,     0,     0,
     0,     0,     0,   325,   326,  1527,     0,     0,     0,     0,
     0,   328,   329,   330,     0,     0,     0,  1528,   301,     8,
     9,    10,     0,    12,   302,   303,   304,     0,   305,    14,
     0,     0,     0,     0,   332,     0,     0,     0,     0,     0,
     0,     0,     0,    16,   306,    17,     0,    19,     0,   307,
   308,   309,    20,     0,   310,   311,   312,    21,   313,   314,
     0,    23,     0,     0,     0,   315,   316,   317,   318,   319,
    26,     0,   320,   321,     0,     0,     0,   322,     0,     0,
     0,     0,     0,   323,     0,     0,   324,     0,     0,     0,
     0,     0,     0,     0,   325,   326,   327,     0,     0,     0,
     0,     0,   328,   329,   330,     0,     0,     0,   331,   301,
     8,     9,    10,     0,    12,   302,   303,   304,     0,   305,
    14,     0,     0,     0,     0,   332,     0,     0,     0,     0,
     0,     0,     0,     0,    16,   306,    17,     0,    19,     0,
   307,   308,   309,    20,     0,   310,   311,   312,    21,   313,
   314,     0,    23,     0,     0,     0,   315,   316,   317,   318,
   319,    26,     0,    27,   321,     0,     0,     0,   322,     0,
     0,     0,     0,     0,   323,     0,     0,   324,     0,     0,
     0,     0,     0,     0,     0,   325,   326,   327,     0,     0,
     0,     0,     0,   328,   329,   330,     0,     0,     0,   331,
   301,     8,     9,    10,     0,    12,   482,   303,   304,     0,
   305,    14,     0,     0,     0,     0,   332,     0,     0,     0,
     0,     0,     0,     0,     0,    16,   306,    17,     0,    19,
     0,   307,   308,   309,    20,     0,   310,   311,   312,    21,
   313,   314,     0,    23,     0,     0,     0,   315,   316,   317,
   318,   319,    26,     0,    27,   321,     0,     0,     0,   322,
     0,     0,     0,     0,     0,   323,     0,     0,   324,     0,
     0,     0,     0,     0,     0,     0,   325,   326,   327,     0,
     0,     0,     0,     0,   328,   329,   330,     0,     0,     0,
   331,   301,     8,     9,    10,     0,    12,   482,   303,   304,
     0,   305,    14,     0,     0,     0,     0,   332,     0,     0,
     0,     0,     0,     0,     0,     0,    16,   306,    17,     0,
    19,     0,   307,   308,   309,    20,     0,   310,   311,   312,
    21,   313,   314,     0,    23,     0,     0,     0,   315,   316,
   317,   318,   319,    26,     0,    27,   321,   585,     0,     0,
     0,     0,     0,     0,     0,     0,   323,     0,     0,   324,
     0,     0,     0,     0,     0,     0,     0,   325,   326,   327,
     0,     0,     0,     0,     0,   328,   329,   330,     0,     0,
     0,   586,   301,     8,     9,    10,     0,    12,   482,   303,
   304,     0,   305,    14,     0,     0,     0,     0,   332,     0,
     0,     0,     0,     0,     0,     0,     0,    16,   306,    17,
     0,    19,     0,   307,   308,   309,    20,     0,   310,   311,
   312,    21,   313,   314,     0,    23,     0,     0,     0,   315,
   316,   317,   318,   319,    26,     0,    27,   321,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   323,     0,     0,
   324,     0,     0,     0,     0,     0,     0,     0,   325,   326,
   327,     0,     0,     0,     0,     0,   328,   329,   330,     0,
     0,     0,   331,   624,   301,     8,     9,    10,     0,    12,
   482,   303,   304,     0,   305,    14,     0,     0,     0,   332,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    16,
   306,    17,    18,    19,     0,   307,   308,   309,    20,     0,
   310,   311,   312,    21,   313,   314,     0,    23,     0,     0,
     0,   315,   316,   317,   318,   319,    26,     0,    27,   321,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   323,
     0,     0,   571,     0,     0,     0,     0,     0,     0,     0,
   325,   326,   572,     0,     0,     0,     0,     0,   328,   329,
   330,     0,     0,     0,   573,  1187,     8,     9,    10,     0,
    12,   482,   303,   304,     0,   305,    14,     0,     0,     0,
     0,   332,     0,     0,     0,     0,     0,     0,     0,     0,
    16,   306,    17,     0,    19,     0,   307,   308,   309,    20,
     0,   310,   311,   312,    21,   313,   314,     0,    23,     0,
     0,     0,   315,   316,   317,   318,   319,    26,     0,    27,
   321,     0,     0,     0,   322,     0,     0,     0,     0,     0,
   323,     0,     0,   324,     0,     0,     0,     0,     0,     0,
     0,   325,   326,   327,     0,     0,     0,     0,     0,   328,
   329,   330,     0,     0,     0,   331,     7,     8,     9,    10,
     0,    12,   302,   303,   304,     0,   305,    14,     0,     0,
     0,     0,   332,     0,     0,     0,     0,     0,     0,     0,
     0,    16,   306,    17,    18,    19,     0,   307,   308,   309,
    20,     0,   310,   311,   312,    21,   313,   314,     0,    23,
     0,     0,     0,   315,   316,   317,   318,   319,    26,     0,
    27,    28,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   323,     0,     0,  1526,     0,     0,     0,     0,     0,
     0,     0,   325,   326,  1527,     0,     0,     0,     0,     0,
   328,   329,   330,     0,     0,     0,  1528,   301,     8,     9,
    10,     0,    12,   482,   303,   304,     0,   305,    14,     0,
     0,     0,     0,   332,     0,     0,     0,     0,     0,     0,
     0,     0,    16,   306,    17,     0,    19,     0,   307,   308,
   309,    20,     0,   310,   311,   312,    21,   313,   314,     0,
    23,     0,     0,     0,   315,   316,   317,   318,   319,    26,
     0,    27,   321,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   323,     0,     0,   324,     0,     0,     0,     0,
     0,     0,     0,   325,   326,   327,     0,     0,     0,     0,
     0,   328,   329,   330,     0,     0,     0,   553,   301,     8,
     9,    10,     0,    12,   482,   303,   304,     0,   305,    14,
     0,     0,     0,     0,   332,     0,     0,     0,     0,     0,
     0,     0,     0,    16,   306,    17,     0,    19,     0,   307,
   308,   309,    20,     0,   310,   311,   312,    21,   313,   314,
     0,    23,     0,     0,     0,   315,   316,   317,   318,   319,
    26,     0,    27,   321,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   323,     0,     0,   324,     0,     0,     0,
     0,     0,     0,     0,   325,   326,   327,     0,     0,     0,
     0,     0,   328,   329,   330,     0,     0,     0,   555,   301,
     8,     9,    10,     0,    12,   482,   303,   304,     0,   305,
    14,     0,     0,     0,     0,   332,     0,     0,     0,     0,
     0,     0,     0,     0,    16,   306,    17,     0,    19,     0,
   307,   308,   309,    20,     0,   310,   311,   312,    21,   313,
   314,     0,    23,     0,     0,     0,   315,   316,   317,   318,
   319,    26,     0,    27,   321,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   323,     0,     0,   324,     7,     8,
     9,    10,   206,    12,   207,   325,   326,   327,     0,    14,
     0,     0,     0,   328,   329,   330,     0,     0,     0,   331,
     0,     0,     0,    16,     0,    17,    18,     0,     0,     0,
     0,     0,    20,     0,     0,     0,   332,    21,     0,     0,
     0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
    26,     0,    27,    28,     8,     9,     0,   167,    12,    13,
     0,     0,  1577,     0,    14,     0,    30,     8,     9,     0,
   206,    12,   207,     0,     0,     0,    31,    14,    16,     0,
    17,    18,     0,     0,    32,     0,     0,    20,    33,     0,
     0,    16,     0,    17,    18,     0,    23,     0,     0,     0,
    20,     0,     0,     0,     0,    26,     0,   130,   131,    23,
     0,     0,     8,     9,     0,     0,    12,    13,    26,     0,
   130,   131,    14,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    16,     0,    17,     0,
     0,     0,     0,     0,     0,    20,     0,     0,     0,     0,
     0,     0,     0,     0,    23,     0,     0,     0,     0,     0,
     0,     0,     0,    26,     0,   130,   131,   588,   589,   590,
   591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
   601,   602,   603,   604,   605,   606,   607,   608,   609,   588,
   589,   590,   591,   592,   593,   594,   595,   596,   597,   598,
   599,   600,   601,   602,   603,   604,   605,   606,   607,   608,
   609,  1118,     0,     0,  1282,   588,   589,   590,   591,   592,
   593,   594,   595,   596,   597,   598,   599,   600,   601,   602,
   603,   604,   605,   606,   607,   608,   609,  1591,   588,   589,
   590,   591,   592,   593,   594,   595,   596,   597,   598,   599,
   600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
   588,   589,   590,   591,   592,   593,   594,   595,   596,   597,
   598,   599,     0,   601,   602,   603,   604,   605,   606,   607,
   608,   609,   593,   594,   595,   596,   597,   598,   599,   600,
   601,   602,   603,   604,   605,   606,   607,   608,   609,   595,
   596,   597,   598,   599,   600,   601,   602,   603,   604,   605,
   606,   607,   608,   609,   596,   597,   598,   599,   600,   601,
   602,   603,   604,   605,   606,   607,   608,   609
};

static const short yycheck[] = {     4,
   149,   150,   126,   174,   161,    23,   456,   351,   176,    80,
     4,    42,   731,     4,   175,     4,   403,   357,   210,   252,
   403,   357,    42,   358,   359,   305,   306,   524,    59,    57,
    35,   583,   244,   403,   307,   308,   134,    42,    42,   662,
     4,    35,   374,    80,    35,   907,    35,   441,    42,   156,
   133,   324,    57,    42,   327,    84,   248,   330,   707,   339,
   333,  1419,     4,   124,   337,  1341,    90,    72,    92,  1507,
    14,    35,   345,   144,   409,   410,   218,   219,    42,    84,
  1508,   210,   190,    88,    11,    90,    42,    92,    30,    31,
   219,   714,   479,    35,   133,   134,   479,    42,    11,    11,
    42,    33,   107,   108,    12,   297,     4,   713,   136,   815,
  1509,   817,     1,   137,     0,  1553,    63,    75,     1,   825,
     1,   350,   351,   352,   357,    61,     4,   577,    38,   510,
   474,   136,   137,   204,   139,  1531,    63,    35,   169,    83,
     9,   485,    84,  1351,    42,   165,   527,     0,   176,   169,
  1358,    75,    60,    46,    59,    63,  1552,    35,    63,   351,
   165,   108,   106,   831,   169,   169,     4,     5,    93,   837,
    59,   176,   136,   109,    63,   169,    59,   109,    59,   210,
   169,   108,    63,    76,    25,   190,    27,   218,   219,  1588,
    55,    48,    60,    62,   136,   108,   108,    49,    31,   109,
   108,   165,     3,     4,     5,   169,    95,   149,   150,  1637,
    12,  1250,  1251,   169,    95,  1653,  1612,   248,    59,    57,
    58,    27,    63,   165,   169,    31,   263,   169,  1267,    48,
    59,    93,  1508,   730,    39,  1593,    93,    94,   136,     4,
    62,   109,   471,    60,   473,   474,   475,    61,   190,    12,
    55,   108,   194,   195,    95,    61,    57,    58,    60,    65,
     1,    63,     3,     4,     5,   348,   297,   165,    97,    93,
    35,   169,    60,    61,    93,    94,  1138,    42,  1556,   947,
    81,     1,   732,     3,     4,     5,     6,    61,     8,   108,
    60,   108,   449,   298,    60,   109,   394,    60,   571,   572,
    63,    48,    65,   109,  1512,   249,    76,    48,   141,   348,
   175,    60,    55,   146,    55,   344,    57,    58,   140,    84,
   351,   214,    42,   659,    75,   386,   331,  1605,   663,    49,
   700,   725,   726,   361,   156,    55,   360,    57,    58,   344,
   989,  1380,   108,     7,   493,   494,    93,   352,     4,    75,
  1389,  1390,    93,  1392,  1562,   360,   361,   963,   690,   108,
   966,   108,   195,    48,   506,   507,    76,   461,    78,    89,
    48,   136,   514,    63,    38,    55,   407,    48,   507,    35,
     3,     4,     5,    63,   526,    75,    25,    65,    27,   496,
    93,   213,   998,   999,  1062,    25,   629,   361,   403,   221,
   165,   406,   344,   545,   169,  1613,  1074,   107,    93,    94,
    61,    12,   443,   357,   403,    93,   238,     4,     3,   361,
    59,     6,    93,   443,    63,   190,    27,   260,  1290,    59,
    31,  1054,   175,    63,    57,    58,    59,   108,   443,   443,
  1108,   993,  1110,   474,    60,    61,    31,    48,    35,     8,
     9,    55,     4,     5,    61,    14,    95,    42,   109,    60,
    61,   403,    63,   361,    65,    95,    48,   472,    60,    25,
   475,    75,    57,    58,   479,   506,   507,   706,    37,   443,
   223,    48,    61,   514,    55,    48,    71,    46,   525,    48,
     4,     5,    93,    94,   518,   526,    81,   525,    65,  1538,
  1539,   443,   109,    55,    89,    57,    58,   108,    93,    48,
    31,    93,   847,   518,   545,    63,   108,    48,    55,    71,
   525,     3,     4,     5,    59,    48,    93,   551,   500,    81,
    93,   525,    48,    75,    93,    49,   508,   479,    75,    48,
   405,    59,    94,    57,    58,   443,   551,    65,   553,    55,
   555,   493,   494,   724,    93,   560,   561,   562,   563,   564,
  1266,   525,    93,  1060,   182,    48,    59,    81,   573,  1019,
    93,    94,    76,  1179,  1180,    57,    58,    93,   583,   344,
    93,   586,    55,   525,    93,   108,    48,   420,   800,   801,
   423,    48,   621,   691,   806,     1,   361,     3,     4,     5,
   698,    55,   435,   990,    60,    61,   471,   990,   473,   474,
    93,    94,    60,     4,     5,   620,   621,   957,     9,    55,
   990,   957,    25,   516,    27,   108,   855,   525,    76,   451,
    78,    93,    94,    55,   639,   666,    93,    94,   403,    75,
    31,   646,    48,   108,    48,   918,   108,   108,   983,    55,
   792,    57,    58,    59,    60,   488,    59,    48,   491,   698,
    63,   108,   405,   855,    55,   487,    57,    58,   108,   693,
    11,    48,   505,   953,   496,   706,   949,   950,   443,   621,
    71,   699,   753,     4,     5,   809,   109,    93,   693,    93,
    81,   513,    95,    60,    61,   637,   638,   639,  1144,  1145,
   929,  1147,    93,    94,   646,  1202,   650,   936,     7,     8,
     9,    25,   730,    27,   479,    14,    93,     3,     4,     5,
     6,     4,     5,   831,   957,    48,   955,    97,   471,   837,
   473,   474,    31,    61,    14,    55,    57,    58,    37,     4,
     5,    45,    22,   748,   487,    59,  1243,    46,    93,    63,
   755,    55,     3,   496,    58,    75,    42,   500,    61,    55,
   525,   792,    61,  1036,  1037,   508,    49,  1102,  1103,  1104,
    93,    57,    58,    75,    57,    58,    60,    61,   815,    75,
   817,    95,    60,    61,    49,    65,   823,   815,   825,   817,
    33,    63,    57,    58,   822,   823,  1025,   825,    81,  1143,
   665,    94,  1031,    89,   746,   747,   748,    48,   832,   833,
   815,   835,   817,   755,   111,   909,    81,    48,   823,    48,
   825,   815,    48,   817,   855,    48,   831,   832,   833,    55,
   835,   825,   837,    48,    65,  1006,   778,   779,    55,   947,
    55,   706,    94,    63,   124,  1057,  1058,  1059,   955,    75,
    75,   815,    93,   817,    48,    75,   621,    63,    75,     4,
    75,   825,    93,    94,    93,    94,    48,    93,   148,    75,
    93,    48,    63,   815,   639,   817,    60,  1150,    93,  1028,
  1029,   646,    93,   825,    75,    93,    48,  1036,  1037,   831,
    35,     7,     8,     9,    93,   837,    11,    42,    14,    93,
  1619,   906,     4,     5,    75,   910,   149,   150,   151,    75,
    55,    93,    57,    63,   747,    31,    93,   815,    75,   817,
   108,    37,   665,    60,  1031,   818,   819,   825,   107,   108,
    46,    93,    84,    85,    27,   828,   941,    75,    31,     4,
     5,  1170,   947,   776,   777,    61,   951,    49,    27,  1043,
  1044,   784,    31,   196,  1062,    57,    58,   822,   108,   239,
   240,   108,  1033,   706,   108,  1300,  1074,    60,    61,     4,
     5,    55,   252,   108,     3,     4,     5,    60,    61,    81,
  1430,    60,    61,   748,    49,   990,    65,   992,   993,  1218,
   755,   136,    57,    58,    75,   140,  1446,     7,     8,     9,
  1108,   990,  1110,    75,    14,   947,  1350,   949,   950,   951,
    60,    61,   191,   957,    49,  1086,    81,   844,   845,   846,
   165,    31,    57,    58,   169,  1030,    55,    37,    57,    58,
   175,   176,   108,  1038,  1128,  1129,    46,  1065,     4,     5,
   109,  1046,   109,   323,    48,   108,    81,   108,   990,  1086,
   815,    55,   817,   108,    55,   111,    55,  1062,  1095,    65,
   825,   108,    63,  1170,    63,    65,   831,  1095,  1341,  1074,
     9,    75,   837,    12,    75,    27,    75,    75,   223,   822,
    75,  1531,    55,    49,   364,    75,  1028,  1029,  1030,    93,
  1095,    57,    58,   373,  1036,  1037,  1038,     4,     5,    60,
    61,  1095,  1552,  1108,   111,  1110,   386,   929,   111,    48,
    59,  1218,   108,  1118,   936,    60,    61,     3,     4,     5,
  1062,    60,  1216,    62,    63,    60,    65,   108,  1152,  1579,
   108,  1095,  1074,   955,   108,    55,    55,    76,     8,    78,
    75,    76,    93,    78,    63,    48,  1240,  1152,    55,    65,
    57,    58,   331,  1095,    93,    94,    75,    93,    60,  1546,
     4,     5,  1612,  1546,    71,     9,  1108,   109,  1110,   108,
  1175,    57,    58,    55,    81,    33,   109,   795,    61,   108,
    37,  1349,   947,  1633,  1202,  1078,   951,  1348,  1282,  1350,
    55,  1084,  1085,  1026,  1027,  1088,  1089,  1095,    63,  1092,
  1065,    65,  1035,  1025,    65,    65,  1550,   108,  1213,  1031,
    75,    55,    61,    57,    58,    55,   361,    63,  1223,  1213,
   108,   111,  1213,    63,  1261,   990,    65,    71,    65,  1266,
    60,  1173,  1174,  1175,    76,    75,   108,    81,  1266,   108,
  1469,   108,   522,    76,    76,     3,     4,     5,     6,   108,
   493,   494,   495,  1526,  1527,   108,     3,     4,     5,    76,
   405,  1266,     3,     4,     5,  1030,    76,   108,    63,    63,
    55,  1213,  1266,  1038,   108,  1369,    60,   108,    63,  1221,
  1222,  1223,  1025,    63,    42,     3,     4,     5,  1031,     7,
    75,   149,   150,   151,  1236,  1237,   108,  1062,   443,    57,
    58,   108,  1266,  1532,   108,   585,   111,   109,   108,  1074,
    57,    58,  1406,    60,    55,  1213,    57,    58,    59,  1350,
    38,    94,  1065,   502,  1266,   111,   471,   472,   473,   474,
  1095,     4,     5,    89,   479,    75,  1341,    55,   196,    57,
    58,    48,   487,  1108,  1349,  1110,  1351,  1341,  1170,   629,
   111,     4,     5,  1358,   108,   500,     9,  1351,  1550,   108,
  1351,  1366,   108,   508,  1358,   108,  1523,  1358,  1266,    33,
   108,    61,   109,   108,   553,    48,   555,  1526,  1527,   109,
   525,   560,    55,    60,    57,    58,  1219,  1220,    81,    82,
    83,    84,    85,  1226,   573,   108,  1218,    65,    71,  1341,
    60,    60,    55,   108,    57,    58,    63,   586,    81,  1351,
  1175,   590,   108,     3,     4,     5,  1358,  1239,    71,   699,
    93,    94,    93,     3,     4,     5,    93,   707,    81,  1600,
    93,    93,   111,   109,   108,    30,    31,     8,    33,   618,
    33,    94,   108,  1341,    65,   624,   111,   108,  1213,  1067,
  1068,    55,   108,  1351,     3,     4,     5,   737,  1223,    49,
  1358,   640,    57,  1468,    59,   108,   108,    57,    58,    49,
    65,   108,   108,   108,   108,  1218,  1094,    57,    58,   108,
   108,  1099,   108,  1348,   108,  1350,   150,   151,     3,     4,
     5,     6,   111,    63,  1387,  1388,  1239,  1502,     3,     4,
     5,  1266,  1507,  1508,  1509,   748,    55,  1512,    57,    58,
    48,   108,   755,  1507,  1508,  1258,  1507,   108,  1512,  1550,
   665,  1512,   108,  1528,  1466,  1467,  1468,    42,    96,    63,
    63,    61,   196,    61,    49,     9,    61,    16,   111,   108,
    93,  1546,    57,    58,     4,     5,   141,   108,  1553,  1643,
   790,   146,    57,    58,   149,   150,   151,  1562,   108,  1553,
  1502,   706,  1553,  1456,   108,  1507,  1508,  1509,  1562,   108,
  1512,  1562,    93,    65,    89,   190,  1341,     3,     4,     5,
    61,   176,    55,  1588,  1526,  1527,  1351,   182,     8,     9,
   830,    61,    80,  1358,    14,    55,   836,    57,    58,   194,
   195,   196,    93,    93,  1546,  1348,    17,  1350,  1613,  1507,
  1508,  1553,    61,    55,  1512,   210,   104,    37,    61,  1613,
  1562,   108,  1613,   218,   219,   108,    46,     3,     4,     5,
     6,    57,    58,   102,    11,   493,   494,   495,  1256,  1257,
   107,  1259,  1260,   108,  1262,   133,  1588,  1469,  1653,   108,
    65,    61,     3,     4,     5,  1553,   144,    61,    61,  1653,
    93,    60,  1653,   108,  1562,   260,    42,   331,    61,   108,
   815,  1613,   817,     3,     4,     5,   108,   822,   823,    55,
   825,    57,    58,    11,    11,    61,  1551,    63,  1581,    61,
    61,     3,     4,     5,     0,    71,   976,     0,     3,     4,
     5,     0,   942,  1468,   944,    81,    57,    58,   170,   989,
  1532,  1653,     2,    89,    35,  1613,   204,    93,    79,    80,
    81,    82,    83,    84,    85,    55,  1469,    57,    58,     4,
     5,  1444,   691,     8,     9,   914,   331,  1502,   169,    14,
   990,   443,  1507,  1508,  1509,    57,    58,  1512,   165,     4,
     5,   239,    57,    58,     9,  1653,  1599,   823,  1202,  1377,
  1378,    94,    37,    60,   239,   139,   430,   431,    65,   948,
  1429,    46,   951,    48,  1653,   263,    31,   300,    75,    76,
    55,  1546,    57,    58,   976,  1028,  1029,  1030,  1553,  1532,
   737,     4,     5,  1036,  1037,  1038,    71,  1562,   672,   243,
    55,  1243,    57,    58,  1060,  1095,    81,   823,  1551,   969,
  1263,   406,   407,     7,     8,     9,    71,   201,    93,    94,
    14,   348,   674,  1588,   621,   420,    81,  1351,   423,   124,
   494,   495,    45,  1214,   429,   430,   431,    31,    93,  1633,
   435,  1619,    55,    37,    57,    58,  1567,   462,  1613,  1129,
  1629,  1631,    46,   764,  1366,    -1,   190,    -1,    -1,  1038,
    -1,  1479,  1480,  1481,    -1,    -1,    -1,  1107,   356,  1109,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   472,    -1,   474,
  1025,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1653,   553,
   748,   555,    -1,   488,    -1,    -1,   491,   755,   493,   494,
   495,     3,     4,     5,   499,     7,     8,     9,   572,   573,
   505,   506,   507,    -1,    -1,   510,    -1,  1535,  1536,   514,
  1065,    -1,   586,    -1,    -1,   413,  1166,    -1,    -1,    31,
  1210,    -1,   527,    -1,    -1,    37,  1216,   552,    -1,    -1,
    -1,     4,     5,    -1,    -1,    -1,     3,     4,     5,     6,
  1095,    -1,    -1,    -1,    -1,    57,    58,    -1,   553,    -1,
   555,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,  1148,
    -1,     3,     4,     5,     6,    -1,   571,   572,   573,    -1,
    -1,    -1,   646,   190,    -1,    42,  1604,    -1,    -1,    -1,
    -1,   586,    55,    -1,    57,    58,   611,    -1,    55,    31,
    57,    58,   617,    -1,   619,   620,    63,  1247,    71,    -1,
    42,    -1,  1252,    -1,    71,    -1,    48,    88,    81,    90,
    -1,    92,    -1,    55,    81,    57,    58,    -1,    -1,    -1,
    93,   646,    89,    -1,   522,    -1,    93,    -1,   653,    71,
    -1,    -1,   637,   638,   639,    -1,    -1,    -1,    -1,    81,
    48,   646,    -1,     4,     5,  1335,  1336,    89,     9,    -1,
   548,    93,    94,    -1,  1304,    -1,   137,    -1,   139,   403,
    -1,   666,    -1,     3,     4,     5,    -1,     7,     8,     9,
    31,    -1,    -1,    -1,   748,    -1,    -1,    -1,    -1,    87,
    88,   755,    -1,    91,    92,    93,    94,    48,    -1,  1278,
  1279,  1280,  1281,    -1,    55,   769,    57,    58,    -1,  1288,
    -1,   706,   707,  1258,    -1,   779,   780,    -1,  1263,   190,
    71,  1266,    -1,    -1,    -1,   194,   195,    57,    58,    -1,
    81,    77,    78,    79,    80,    81,    82,    83,    84,    85,
   755,  1421,    93,    94,    -1,   479,   634,    -1,    -1,    -1,
    -1,   746,   747,   748,   769,  1334,  1396,  1397,    -1,    -1,
   755,   649,    -1,  1443,  1444,    -1,    -1,    -1,    -1,    -1,
  1028,  1029,  1030,  1413,   769,    -1,    -1,    -1,  1036,  1037,
  1038,   776,   777,   778,   779,   780,    -1,    -1,    -1,   784,
     3,     4,     5,    -1,     7,     8,     9,   792,    -1,    -1,
   795,    -1,    -1,  1348,  1349,  1350,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,  1457,    -1,    -1,    -1,    31,    -1,
     3,     4,     5,     6,    37,    -1,    -1,    -1,   823,    -1,
    -1,    -1,  1472,  1473,    -1,    -1,    -1,    -1,    -1,    -1,
  1520,    -1,    55,    -1,    57,    58,    59,    -1,  1488,  1489,
    -1,   322,    -1,    -1,    -1,   462,    -1,    -1,    -1,    42,
  1439,     3,     4,     5,     6,   753,    -1,    -1,    -1,    -1,
    -1,    -1,    55,    -1,    57,    58,    -1,    -1,   107,   108,
    63,    -1,    -1,  1526,  1527,  1528,   950,   951,    71,   360,
   103,   104,   105,   781,    -1,   910,    -1,    -1,    81,    -1,
    42,    -1,    -1,    -1,    -1,   639,    89,    49,    -1,   924,
    93,   926,   646,   928,    -1,    57,    58,    -1,    -1,    -1,
    -1,    -1,    -1,  1502,    -1,     3,     4,     5,     6,  1508,
  1509,     9,    -1,    -1,    -1,   930,    -1,    -1,   933,    81,
    -1,    -1,    -1,    -1,    -1,   552,    -1,    89,    -1,  1528,
   945,    -1,    -1,    31,   949,   950,   951,    -1,    -1,    -1,
    -1,   190,    -1,   978,    42,  1029,  1030,    -1,    -1,    -1,
    48,    -1,    -1,  1037,  1038,    -1,    -1,    55,    -1,    57,
    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   461,   462,    -1,    71,   989,    -1,    -1,    -1,  1013,    -1,
    -1,    -1,    -1,    81,   611,    -1,  1551,    -1,    -1,  1588,
   617,    89,   619,   620,   748,    93,    94,    -1,    -1,   488,
    -1,   755,   491,    -1,   493,   494,    -1,    -1,  1607,    -1,
    -1,  1026,  1027,  1028,  1029,  1030,   505,    -1,    -1,    -1,
  1035,  1036,  1037,  1038,    -1,    -1,   653,   518,    -1,  1628,
    -1,    -1,  1047,  1048,  1049,    -1,    -1,    -1,  1637,    -1,
    -1,     3,     4,     5,     6,    -1,    -1,    -1,   956,    -1,
   958,    -1,  1067,  1068,    -1,    -1,    -1,    -1,    -1,    -1,
   551,   552,    -1,    -1,    -1,    -1,    -1,    -1,   559,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   831,    -1,  1094,
    42,    -1,   331,   837,  1099,    -1,    -1,    49,    -1,    -1,
  1174,  1175,   583,    -1,   585,    57,    58,   588,   589,    -1,
   591,   592,   593,   594,   595,   596,   597,   598,   599,   600,
   601,   602,   603,   604,   605,   606,   607,   608,   609,    81,
   611,    -1,    -1,     4,     5,  1033,   617,    89,   619,   620,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1222,  1223,
    -1,    -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,
    31,    -1,    -1,    -1,   403,   646,    -1,    -1,  1173,  1174,
  1175,    -1,   653,    -1,    -1,    -1,    -1,    48,    -1,  1204,
    -1,  1206,    -1,  1208,    55,    -1,    57,    58,  1086,  1457,
    39,    40,    -1,    42,     4,     5,   677,   678,     8,     9,
    71,    -1,    -1,   947,    14,    -1,    55,   951,    57,    58,
    81,    -1,   693,    -1,  1219,  1220,  1221,  1222,  1223,    -1,
    -1,  1226,    93,    94,    -1,    -1,    -1,    37,    -1,    -1,
    -1,  1236,  1237,  1238,    -1,    -1,    46,    -1,    48,    -1,
   479,     3,     4,     5,     6,    55,   990,    57,    58,    -1,
    -1,  1256,  1257,    -1,  1259,  1260,   737,  1262,  1526,  1527,
  1528,    71,    -1,    -1,    -1,    -1,    -1,   746,   747,    -1,
    -1,    81,    -1,    -1,   755,    -1,    -1,    -1,  1176,    -1,
    42,    -1,    -1,    93,    94,  1310,  1030,    49,   769,    -1,
    -1,    -1,    -1,   910,  1038,    57,    58,   776,   777,   778,
   779,    -1,    -1,    -1,    -1,   784,    -1,   924,    -1,   926,
    -1,   928,    -1,    -1,   553,    -1,   555,    -1,  1062,    81,
    -1,   560,   561,   562,   563,   564,    -1,    89,    -1,    -1,
  1074,    -1,    -1,   814,   573,    -1,    -1,     3,     4,     5,
     6,     7,     8,     9,  1349,  1350,    -1,   586,    14,    -1,
    -1,   832,   833,    -1,   835,    -1,  1361,  1362,    -1,  1364,
    -1,   978,    -1,  1261,  1108,    31,  1110,    -1,    -1,    -1,
    -1,    37,  1377,  1378,    -1,    -1,    42,    -1,    -1,    -1,
    46,   620,    48,  1457,    -1,    -1,    -1,    -1,    -1,    55,
   871,    57,    58,    -1,    -1,    -1,  1013,    -1,    -1,    -1,
   639,    -1,    -1,    -1,    -1,    71,    -1,   646,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    81,    -1,     3,     4,     5,
     6,    -1,    -1,    89,    -1,    -1,    -1,    93,   909,   910,
    -1,  1175,  1457,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   924,    -1,   926,    -1,   928,    -1,    -1,
    -1,    -1,  1457,  1527,  1528,    -1,    42,    -1,    -1,    -1,
    -1,  1466,  1467,  1468,    -1,  1363,    -1,    -1,    -1,    55,
    -1,    57,    58,     4,  1479,  1480,  1481,    63,    -1,  1223,
    -1,    -1,    -1,    14,    -1,    71,   967,    -1,    -1,    -1,
    -1,    -1,    -1,    24,    -1,    81,    -1,   978,    -1,    30,
    31,    -1,    33,    89,    35,    -1,    -1,    93,    -1,   748,
    -1,    42,   993,    -1,    -1,   996,   755,    -1,    -1,    -1,
    -1,  1526,  1527,  1528,    55,    -1,    57,    -1,    -1,    -1,
  1535,  1536,  1013,    -1,    65,    -1,    -1,    -1,    -1,    -1,
    -1,    72,    -1,    -1,    -1,    -1,    -1,  1026,  1027,  1028,
  1029,    -1,    83,    84,    -1,    -1,  1035,  1036,  1037,    -1,
    -1,    -1,  1043,  1044,    -1,    -1,    -1,    -1,  1047,  1048,
  1049,    -1,    -1,     4,     5,   106,    -1,    -1,     9,     4,
     5,    -1,    -1,    -1,     9,    -1,    -1,  1204,    -1,  1206,
    -1,  1208,   831,    -1,    -1,    -1,  1077,    -1,   837,  1604,
    31,    -1,    -1,   134,    -1,   136,    31,    -1,    -1,   140,
   141,    -1,    -1,    -1,   145,   146,    -1,    -1,   149,   150,
   151,    -1,    -1,    48,    55,    -1,    57,    58,    -1,    -1,
    55,    -1,    57,    58,   165,    -1,    -1,    -1,   169,    -1,
    71,    -1,    -1,    -1,   175,   176,    71,  1128,  1129,    -1,
    81,  1132,     3,     4,     5,     6,    81,    -1,    -1,    -1,
    -1,    -1,    93,   194,   195,   196,    -1,   906,    93,    94,
    -1,  1152,    -1,    -1,     1,    -1,     3,     4,     5,     6,
     7,     8,     9,    -1,    -1,    -1,    -1,    14,    -1,    -1,
    -1,    42,   223,  1310,     3,     4,     5,     6,    49,    -1,
    -1,    28,   941,    30,    31,    32,    57,    58,   947,   240,
    37,    38,   951,    -1,    -1,    42,    -1,    -1,   249,    46,
    47,    -1,    49,  1204,  1468,  1206,    -1,  1208,    55,   260,
    57,    58,    -1,    42,    61,  1216,    63,    -1,    89,    -1,
  1219,  1220,  1221,  1222,    71,    -1,    55,  1226,    57,    58,
    -1,   990,    -1,   992,    81,    -1,    -1,  1236,  1237,  1240,
    -1,    -1,    89,    -1,    -1,    -1,    93,   298,   299,    -1,
    -1,    -1,    -1,  1254,  1255,    -1,    -1,    -1,    -1,    -1,
    89,    -1,   109,    -1,    -1,    -1,    -1,     4,     5,    -1,
    82,  1030,     9,    -1,    -1,    -1,    -1,    -1,    -1,  1038,
    -1,  1282,  1546,    -1,    -1,   637,   638,  1046,    -1,    -1,
    -1,    -1,    -1,   344,    31,    -1,    -1,   348,    -1,   350,
   351,   352,    -1,  1062,    -1,    -1,    -1,    -1,    -1,  1310,
   361,    48,    -1,    -1,    -1,  1074,    -1,    -1,    55,    -1,
    57,    58,     3,     4,     5,     6,    -1,    -1,     9,  1330,
    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   394,    81,    -1,    -1,   159,    -1,  1108,
    31,  1110,   403,    -1,   405,   406,    93,    94,    -1,  1118,
    -1,    42,  1361,  1362,    -1,  1364,    -1,    48,  1369,   420,
    -1,    -1,   423,    -1,    55,    -1,    57,    58,    -1,    -1,
   192,    -1,  1383,    -1,   435,    -1,    -1,    -1,    -1,    -1,
    71,    -1,   443,   205,   746,   747,    -1,    -1,    -1,    -1,
    81,    -1,    -1,    -1,    -1,  1406,    -1,    -1,    89,    -1,
    -1,    -1,    93,    94,    -1,    -1,  1175,    -1,    -1,    -1,
   471,   472,   473,   474,   475,    -1,    -1,    -1,   479,    -1,
     3,     4,     5,     6,    -1,    -1,   487,   488,    -1,    -1,
   491,    -1,   493,   494,   495,   496,    -1,    -1,    -1,   500,
    -1,    -1,    -1,    -1,   505,    -1,  1457,   508,    31,    -1,
    -1,    -1,    -1,    -1,  1223,    -1,    -1,  1466,  1467,    42,
    -1,    -1,    -1,    -1,   525,    48,  1477,  1478,    -1,    -1,
    -1,    -1,    55,    -1,    57,    58,    -1,    -1,     1,    -1,
     3,     4,     5,     6,     7,     8,     9,    -1,    71,    -1,
    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,    81,  1510,
   561,   562,   563,   564,    -1,    28,    89,    30,    31,    32,
    93,    94,    -1,    -1,    37,    38,    -1,  1526,  1527,    42,
    -1,    -1,    -1,    46,    47,    -1,    49,    -1,    -1,    -1,
  1541,    -1,    55,    -1,    57,    58,    -1,    -1,    61,    -1,
    63,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,
    -1,    -1,    -1,     3,     4,     5,     6,    -1,    81,     9,
   621,    -1,   623,    -1,    -1,    -1,    89,    -1,   930,    -1,
    93,   933,    -1,    -1,   635,    -1,   637,   638,   639,    -1,
    -1,    31,    -1,   945,    -1,   646,   109,   949,   950,   650,
    -1,    -1,    42,    -1,    -1,    -1,    -1,  1366,    48,    -1,
    -1,    -1,    -1,    -1,   665,    55,    -1,    57,    58,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    71,    -1,     3,     4,     5,     6,    -1,    -1,    -1,
   691,    81,  1643,    -1,    -1,    -1,    -1,   698,    -1,    89,
    -1,    -1,    -1,    93,    94,   706,   707,    -1,    -1,     3,
     4,     5,     6,     3,     4,     5,     6,    -1,    -1,    -1,
    -1,    -1,    42,    -1,  1026,  1027,  1028,  1029,    -1,    49,
    -1,    -1,    -1,  1035,  1036,  1037,   498,    57,    58,    -1,
    -1,   503,    -1,    -1,    -1,   746,   747,   748,    42,    -1,
    -1,    -1,    42,    -1,   755,    49,    -1,    -1,    48,  1468,
    -1,    81,    -1,    57,    58,    55,   528,    57,    58,    89,
    -1,    -1,   534,    -1,    -1,   776,   777,   778,   779,   780,
    -1,    71,    -1,   784,   546,   547,    -1,   549,     4,     5,
    -1,    81,    -1,     9,    -1,    89,    -1,    -1,    -1,    89,
    -1,    -1,    -1,    93,    94,    -1,    -1,     4,     5,    -1,
    -1,   812,     9,    -1,   815,    31,   817,    -1,    -1,  1528,
    -1,   822,   823,    -1,   825,    -1,    -1,    -1,    -1,    -1,
   831,    -1,    48,    -1,    31,    -1,   837,  1546,    -1,    55,
    -1,    57,    58,   844,   845,   846,    -1,    -1,    -1,    -1,
    -1,    48,    -1,    -1,   855,    71,    -1,    -1,    55,    -1,
    57,    58,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,
    -1,  1173,  1174,    -1,    71,    -1,    -1,    93,    94,    -1,
   642,   643,    -1,    -1,    81,   647,    -1,     3,     4,     5,
     6,     7,     8,     9,    -1,    -1,    93,    94,    14,    -1,
    -1,    -1,    -1,    -1,    -1,   906,     3,     4,     5,     6,
    -1,    -1,    28,    -1,    30,    31,    32,  1219,  1220,  1221,
  1222,    37,    -1,    -1,  1226,    -1,    42,    -1,   929,   930,
    46,    -1,   933,    49,    31,   936,    -1,    -1,    -1,    55,
   941,    57,    58,    -1,   945,    42,   947,    -1,   949,   950,
   951,    48,    -1,    -1,   955,    71,   957,    -1,    55,    -1,
    57,    58,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    89,    71,    -1,    -1,    93,    -1,    -1,
    -1,    97,    -1,    -1,    81,    -1,    -1,    -1,   750,   990,
    -1,   992,    89,    -1,    60,    -1,    93,    94,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
   782,    -1,    -1,    -1,  1025,  1026,  1027,  1028,  1029,  1030,
  1031,     4,     5,    -1,  1035,  1036,  1037,  1038,     3,     4,
     5,     6,     7,     8,     9,  1046,  1047,  1048,  1049,    14,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,  1361,
  1362,  1062,  1364,    28,  1065,    30,    31,    -1,    -1,    -1,
    -1,    -1,    37,  1074,    -1,    48,   838,    42,   840,    -1,
    -1,    46,    55,    48,    57,    58,  1087,    -1,    -1,    -1,
    55,    -1,    57,    58,  1095,    -1,    -1,    -1,    71,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    71,  1108,    81,  1110,
    -1,    -1,    -1,    -1,    -1,    -1,    81,  1118,    -1,    -1,
    93,    94,    -1,    -1,    89,    -1,    -1,    -1,    93,    94,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
     5,     6,    -1,  1144,  1145,    -1,  1147,    -1,    -1,    -1,
   912,   913,    -1,   915,    -1,     3,     4,     5,     6,     7,
     8,     9,    -1,    -1,  1466,  1467,    14,    -1,    -1,  1170,
    -1,    -1,  1173,  1174,  1175,    -1,    -1,    42,    -1,    -1,
    -1,    -1,    -1,    31,   946,    -1,    -1,    -1,    -1,    37,
    55,    -1,    57,    58,    42,    -1,    61,    -1,    46,    -1,
    48,    -1,    -1,    -1,    -1,    -1,    71,    55,    -1,    57,
    58,    -1,    -1,    -1,    -1,    -1,    81,  1218,  1219,  1220,
  1221,  1222,  1223,    71,    89,  1226,    -1,    -1,    93,    -1,
    -1,    -1,    -1,    81,    -1,  1236,  1237,  1238,  1239,    -1,
     4,    89,    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,
    14,    -1,    -1,    -1,    -1,    -1,    -1,  1258,    -1,    23,
    24,    -1,  1263,    -1,    -1,  1266,    30,    31,    -1,    33,
    -1,    35,  1034,    -1,    -1,    -1,    -1,    -1,    42,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    55,    -1,    57,    -1,    -1,    -1,    -1,    -1,  1061,
    -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,
     1,  1073,     3,     4,     5,     6,     7,     8,     9,    -1,
    84,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,     3,
     4,     5,     6,    -1,    -1,     9,    27,    28,    -1,    30,
    31,    32,    -1,    -1,    -1,    -1,    37,  1348,  1349,  1350,
    -1,    42,    -1,    -1,    45,    46,    47,    31,    49,    -1,
  1361,  1362,    -1,  1364,    55,  1366,    57,    58,    42,    -1,
    61,    -1,   136,    -1,    48,    -1,   140,   141,    -1,    -1,
    71,    55,   146,    57,    58,   149,   150,   151,    -1,    -1,
    81,    -1,    -1,    -1,    -1,    -1,    -1,    71,    89,  1161,
    -1,   165,    93,    -1,    -1,   169,    97,    81,    -1,    -1,
    -1,   175,   176,    -1,    -1,    89,    -1,    -1,    -1,    93,
    94,    -1,     3,     4,     5,     6,    -1,    -1,     9,    -1,
   194,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,     3,     4,     5,     6,    -1,    -1,    -1,
    31,    -1,    -1,    -1,    -1,    -1,  1457,    -1,    -1,   223,
    -1,    42,  1224,    -1,    -1,  1466,  1467,  1468,  1469,    -1,
    -1,    -1,    -1,    -1,    55,    -1,    57,    58,    -1,    -1,
    -1,    -1,    42,    -1,    -1,    -1,    -1,    -1,    -1,    49,
    71,    -1,    -1,    -1,    -1,    -1,   260,    57,    58,    -1,
    81,    -1,    -1,    -1,    -1,    -1,  1268,    -1,    89,    -1,
  1272,     1,    93,     3,     4,     5,     6,     7,     8,     9,
    -1,    81,    -1,    -1,    14,  1526,  1527,  1528,    -1,    89,
    -1,  1532,    -1,    -1,   298,   299,    -1,    -1,    28,    -1,
    30,    31,    32,    -1,  1306,  1546,    -1,    37,    38,    -1,
  1551,    -1,    42,    -1,    -1,    -1,    46,    47,    -1,    49,
    -1,    -1,    -1,    -1,    -1,    55,    -1,    57,    58,    -1,
    -1,    61,    -1,    63,    -1,    -1,    -1,    -1,    -1,    -1,
   344,    71,    -1,    -1,   348,    -1,   350,   351,   352,    -1,
    -1,    81,    -1,   357,    -1,    -1,    -1,   361,    -1,    89,
    -1,    -1,    -1,    93,    -1,    -1,     3,     4,     5,     6,
  1372,    -1,     9,    -1,  1376,    -1,    -1,    -1,    -1,   109,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     4,     5,    -1,
   394,    -1,     9,    -1,    31,    -1,  1398,  1399,    -1,   403,
    -1,   405,   406,    -1,    -1,    42,    -1,    -1,    -1,    -1,
    -1,    48,    -1,    -1,    31,    -1,   420,    -1,    55,   423,
    57,    58,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
     6,   435,    -1,     9,    71,    -1,    -1,    -1,    55,   443,
    57,    58,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    89,    -1,    71,    31,    93,    94,    -1,    -1,
    -1,    -1,    -1,    -1,    81,    -1,    42,   471,   472,   473,
   474,   475,    48,    -1,    -1,   479,    93,    -1,    -1,    55,
    -1,    57,    58,   487,   488,    -1,    -1,   491,    -1,   493,
   494,   495,   496,    -1,    -1,    71,   500,    -1,    -1,    -1,
    -1,   505,    -1,    -1,   508,    81,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,    94,    -1,
   524,   525,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   561,   562,   563,
   564,    28,    29,    30,    31,    32,    -1,    34,    35,    36,
    37,    -1,    39,    40,    41,    42,    43,    44,    -1,    46,
    -1,    48,    -1,    50,    51,    52,    53,    54,    55,    -1,
    57,    58,    59,    -1,    -1,    62,    -1,    -1,    -1,    -1,
    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    -1,    -1,   621,    -1,   623,
    87,    88,    89,    -1,    -1,    -1,    93,    94,    -1,    -1,
    -1,    -1,    -1,   637,   638,   639,    -1,    -1,    -1,    -1,
    -1,    -1,   646,   110,     1,    -1,     3,     4,     5,     6,
     7,     8,     9,    -1,    -1,   659,    -1,    14,    -1,    -1,
    -1,   665,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    28,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
    37,    38,    -1,    -1,    -1,    42,    -1,   691,    -1,    46,
    47,    -1,    49,    -1,    -1,   699,    -1,    -1,    55,    -1,
    57,    58,   706,   707,    61,    -1,    63,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    71,     3,     4,     5,     6,    -1,
    -1,    -1,    -1,    -1,    81,    -1,   730,    -1,    -1,    -1,
    -1,    -1,    89,    -1,    -1,    -1,    93,    -1,    -1,    -1,
    -1,    -1,   746,   747,   748,    -1,    -1,    -1,    -1,    -1,
    -1,   755,   109,    -1,    42,    -1,    -1,    -1,     1,    -1,
     3,     4,     5,     6,     7,     8,     9,    55,    -1,    57,
    58,    14,   776,   777,   778,   779,   780,    -1,    -1,    -1,
   784,    -1,    -1,    71,    -1,    28,    -1,    30,    31,    32,
    -1,    -1,    -1,    81,    37,    -1,    -1,    -1,    -1,    42,
    -1,    89,    -1,    46,    -1,    93,    49,    -1,   812,    -1,
    -1,   815,    55,   817,    57,    58,    -1,    -1,   822,   823,
    -1,   825,    -1,    -1,    -1,    -1,    -1,   831,    71,     3,
     4,     5,     6,   837,    -1,     9,    -1,    -1,    81,    -1,
   844,   845,   846,    -1,    -1,    -1,    89,     4,    -1,    -1,
    93,   855,    -1,    -1,    97,    -1,    -1,    31,    -1,    -1,
    -1,    -1,     3,     4,     5,     6,    -1,    -1,    42,    -1,
    -1,    -1,    -1,    30,    31,    -1,    33,    -1,    35,    -1,
    -1,    55,    -1,    57,    58,    42,    -1,    -1,    -1,    -1,
    31,    -1,    -1,    -1,    -1,    -1,    -1,    71,    55,    -1,
    57,    42,   906,    -1,    -1,    -1,    -1,    81,    -1,    -1,
    -1,    -1,    -1,    -1,    55,    89,    57,    58,    -1,    93,
    -1,    -1,    -1,    80,    -1,   929,   930,    -1,    -1,   933,
    71,    -1,   936,    -1,    -1,    -1,    -1,   941,    -1,    -1,
    81,   945,    -1,   947,    -1,   949,   950,   951,    89,    -1,
    -1,   955,    93,   957,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
    -1,    -1,    -1,    14,    -1,    -1,   133,   134,    -1,   136,
    -1,    -1,    -1,   140,   141,    -1,   990,   144,   992,   146,
    31,    -1,   149,   150,   151,    -1,    37,    -1,    -1,   156,
    -1,    42,    -1,    -1,    -1,    46,    -1,    48,   165,    -1,
    -1,    -1,   169,    -1,    55,    -1,    57,    58,   175,   176,
    -1,  1025,  1026,  1027,  1028,  1029,  1030,  1031,    -1,    -1,
    71,  1035,  1036,  1037,  1038,    -1,    -1,   194,   195,   196,
    81,    -1,  1046,  1047,  1048,  1049,    -1,   204,    89,    -1,
    -1,    -1,    93,    94,    -1,    -1,  1060,    -1,  1062,    -1,
    -1,  1065,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,
  1074,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
     9,    -1,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,
    -1,  1095,    -1,    -1,     3,     4,     5,     6,    -1,    28,
     9,    30,    31,   260,  1108,    -1,  1110,    -1,    37,    -1,
    -1,    -1,    -1,    42,  1118,    -1,    -1,    46,    -1,    -1,
    49,    -1,    31,    -1,    -1,    -1,    55,    -1,    57,    58,
    -1,    -1,    61,    42,     3,     4,     5,     6,    -1,    -1,
  1144,  1145,    71,  1147,    -1,    -1,    55,    -1,    57,    58,
    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    89,    -1,    71,    -1,    93,    -1,  1170,    -1,    -1,  1173,
  1174,  1175,    81,    42,   331,    -1,    -1,    -1,    -1,    -1,
    89,    -1,    -1,    -1,    93,    -1,    55,    -1,    57,    58,
    -1,   348,    61,    -1,    -1,    -1,    -1,    -1,  1202,   356,
    -1,    -1,    71,    -1,   361,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    81,    -1,  1218,  1219,  1220,  1221,  1222,  1223,
    89,    -1,  1226,    -1,    93,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,  1236,  1237,  1238,  1239,    -1,   394,    -1,  1243,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   405,    -1,
    -1,     4,     5,    -1,  1258,     8,     9,    -1,    -1,  1263,
    -1,    14,  1266,   420,    -1,    -1,   423,    -1,    -1,    -1,
    -1,    -1,   429,   430,   431,    28,    -1,    30,   435,    -1,
    -1,    -1,    -1,    -1,    37,    -1,   443,    -1,    -1,    -1,
    -1,    -1,    -1,    46,    -1,    48,    -1,    -1,    -1,    -1,
    -1,    -1,    55,    -1,    57,    58,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   471,   472,   473,   474,    71,    -1,
    -1,    -1,   479,    -1,    -1,    -1,    -1,    -1,    81,    -1,
   487,   488,    -1,  1337,   491,    -1,   493,   494,   495,   496,
    93,    94,    -1,   500,  1348,  1349,  1350,    -1,   505,     4,
     5,   508,    -1,     8,     9,    -1,    -1,  1361,  1362,    14,
  1364,    -1,  1366,    -1,    -1,    -1,     4,     5,   525,     7,
     8,     9,    -1,    28,    12,    30,    14,    -1,    -1,    -1,
    -1,    -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    28,    46,    30,    31,    -1,    -1,   553,    -1,   555,    37,
    55,    -1,    57,    58,    59,    -1,    -1,    -1,    46,    -1,
    48,    -1,    -1,    -1,   571,   572,   573,    55,    -1,    57,
    58,    -1,    -1,     4,    -1,    -1,    -1,    -1,    -1,   586,
    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,    93,     3,
     4,     5,     6,    81,    -1,     9,    -1,    -1,    -1,    30,
    31,    -1,    33,  1457,    35,    93,    94,    -1,    -1,    -1,
    -1,    42,  1466,  1467,  1468,  1469,    -1,    31,    -1,    -1,
    -1,    -1,    -1,    -1,    55,    -1,    57,   634,    42,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   646,
    -1,    55,    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    71,   665,    -1,
    -1,    -1,    -1,    -1,    -1,    33,    -1,    81,    -1,    -1,
    -1,    -1,  1526,  1527,  1528,    89,    -1,    -1,  1532,    93,
    -1,    -1,    -1,    -1,   691,    -1,    -1,    55,    -1,    -1,
    -1,   698,  1546,    -1,    -1,    -1,    -1,  1551,    -1,   706,
    -1,    -1,    -1,    -1,    -1,   136,    -1,    -1,    -1,   140,
   141,    -1,    -1,    -1,    -1,   146,    -1,    -1,   149,   150,
   151,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,   165,    -1,    -1,    -1,   169,   746,
   747,   748,    -1,    -1,   175,   176,   753,    -1,   755,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
     6,    -1,   769,   194,   195,   196,    -1,    -1,    -1,   776,
   777,   778,   779,   780,    -1,    -1,    -1,   784,    -1,    -1,
    -1,   149,   150,   151,    -1,    31,    -1,    -1,    -1,    -1,
    -1,    -1,   223,    -1,    -1,    -1,    42,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   175,   815,    55,
   817,    57,    58,    -1,    -1,   822,   823,    -1,   825,    -1,
    -1,    -1,    -1,    -1,    -1,    71,   194,   195,   196,   260,
    -1,    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   223,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    -1,    13,
    14,    15,    -1,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
    34,    35,    36,    37,    -1,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    -1,    -1,    50,    51,    52,    53,
    54,    55,    -1,    57,    58,    59,   357,    61,    62,    -1,
   361,   299,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,
    -1,    -1,   949,   950,   951,    79,    80,    81,   955,   956,
    -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,
    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   405,   109,   110,    -1,    -1,    -1,
    -1,    -1,   350,   351,   352,    -1,    -1,    -1,    -1,   420,
    -1,    -1,   423,    -1,    -1,    -1,    -1,     3,     4,     5,
     6,    -1,    -1,     9,   435,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   443,    -1,    -1,    -1,    -1,    -1,  1025,  1026,
  1027,  1028,  1029,  1030,  1031,    31,  1033,    -1,  1035,  1036,
  1037,  1038,    -1,    -1,    -1,    -1,    42,   405,    -1,    -1,
   471,   472,   473,   474,    -1,    -1,    -1,    -1,   479,    55,
    -1,    57,    58,    -1,    -1,    -1,   487,   488,  1065,    -1,
   491,    -1,   493,   494,   495,    71,    -1,    -1,    -1,   500,
    -1,    -1,    -1,    -1,   505,    81,    -1,   508,    -1,  1086,
    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,  1095,    -1,
    -1,     4,     5,    -1,   525,     8,     9,    -1,    -1,    -1,
    -1,    14,    -1,   471,    -1,   473,   474,   475,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,    -1,   487,
   488,    -1,    -1,   491,    37,   493,   494,   495,   496,    -1,
    -1,    -1,   500,    46,    -1,    -1,    -1,   505,    -1,    -1,
   508,    -1,    55,    -1,    57,    58,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
    -1,    -1,    12,  1170,    14,    -1,  1173,  1174,  1175,  1176,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,
    30,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
    -1,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,    -1,
    -1,    -1,    -1,    -1,   635,    55,    -1,    57,    58,    -1,
    -1,  1218,  1219,  1220,  1221,  1222,  1223,    -1,    -1,  1226,
    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    81,    -1,    -1,   665,    -1,    -1,    -1,    -1,    89,
    -1,    -1,    -1,    93,    94,    -1,    -1,    -1,    -1,    -1,
    -1,  1258,    -1,    -1,    -1,   623,  1263,    -1,    -1,  1266,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   637,
   638,   639,    -1,    -1,    -1,   706,    -1,     1,   646,     3,
     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,    -1,
    14,    -1,    -1,    -1,    -1,    -1,    -1,   665,    -1,    -1,
    -1,    -1,    -1,    -1,    28,    -1,    30,    31,    32,    -1,
    -1,    -1,    -1,    37,    -1,   746,   747,   748,    42,    -1,
    -1,    -1,    46,    47,   755,    49,    -1,    -1,    -1,    -1,
    -1,    55,    -1,    57,    58,    -1,    -1,    61,   706,    63,
    -1,  1348,  1349,  1350,    -1,   776,   777,    71,    -1,    -1,
    -1,    -1,    -1,   784,    -1,    -1,    -1,    81,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   746,   747,
   748,    -1,    -1,    -1,   815,    -1,   817,   755,    -1,    -1,
    -1,   822,   823,    -1,   825,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   776,   777,
   778,   779,   780,    -1,    -1,    -1,   784,     3,     4,     5,
     6,     7,     8,     9,    -1,    -1,    12,    -1,    14,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    28,    -1,    30,    31,    -1,    -1,    -1,    -1,
  1457,    37,    -1,    -1,   822,    -1,    42,    -1,    -1,    -1,
    46,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    55,
    -1,    57,    58,    -1,    -1,    -1,   844,   845,   846,    -1,
    -1,    -1,    -1,    -1,    -1,    71,    -1,   855,     3,     4,
     5,     6,    -1,    -1,     9,    81,    -1,    55,    -1,    -1,
    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,    94,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    -1,  1526,
  1527,  1528,    80,    -1,    -1,    83,   957,    42,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    55,    -1,    57,    58,  1551,    -1,   104,    -1,   106,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,
    -1,   929,   930,    -1,    -1,   933,    81,    -1,   936,    -1,
    -1,    -1,    -1,    -1,    89,    -1,    -1,   945,    93,    -1,
    -1,   949,   950,   951,    -1,    -1,    -1,   955,     3,     4,
     5,     6,    -1,    -1,  1025,  1026,  1027,  1028,  1029,  1030,
    -1,    -1,    -1,    -1,  1035,  1036,  1037,  1038,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    31,   175,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
    -1,    -1,    -1,    -1,  1065,    -1,   194,   195,   196,    -1,
    55,    -1,    57,    58,    -1,    -1,   204,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    71,  1025,  1026,  1027,
  1028,  1029,  1030,  1031,  1095,   223,    81,  1035,  1036,  1037,
  1038,    -1,    -1,    -1,    89,    -1,    -1,    -1,    93,  1047,
  1048,  1049,    -1,     3,     4,     5,     6,     7,     8,     9,
    -1,   249,    12,    -1,    14,    -1,    -1,  1065,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   263,    -1,    -1,    28,    -1,
    30,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,
    -1,    -1,    42,    -1,    -1,    -1,    46,    -1,    48,     4,
     5,    -1,    -1,     8,     9,    55,    -1,    57,    58,    14,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    71,    -1,    28,    -1,    30,   350,   351,   352,    -1,
    -1,    81,    37,    -1,    -1,    -1,    -1,    -1,    -1,    89,
    -1,    46,    -1,    93,    94,    -1,  1144,  1145,    -1,  1147,
    55,    -1,    57,    58,    -1,    -1,    -1,    -1,  1219,  1220,
    -1,    -1,    -1,    -1,    -1,  1226,    -1,    -1,   356,   357,
    -1,    -1,  1170,    -1,    -1,  1173,  1174,  1175,    -1,    -1,
     3,     4,     5,     6,    -1,    -1,     9,    -1,    93,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1258,    -1,    -1,
    -1,    -1,  1263,    -1,    -1,  1266,    -1,    -1,    31,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   405,    -1,    42,
  1218,  1219,  1220,  1221,  1222,  1223,    -1,    -1,  1226,    -1,
    -1,    -1,    55,    -1,    57,    58,    -1,    -1,  1236,  1237,
  1238,  1239,    -1,    -1,    -1,    -1,    -1,   471,    71,   473,
   474,   475,    -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,
  1258,    -1,    -1,    14,    -1,    -1,    89,    -1,    -1,    -1,
    93,    -1,    23,    24,    -1,    -1,    -1,    -1,    -1,    30,
    31,    -1,    33,   471,    -1,   473,   474,  1348,  1349,  1350,
    -1,     3,     4,     5,     6,     7,     8,     9,    -1,   487,
   488,    -1,    14,   491,    -1,   493,   494,   495,   496,    -1,
    -1,    -1,   500,    -1,    65,    -1,    28,   505,    30,    31,
   508,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,
    42,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    55,    -1,    57,    58,    -1,    -1,    61,
  1348,    -1,  1350,    -1,    -1,    -1,    -1,    -1,    -1,    71,
    -1,    -1,    -1,  1361,  1362,    -1,  1364,    -1,    -1,    81,
    -1,    -1,    -1,   124,    -1,   126,    -1,    89,    -1,    -1,
    -1,    93,   133,   134,    -1,    -1,    -1,    -1,    -1,   140,
   141,    -1,    -1,   144,   145,   146,  1457,   148,   149,   150,
   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   637,   638,   639,    -1,    -1,    -1,    -1,
    -1,    -1,   646,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     4,     5,    -1,     7,     8,     9,    -1,    -1,    12,    -1,
    14,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
     6,    -1,    -1,     9,    28,    -1,    30,    31,    -1,  1457,
    -1,   649,   650,    37,    -1,  1526,  1527,  1528,  1466,  1467,
  1468,  1469,    46,    -1,    48,    31,    -1,   665,    -1,    -1,
    -1,    55,   706,    57,    58,    -1,    42,    -1,   239,   240,
  1551,    -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,    55,
    -1,    57,    58,    -1,    -1,    -1,    -1,    81,    -1,   260,
    -1,    -1,    -1,    -1,    -1,    71,    -1,    -1,   706,    93,
    94,    -1,   746,   747,   748,    81,    -1,    -1,  1526,  1527,
  1528,   755,    -1,    89,  1532,    -1,    -1,    93,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   299,    -1,
    -1,    -1,    -1,  1551,    -1,    -1,    -1,    -1,   746,   747,
   748,    -1,    -1,    -1,    -1,   753,    -1,   755,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    -1,    -1,   776,   777,
   778,   779,   780,   781,    -1,    -1,   784,   348,    -1,   350,
   351,    -1,     3,     4,     5,     6,     7,     8,     9,    -1,
    -1,    12,    -1,    14,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   809,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,
    31,   855,    -1,    -1,   822,    -1,    37,    -1,    -1,    -1,
    -1,    42,    -1,   394,    -1,    46,     3,     4,     5,     6,
    -1,    -1,     9,    -1,    55,    -1,    57,    58,    -1,    -1,
    -1,    -1,   413,    -1,    -1,     3,     4,     5,     6,   420,
    71,    -1,   423,    -1,    31,    -1,    -1,    -1,    -1,    -1,
    81,    -1,    -1,    -1,   435,    42,    -1,    -1,    89,    -1,
    -1,    -1,    93,    31,    -1,    -1,    -1,    -1,    55,    -1,
    57,    58,    -1,    -1,    42,   929,   930,    -1,    -1,   933,
    -1,    -1,   936,    -1,    71,    -1,    -1,    55,    -1,    57,
    58,   945,    -1,    12,    81,   949,   950,   951,    -1,    -1,
    -1,   955,    89,    71,    -1,    -1,    93,    -1,    -1,    -1,
    -1,    -1,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    89,    -1,    -1,    -1,    93,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   956,   957,
   958,   522,    -1,   524,    63,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,   548,    -1,    -1,
    -1,  1025,  1026,  1027,  1028,  1029,  1030,  1031,    -1,    -1,
    -1,  1035,  1036,  1037,  1038,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,  1025,  1026,  1027,
  1028,  1029,  1030,  1031,    -1,  1033,    -1,  1035,  1036,  1037,
  1038,     3,     4,     5,     6,     7,     8,     9,   107,  1047,
  1048,  1049,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   623,    -1,    -1,    -1,    28,  1065,    30,    31,
    -1,    -1,    -1,   634,   635,    37,   637,   638,    -1,    -1,
    42,    -1,    -1,    -1,    46,    -1,    -1,    -1,  1086,    -1,
    -1,    -1,    -1,    55,    -1,    57,    58,    -1,    -1,    -1,
    -1,    63,    -1,    -1,     3,     4,     5,     6,    -1,    71,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    81,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    89,    -1,    -1,
   691,    93,    31,    -1,    -1,    -1,  1170,   698,   699,  1173,
  1174,  1175,    -1,    42,    -1,    -1,   707,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    57,    58,
    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,    -1,   730,
    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,  1176,    -1,
    -1,    -1,    81,    -1,  1218,  1219,  1220,  1221,  1222,  1223,
    89,    -1,  1226,    -1,    93,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    -1,    -1,    -1,
  1218,  1219,  1220,  1221,  1222,  1223,    -1,    -1,  1226,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1236,  1237,
  1238,  1239,    -1,    -1,    -1,    -1,    -1,    -1,   809,    -1,
    -1,   812,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
  1258,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    -1,   844,   845,   846,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,   855,    28,    29,    30,    31,    32,
    -1,    34,    35,    36,    37,    -1,    39,    40,    41,    42,
    43,    44,    -1,    46,    -1,    48,    -1,    50,    51,    52,
    53,    54,    55,    -1,    57,    58,    59,  1361,  1362,    62,
  1364,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,
  1348,    -1,  1350,    -1,    87,    88,    89,    -1,    -1,    -1,
    93,    94,    -1,  1361,  1362,  1363,  1364,    -1,   929,   930,
    -1,    -1,   933,    -1,    -1,   936,    -1,   110,    -1,    -1,
    -1,    -1,    -1,    -1,   945,    -1,     3,     4,     5,     6,
     7,     8,     9,    -1,   955,     4,     5,    14,     7,     8,
     9,    -1,    -1,    12,    -1,    14,    -1,    -1,    -1,    -1,
    -1,    28,    -1,    30,    31,    -1,    -1,    -1,    -1,    28,
    37,    30,    31,    -1,    -1,    42,    -1,    -1,    37,    46,
    -1,    -1,  1466,  1467,  1468,  1469,    -1,    46,    55,    -1,
    57,    58,    -1,    -1,    61,    -1,    55,    -1,    57,    58,
    -1,    -1,    -1,    -1,    71,    -1,    -1,    -1,    -1,  1457,
    -1,    -1,    -1,    -1,    81,    -1,    -1,    -1,  1466,  1467,
  1468,  1469,    89,    -1,    -1,    -1,    93,    -1,    -1,    -1,
    -1,     3,     4,     5,     6,     7,     8,     9,    -1,    -1,
    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,  1532,  1060,
    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,    31,
    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,
    42,    -1,    -1,    -1,    46,    -1,  1087,    -1,  1526,  1527,
  1528,    -1,    -1,    55,  1532,    57,    58,     4,     5,    -1,
     7,     8,     9,    -1,    -1,    -1,    -1,    14,    -1,    71,
    -1,    -1,    -1,  1551,    -1,    -1,    -1,    -1,    -1,    81,
    -1,    28,    -1,    30,    31,    -1,    -1,    89,    -1,    -1,
    37,    93,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
    -1,    -1,    49,  1144,  1145,    -1,  1147,    -1,    55,    -1,
    57,    58,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,
     4,     5,     6,     7,     8,     9,    -1,    -1,    12,  1170,
    14,    -1,  1173,  1174,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    25,    -1,    27,    -1,    -1,    -1,    31,    -1,    -1,
    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,    42,    -1,
    -1,  1202,    46,    -1,    48,    -1,    -1,    -1,    -1,    -1,
    -1,    55,    -1,    57,    58,    59,    60,    61,    -1,    63,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
    84,    85,  1243,    87,    88,    89,    -1,    91,    92,    93,
    94,    95,    -1,    -1,    -1,    -1,    -1,   101,   102,    -1,
  1261,    -1,  1263,   107,   108,   109,     1,   111,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    -1,    13,    14,
    15,    -1,    17,    18,    19,    20,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    32,    -1,    34,
    35,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
    45,    46,    47,    -1,    -1,    50,    51,    52,    53,    54,
    55,    -1,    57,    58,    59,    -1,    61,    62,    -1,    -1,
    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,     1,
    95,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    -1,    -1,   110,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,
    32,    -1,    34,    35,    36,    37,    -1,    39,    40,    41,
    42,    43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,
    52,    53,    54,    55,    -1,    57,    58,    -1,    -1,    -1,
    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,
    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,    -1,
     1,    93,     3,     4,     5,     6,     7,     8,     9,    10,
    11,    -1,    13,    14,    -1,    -1,   108,    -1,   110,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
    31,    32,    -1,    34,    35,    36,    37,    -1,    39,    40,
    41,    42,    43,    44,    -1,    46,    -1,    -1,    -1,    50,
    51,    52,    53,    54,    55,    -1,    57,    58,    59,    -1,
    61,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,
    -1,     1,    93,     3,     4,     5,     6,    -1,     8,     9,
    10,    11,    -1,    13,    14,    -1,    -1,    -1,    -1,   110,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,
    30,    -1,    32,    -1,    34,    35,    36,    37,    -1,    39,
    40,    41,    42,    43,    44,    -1,    46,    -1,    -1,    -1,
    50,    51,    52,    53,    54,    55,    -1,    57,    58,    59,
    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,
    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
    80,    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,
    -1,    -1,    -1,    93,    94,     1,    -1,     3,     4,     5,
     6,    -1,     8,     9,    10,    11,    -1,    13,    14,   109,
   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    28,    29,    30,    31,    32,    -1,    34,    35,
    36,    37,    -1,    39,    40,    41,    42,    43,    44,    -1,
    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
    -1,    57,    58,    59,    -1,    -1,    62,    -1,    -1,    -1,
    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,
    -1,    87,    88,    89,    -1,    -1,     1,    93,     3,     4,
     5,     6,    -1,     8,     9,    10,    11,    -1,    13,    14,
    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,    34,
    35,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,
    55,    -1,    57,    58,    59,    -1,    -1,    62,    -1,    -1,
    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,    94,
     1,    -1,     3,     4,     5,     6,    -1,     8,     9,    10,
    11,    -1,    13,    14,    -1,   110,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
    -1,    32,    -1,    34,    35,    36,    37,    -1,    39,    40,
    41,    42,    43,    44,    -1,    46,    -1,    -1,    -1,    50,
    51,    52,    53,    54,    55,    -1,    57,    58,    59,    -1,
    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,
    -1,    -1,    93,     1,    -1,     3,     4,     5,     6,   100,
     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,   110,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    28,    29,    30,    -1,    32,    -1,    34,    35,    36,    37,
    -1,    39,    40,    41,    42,    43,    44,    -1,    46,    -1,
    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,    57,
    58,    59,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,
    88,    89,    -1,    -1,     1,    93,     3,     4,     5,     6,
    -1,     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,
    -1,   109,   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    28,    29,    30,    -1,    32,    -1,    34,    35,    36,
    37,    -1,    39,    40,    41,    42,    43,    44,    -1,    46,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,
    57,    58,    59,    -1,    -1,    62,    -1,    -1,    -1,    -1,
    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,
    87,    88,    89,    -1,    -1,     1,    93,     3,     4,     5,
     6,    -1,     8,     9,    10,    11,    -1,    13,    14,    -1,
    -1,    -1,   109,   110,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    28,    29,    30,    31,    32,    -1,    34,    35,
    36,    37,    -1,    39,    40,    41,    42,    43,    44,    -1,
    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
    -1,    57,    58,    59,    -1,    -1,    62,    -1,    -1,    -1,
    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,
    -1,    87,    88,    89,    -1,    -1,     1,    93,     3,     4,
     5,     6,    -1,     8,     9,    10,    11,    -1,    13,    14,
    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,    34,
    35,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,
    55,    -1,    57,    58,    59,    -1,    -1,    62,    -1,    -1,
    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
    -1,    -1,    87,    88,    89,    -1,    -1,     1,    93,     3,
     4,     5,     6,    -1,     8,     9,    10,    11,    -1,    13,
    14,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,
    34,    35,    36,    37,    -1,    39,    40,    41,    42,    43,
    44,    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,
    54,    55,    -1,    57,    58,    -1,    -1,    -1,    62,    63,
    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,
    -1,    -1,    -1,    87,    88,    89,    -1,    -1,     1,    93,
     3,     4,     5,     6,    -1,     8,     9,    10,    11,    -1,
    13,    14,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    -1,    32,
    -1,    34,    35,    36,    37,    -1,    39,    40,    41,    42,
    43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,    52,
    53,    54,    55,    -1,    57,    58,    -1,    -1,    61,    62,
    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,
    -1,    -1,    -1,    -1,    87,    88,    89,    -1,    -1,     1,
    93,     3,     4,     5,     6,    -1,     8,     9,    10,    11,
    -1,    13,    14,    -1,    -1,    -1,    -1,   110,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    -1,
    32,    -1,    34,    35,    36,    37,    -1,    39,    40,    41,
    42,    43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,
    52,    53,    54,    55,    -1,    57,    58,    -1,    -1,    -1,
    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,
    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,    -1,
     1,    93,     3,     4,     5,     6,    -1,     8,     9,    10,
    11,    -1,    13,    14,    -1,    -1,   108,    -1,   110,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
    -1,    32,    -1,    34,    35,    36,    37,    -1,    39,    40,
    41,    42,    43,    44,    -1,    46,    -1,    -1,    -1,    50,
    51,    52,    53,    54,    55,    -1,    57,    58,    -1,    -1,
    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,
    -1,     1,    93,     3,     4,     5,     6,    -1,     8,     9,
    10,    11,    -1,    13,    14,    -1,    -1,    -1,    -1,   110,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,
    30,    -1,    32,    -1,    34,    35,    36,    37,    -1,    39,
    40,    41,    42,    43,    44,    -1,    46,    -1,    -1,    -1,
    50,    51,    52,    53,    54,    55,    -1,    57,    58,    -1,
    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,
    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
    80,    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,
    -1,    -1,     1,    93,     3,     4,     5,     6,    -1,     8,
     9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,    -1,
   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
    29,    30,    -1,    32,    -1,    34,    35,    36,    37,    -1,
    39,    40,    41,    42,    43,    44,    -1,    46,    -1,    -1,
    -1,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,
     1,    -1,    71,     4,     5,    -1,    -1,     8,     9,    -1,
    79,    80,    81,    14,    -1,    -1,    -1,    -1,    87,    88,
    89,    -1,    -1,    -1,    93,    -1,    -1,    28,    -1,    30,
    -1,    -1,    -1,    -1,    -1,    -1,    37,    -1,    39,    40,
    -1,   110,    -1,    -1,    -1,    46,    -1,    48,    -1,    -1,
    -1,    -1,    -1,    -1,    55,    -1,    57,    58,    -1,    60,
    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    -1,    -1,    87,    88,    89,    -1,
    91,    -1,    -1,    94,     3,     4,     5,     6,    -1,     8,
     9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,   110,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
    29,    30,    -1,    32,    -1,    34,    35,    36,    37,    -1,
    39,    40,    41,    42,    43,    44,    -1,    46,    -1,    -1,
    -1,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,
    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,    88,
    89,    -1,    -1,    -1,    93,     3,     4,     5,     6,    -1,
     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,
    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    28,    29,    30,    -1,    32,    -1,    34,    35,    36,    37,
    -1,    39,    40,    41,    42,    43,    44,    -1,    46,    -1,
    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,    57,
    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,
    88,    89,    -1,    -1,    -1,    93,     3,     4,     5,     6,
    -1,     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,
    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    28,    29,    30,    -1,    32,    -1,    34,    35,    36,
    37,    -1,    39,    40,    41,    42,    43,    44,    -1,    46,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,
    57,    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,
    87,    88,    89,    -1,    -1,    -1,    93,     3,     4,     5,
     6,    -1,     8,     9,    10,    11,    -1,    13,    14,    -1,
    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    28,    29,    30,    -1,    32,    -1,    34,    35,
    36,    37,    -1,    39,    40,    41,    42,    43,    44,    -1,
    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
    -1,    57,    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,
    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,
    -1,    87,    88,    89,    -1,    -1,    -1,    93,     3,     4,
     5,     6,    -1,     8,     9,    10,    11,    -1,    13,    14,
    -1,    -1,    -1,    -1,   110,   111,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,    34,
    35,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,
    55,    -1,    57,    58,    -1,    -1,    -1,    62,    -1,    -1,
    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,    70,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,   110,   111,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    -1,    13,    14,    15,
    -1,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    -1,    34,    35,
    36,    37,    -1,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    -1,    -1,    50,    51,    52,    53,    54,    55,
    -1,    57,    58,    59,    -1,    61,    62,    -1,    -1,    -1,
    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,
    -1,    87,    88,    89,    -1,    -1,    -1,    93,    -1,    95,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,   109,   110,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    -1,    13,    14,    15,    -1,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    -1,    34,    35,    36,    37,
    -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,    57,
    58,    59,    -1,    61,    62,    -1,    -1,    -1,    -1,    -1,
    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,
    88,    89,    -1,    -1,    -1,    93,    -1,    95,    -1,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    -1,    13,
    14,    15,   110,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
    34,    35,    36,    37,    -1,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    -1,    -1,    50,    51,    52,    53,
    54,    55,    -1,    57,    58,    59,    -1,    61,    62,    -1,
    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,
    -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,
    -1,    95,    -1,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    -1,    13,    14,    15,   110,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    -1,    34,    35,    36,    37,    -1,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    -1,    -1,
    50,    51,    52,    53,    54,    55,    -1,    57,    58,    -1,
    -1,    61,    62,    -1,    -1,    -1,    -1,    -1,    68,    -1,
    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,
    80,    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,
    -1,    -1,    -1,    93,    -1,    95,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    28,    29,    30,    31,    32,    -1,    34,    35,    36,
    37,    -1,    39,    40,    41,    42,    43,    44,    -1,    46,
    -1,    48,    -1,    50,    51,    52,    53,    54,    55,    -1,
    57,    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,
    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,
    87,    88,    89,    -1,    -1,    -1,    93,    94,     3,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    28,    29,    30,    31,    32,    -1,    34,
    35,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
    -1,    46,    -1,    48,    -1,    50,    51,    52,    53,    54,
    55,    -1,    57,    58,    -1,    -1,    -1,    62,    -1,    -1,
    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,    94,
     3,     4,     5,     6,    -1,     8,     9,    10,    11,    -1,
    13,    14,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    31,    32,
    -1,    34,    35,    36,    37,    -1,    39,    40,    41,    42,
    43,    44,    -1,    46,    -1,    48,    -1,    50,    51,    52,
    53,    54,    55,    -1,    57,    58,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,
    -1,    -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,
    93,    94,     3,     4,     5,     6,    -1,     8,     9,    10,
    11,    -1,    13,    14,    -1,    -1,    -1,   110,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
    31,    32,    -1,    34,    35,    36,    37,    -1,    39,    40,
    41,    42,    43,    44,    -1,    46,    -1,    48,    -1,    50,
    51,    52,    53,    54,    55,    -1,    57,    58,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,
    -1,    -1,    93,    94,     3,     4,     5,     6,    -1,     8,
     9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,   110,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
    29,    30,    31,    32,    -1,    34,    35,    36,    37,    -1,
    39,    40,    41,    42,    43,    44,    -1,    46,    -1,    -1,
    -1,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,    68,
    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,    88,
    89,    -1,    -1,    -1,    93,     3,     4,     5,     6,    -1,
     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,
    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    28,    29,    30,    -1,    32,    -1,    34,    35,    36,    37,
    -1,    39,    40,    41,    42,    43,    44,    -1,    46,    -1,
    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,    57,
    58,    -1,    -1,    61,    62,    -1,    -1,    -1,    -1,    -1,
    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,
    88,    89,    -1,    -1,    -1,    93,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,
    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    28,    29,    30,    31,    32,    -1,    34,    35,    36,
    37,    -1,    39,    40,    41,    42,    43,    44,    -1,    46,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,
    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,
    87,    88,    89,    -1,    -1,    -1,    93,     3,     4,     5,
     6,    -1,     8,     9,    10,    11,    -1,    13,    14,    -1,
    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    28,    29,    30,    31,    32,    -1,    34,    35,
    36,    37,    -1,    39,    40,    41,    42,    43,    44,    -1,
    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
    -1,    57,    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,
    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,
    -1,    87,    88,    89,    -1,    -1,    -1,    93,     3,     4,
     5,     6,    -1,     8,     9,    10,    11,    -1,    13,    14,
    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,    34,
    35,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,
    55,    -1,    57,    58,    -1,    -1,    -1,    62,    -1,    -1,
    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,     3,
     4,     5,     6,    -1,     8,     9,    10,    11,    -1,    13,
    14,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,
    34,    35,    36,    37,    -1,    39,    40,    41,    42,    43,
    44,    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,
    54,    55,    -1,    57,    58,    -1,    -1,    -1,    62,    -1,
    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,
    -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,
     3,     4,     5,     6,    -1,     8,     9,    10,    11,    -1,
    13,    14,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    -1,    32,
    -1,    34,    35,    36,    37,    -1,    39,    40,    41,    42,
    43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,    52,
    53,    54,    55,    -1,    57,    58,    -1,    -1,    -1,    62,
    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,    -1,
    -1,    -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,
    93,     3,     4,     5,     6,    -1,     8,     9,    10,    11,
    -1,    13,    14,    -1,    -1,    -1,    -1,   110,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,    -1,
    32,    -1,    34,    35,    36,    37,    -1,    39,    40,    41,
    42,    43,    44,    -1,    46,    -1,    -1,    -1,    50,    51,
    52,    53,    54,    55,    -1,    57,    58,    59,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,    81,
    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,    -1,
    -1,    93,     3,     4,     5,     6,    -1,     8,     9,    10,
    11,    -1,    13,    14,    -1,    -1,    -1,    -1,   110,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,    29,    30,
    -1,    32,    -1,    34,    35,    36,    37,    -1,    39,    40,
    41,    42,    43,    44,    -1,    46,    -1,    -1,    -1,    50,
    51,    52,    53,    54,    55,    -1,    57,    58,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,    -1,    -1,
    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    79,    80,
    81,    -1,    -1,    -1,    -1,    -1,    87,    88,    89,    -1,
    -1,    -1,    93,    94,     3,     4,     5,     6,    -1,     8,
     9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,   110,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
    29,    30,    31,    32,    -1,    34,    35,    36,    37,    -1,
    39,    40,    41,    42,    43,    44,    -1,    46,    -1,    -1,
    -1,    50,    51,    52,    53,    54,    55,    -1,    57,    58,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    68,
    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,    88,
    89,    -1,    -1,    -1,    93,     3,     4,     5,     6,    -1,
     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,
    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    28,    29,    30,    -1,    32,    -1,    34,    35,    36,    37,
    -1,    39,    40,    41,    42,    43,    44,    -1,    46,    -1,
    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,    57,
    58,    -1,    -1,    -1,    62,    -1,    -1,    -1,    -1,    -1,
    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,    87,
    88,    89,    -1,    -1,    -1,    93,     3,     4,     5,     6,
    -1,     8,     9,    10,    11,    -1,    13,    14,    -1,    -1,
    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    28,    29,    30,    31,    32,    -1,    34,    35,    36,
    37,    -1,    39,    40,    41,    42,    43,    44,    -1,    46,
    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    -1,
    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,    -1,
    87,    88,    89,    -1,    -1,    -1,    93,     3,     4,     5,
     6,    -1,     8,     9,    10,    11,    -1,    13,    14,    -1,
    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    28,    29,    30,    -1,    32,    -1,    34,    35,
    36,    37,    -1,    39,    40,    41,    42,    43,    44,    -1,
    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,    -1,
    -1,    87,    88,    89,    -1,    -1,    -1,    93,     3,     4,
     5,     6,    -1,     8,     9,    10,    11,    -1,    13,    14,
    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,    34,
    35,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,    54,
    55,    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    79,    80,    81,    -1,    -1,    -1,
    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,     3,
     4,     5,     6,    -1,     8,     9,    10,    11,    -1,    13,
    14,    -1,    -1,    -1,    -1,   110,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    28,    29,    30,    -1,    32,    -1,
    34,    35,    36,    37,    -1,    39,    40,    41,    42,    43,
    44,    -1,    46,    -1,    -1,    -1,    50,    51,    52,    53,
    54,    55,    -1,    57,    58,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    68,    -1,    -1,    71,     3,     4,
     5,     6,     7,     8,     9,    79,    80,    81,    -1,    14,
    -1,    -1,    -1,    87,    88,    89,    -1,    -1,    -1,    93,
    -1,    -1,    -1,    28,    -1,    30,    31,    -1,    -1,    -1,
    -1,    -1,    37,    -1,    -1,    -1,   110,    42,    -1,    -1,
    -1,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    55,    -1,    57,    58,     4,     5,    -1,     7,     8,     9,
    -1,    -1,    12,    -1,    14,    -1,    71,     4,     5,    -1,
     7,     8,     9,    -1,    -1,    -1,    81,    14,    28,    -1,
    30,    31,    -1,    -1,    89,    -1,    -1,    37,    93,    -1,
    -1,    28,    -1,    30,    31,    -1,    46,    -1,    -1,    -1,
    37,    -1,    -1,    -1,    -1,    55,    -1,    57,    58,    46,
    -1,    -1,     4,     5,    -1,    -1,     8,     9,    55,    -1,
    57,    58,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,    -1,
    -1,    -1,    -1,    -1,    -1,    37,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    46,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    55,    -1,    57,    58,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    64,
    65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    60,    -1,    -1,   111,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
    79,    80,    81,    82,    83,    84,    85,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
    74,    75,    -1,    77,    78,    79,    80,    81,    82,    83,
    84,    85,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    81,    82,    83,    84,    85,    71,
    72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
    82,    83,    84,    85,    72,    73,    74,    75,    76,    77,
    78,    79,    80,    81,    82,    83,    84,    85
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.27.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 216 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 2:
#line 354 "parse.y"
{ finish_translation_unit (); ;
    break;}
case 3:
#line 362 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 4:
#line 364 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 5:
#line 366 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 8:
#line 375 "parse.y"
{ have_extern_spec = 1;
		  used_extern_spec = 0;
		  yyval.ttype = NULL_TREE; ;
    break;}
case 9:
#line 380 "parse.y"
{ have_extern_spec = 0; ;
    break;}
case 10:
#line 385 "parse.y"
{ yyval.itype = pedantic;
		  pedantic = 0; ;
    break;}
case 12:
#line 394 "parse.y"
{ if (pending_lang_change) do_pending_lang_change(); ;
    break;}
case 13:
#line 396 "parse.y"
{ if (! toplevel_bindings_p ())
		  pop_everything (); ;
    break;}
case 14:
#line 402 "parse.y"
{ if (pending_inlines) do_pending_inlines (); ;
    break;}
case 15:
#line 404 "parse.y"
{ if (pending_inlines) do_pending_inlines (); ;
    break;}
case 16:
#line 406 "parse.y"
{ if (pending_inlines) do_pending_inlines (); ;
    break;}
case 17:
#line 408 "parse.y"
{ if (TREE_CHAIN (yyvsp[-2].ttype)) yyvsp[-2].ttype = combine_strings (yyvsp[-2].ttype);
		  assemble_asm (yyvsp[-2].ttype); ;
    break;}
case 18:
#line 411 "parse.y"
{ pop_lang_context (); ;
    break;}
case 19:
#line 413 "parse.y"
{ if (pending_inlines) do_pending_inlines ();
		  pop_lang_context (); ;
    break;}
case 20:
#line 416 "parse.y"
{ if (pending_inlines) do_pending_inlines ();
		  pop_lang_context (); ;
    break;}
case 21:
#line 419 "parse.y"
{ push_namespace (yyvsp[-1].ttype); ;
    break;}
case 22:
#line 421 "parse.y"
{ pop_namespace (); ;
    break;}
case 23:
#line 423 "parse.y"
{ push_namespace (NULL_TREE); ;
    break;}
case 24:
#line 425 "parse.y"
{ pop_namespace (); ;
    break;}
case 26:
#line 428 "parse.y"
{ do_toplevel_using_decl (yyvsp[-1].ttype); ;
    break;}
case 28:
#line 431 "parse.y"
{ pedantic = yyvsp[-1].itype; ;
    break;}
case 29:
#line 436 "parse.y"
{ begin_only_namespace_names (); ;
    break;}
case 30:
#line 438 "parse.y"
{
		  end_only_namespace_names ();
		  if (lastiddecl)
		    yyvsp[-1].ttype = lastiddecl;
		  do_namespace_alias (yyvsp[-4].ttype, yyvsp[-1].ttype);
		;
    break;}
case 31:
#line 448 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 32:
#line 450 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 33:
#line 452 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 34:
#line 457 "parse.y"
{ yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 35:
#line 459 "parse.y"
{ yyval.ttype = build_parse_node (SCOPE_REF, global_namespace, yyvsp[0].ttype); ;
    break;}
case 36:
#line 461 "parse.y"
{ yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 37:
#line 466 "parse.y"
{ begin_only_namespace_names (); ;
    break;}
case 38:
#line 468 "parse.y"
{
		  end_only_namespace_names ();
		  /* If no declaration was found, the using-directive is
		     invalid. Since that was not reported, we need the
		     identifier for the error message. */
		  if (TREE_CODE (yyvsp[-1].ttype) == IDENTIFIER_NODE && lastiddecl)
		    yyvsp[-1].ttype = lastiddecl;
		  do_using_directive (yyvsp[-1].ttype);
		;
    break;}
case 39:
#line 481 "parse.y"
{
		  if (TREE_CODE (yyval.ttype) == IDENTIFIER_NODE)
		    yyval.ttype = lastiddecl;
		  got_scope = yyval.ttype;
		;
    break;}
case 40:
#line 487 "parse.y"
{
		  yyval.ttype = yyvsp[-1].ttype;
		  if (TREE_CODE (yyval.ttype) == IDENTIFIER_NODE)
		    yyval.ttype = lastiddecl;
		  got_scope = yyval.ttype;
		;
    break;}
case 43:
#line 498 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 44:
#line 500 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 45:
#line 505 "parse.y"
{ push_lang_context (yyvsp[0].ttype); ;
    break;}
case 46:
#line 507 "parse.y"
{ if (current_lang_name != yyvsp[0].ttype)
		    cp_error ("use of linkage spec `%D' is different from previous spec `%D'", yyvsp[0].ttype, current_lang_name);
		  pop_lang_context (); push_lang_context (yyvsp[0].ttype); ;
    break;}
case 47:
#line 514 "parse.y"
{ begin_template_parm_list (); ;
    break;}
case 48:
#line 516 "parse.y"
{ yyval.ttype = end_template_parm_list (yyvsp[-1].ttype); ;
    break;}
case 49:
#line 518 "parse.y"
{ begin_specialization(); 
		  yyval.ttype = NULL_TREE; ;
    break;}
case 50:
#line 524 "parse.y"
{ yyval.ttype = process_template_parm (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 51:
#line 526 "parse.y"
{ yyval.ttype = process_template_parm (yyvsp[-2].ttype, yyvsp[0].ttype); ;
    break;}
case 52:
#line 531 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 53:
#line 533 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 54:
#line 537 "parse.y"
{ yyval.ttype = finish_template_type_parm (yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 55:
#line 539 "parse.y"
{ yyval.ttype = finish_template_type_parm (class_type_node, yyvsp[0].ttype); ;
    break;}
case 56:
#line 544 "parse.y"
{ yyval.ttype = finish_template_template_parm (yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 57:
#line 556 "parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 58:
#line 558 "parse.y"
{ yyval.ttype = build_tree_list (groktypename (yyvsp[0].ftype.t), yyvsp[-2].ttype); ;
    break;}
case 59:
#line 560 "parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ftype.t); ;
    break;}
case 60:
#line 562 "parse.y"
{ yyval.ttype = build_tree_list (yyvsp[0].ttype, yyvsp[-2].ftype.t); ;
    break;}
case 61:
#line 564 "parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 62:
#line 566 "parse.y"
{
		  if (TREE_CODE (yyvsp[0].ttype) != TEMPLATE_DECL
		      && TREE_CODE (yyvsp[0].ttype) != TEMPLATE_TEMPLATE_PARM
		      && TREE_CODE (yyvsp[0].ttype) != TYPE_DECL)
		    {
		      error ("invalid default template argument");
		      yyvsp[0].ttype = error_mark_node;
		    }
		  yyval.ttype = build_tree_list (yyvsp[0].ttype, yyvsp[-2].ttype);
		;
    break;}
case 63:
#line 580 "parse.y"
{ finish_template_decl (yyvsp[-1].ttype); ;
    break;}
case 64:
#line 582 "parse.y"
{ finish_template_decl (yyvsp[-1].ttype); ;
    break;}
case 65:
#line 587 "parse.y"
{ if (pending_inlines) do_pending_inlines (); ;
    break;}
case 66:
#line 589 "parse.y"
{ if (pending_inlines) do_pending_inlines (); ;
    break;}
case 67:
#line 591 "parse.y"
{ if (pending_inlines) do_pending_inlines (); ;
    break;}
case 68:
#line 593 "parse.y"
{ if (pending_inlines) do_pending_inlines ();
		  pop_lang_context (); ;
    break;}
case 69:
#line 596 "parse.y"
{ if (pending_inlines) do_pending_inlines ();
		  pop_lang_context (); ;
    break;}
case 70:
#line 599 "parse.y"
{ pedantic = yyvsp[-1].itype; ;
    break;}
case 72:
#line 605 "parse.y"
{;
    break;}
case 73:
#line 607 "parse.y"
{ note_list_got_semicolon (yyvsp[-2].ftype.t); ;
    break;}
case 74:
#line 609 "parse.y"
{ maybe_process_partial_specialization (yyvsp[-1].ftype.t);
		  note_got_semicolon (yyvsp[-1].ftype.t); ;
    break;}
case 76:
#line 616 "parse.y"
{;
    break;}
case 77:
#line 618 "parse.y"
{ note_list_got_semicolon (yyvsp[-2].ftype.t); ;
    break;}
case 78:
#line 620 "parse.y"
{ pedwarn ("empty declaration"); ;
    break;}
case 80:
#line 623 "parse.y"
{
		  tree t, attrs;
		  split_specs_attrs (yyvsp[-1].ftype.t, &t, &attrs);
		  shadow_tag (t);
		  note_list_got_semicolon (yyvsp[-1].ftype.t);
		;
    break;}
case 84:
#line 636 "parse.y"
{ yyval.itype = 0; ;
    break;}
case 85:
#line 638 "parse.y"
{ yyval.itype = 1; ;
    break;}
case 91:
#line 654 "parse.y"
{ expand_body (finish_function (lineno, (int)yyvsp[-1].itype)); ;
    break;}
case 92:
#line 656 "parse.y"
{ expand_body (finish_function (lineno, (int)yyvsp[0].itype)); ;
    break;}
case 93:
#line 658 "parse.y"
{ ;
    break;}
case 94:
#line 663 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-2].ttype, yyvsp[-1].ttype); ;
    break;}
case 95:
#line 665 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 96:
#line 667 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype); 
		  yyval.ttype = make_call_declarator (yyval.ttype, empty_parms (), yyvsp[-1].ttype, yyvsp[0].ttype);
		;
    break;}
case 97:
#line 671 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-2].ttype, yyvsp[-1].ttype); ;
    break;}
case 98:
#line 673 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 99:
#line 675 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype);
		  yyval.ttype = make_call_declarator (yyval.ttype, empty_parms (), yyvsp[-1].ttype, yyvsp[0].ttype);
		;
    break;}
case 100:
#line 679 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-2].ttype, yyvsp[-1].ttype); ;
    break;}
case 101:
#line 681 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 102:
#line 683 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype);
		  yyval.ttype = make_call_declarator (yyval.ttype, empty_parms (), yyvsp[-1].ttype, yyvsp[0].ttype);
		;
    break;}
case 103:
#line 687 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-2].ttype, yyvsp[-1].ttype); ;
    break;}
case 104:
#line 689 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 105:
#line 691 "parse.y"
{ yyval.ttype = begin_constructor_declarator (yyvsp[-4].ttype, yyvsp[-3].ttype); 
		  yyval.ttype = make_call_declarator (yyval.ttype, empty_parms (), yyvsp[-1].ttype, yyvsp[0].ttype);
		;
    break;}
case 106:
#line 698 "parse.y"
{ if (!begin_function_definition (yyvsp[-1].ftype.t, yyvsp[0].ttype))
		    YYERROR1; ;
    break;}
case 107:
#line 701 "parse.y"
{ if (!begin_function_definition (yyvsp[-1].ttype, yyvsp[0].ttype))
		    YYERROR1; ;
    break;}
case 108:
#line 704 "parse.y"
{ if (!begin_function_definition (NULL_TREE, yyvsp[0].ttype))
		    YYERROR1; ;
    break;}
case 109:
#line 707 "parse.y"
{ if (!begin_function_definition (yyvsp[-1].ttype, yyvsp[0].ttype))
		    YYERROR1; ;
    break;}
case 110:
#line 710 "parse.y"
{ if (!begin_function_definition (NULL_TREE, yyvsp[0].ttype))
		    YYERROR1; ;
    break;}
case 111:
#line 716 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-5].ttype, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 112:
#line 718 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-3].ttype, empty_parms (), yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 113:
#line 720 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-5].ttype, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 114:
#line 722 "parse.y"
{ yyval.ttype = make_call_declarator (yyvsp[-3].ttype, empty_parms (), yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 115:
#line 729 "parse.y"
{ tree specs, attrs;
		  split_specs_attrs (yyvsp[-1].ttype, &specs, &attrs);
		  attrs = build_tree_list (attrs, NULL_TREE);
		  yyval.ttype = start_method (specs, yyvsp[0].ttype, attrs);
		 rest_of_mdef:
		  if (! yyval.ttype)
		    YYERROR1;
		  if (yychar == YYEMPTY)
		    yychar = YYLEX;
		  reinit_parse_for_method (yychar, yyval.ttype); ;
    break;}
case 116:
#line 740 "parse.y"
{ yyval.ttype = start_method (NULL_TREE, yyvsp[0].ttype, NULL_TREE); 
		  goto rest_of_mdef; ;
    break;}
case 117:
#line 743 "parse.y"
{ tree specs, attrs;
		  split_specs_attrs (yyvsp[-1].ftype.t, &specs, &attrs);
		  attrs = build_tree_list (attrs, NULL_TREE);
		  yyval.ttype = start_method (specs, yyvsp[0].ttype, attrs); goto rest_of_mdef; ;
    break;}
case 118:
#line 748 "parse.y"
{ tree specs, attrs;
		  split_specs_attrs (yyvsp[-1].ttype, &specs, &attrs);
		  attrs = build_tree_list (attrs, NULL_TREE);
		  yyval.ttype = start_method (specs, yyvsp[0].ttype, attrs); goto rest_of_mdef; ;
    break;}
case 119:
#line 753 "parse.y"
{ yyval.ttype = start_method (NULL_TREE, yyval.ttype, NULL_TREE); 
		  goto rest_of_mdef; ;
    break;}
case 120:
#line 756 "parse.y"
{ tree specs, attrs;
		  split_specs_attrs (yyvsp[-1].ttype, &specs, &attrs);
		  attrs = build_tree_list (attrs, NULL_TREE);
		  yyval.ttype = start_method (specs, yyvsp[0].ttype, attrs); goto rest_of_mdef; ;
    break;}
case 121:
#line 761 "parse.y"
{ yyval.ttype = start_method (NULL_TREE, yyval.ttype, NULL_TREE); 
		  goto rest_of_mdef; ;
    break;}
case 122:
#line 767 "parse.y"
{
		  if (! current_function_parms_stored)
		    store_parm_decls ();
		  yyval.ttype = yyvsp[0].ttype;
		;
    break;}
case 123:
#line 776 "parse.y"
{ finish_named_return_value (yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 124:
#line 778 "parse.y"
{ finish_named_return_value (yyval.ttype, yyvsp[-1].ttype); ;
    break;}
case 125:
#line 780 "parse.y"
{ finish_named_return_value (yyval.ttype, NULL_TREE); ;
    break;}
case 126:
#line 785 "parse.y"
{
		  if (yyvsp[0].itype == 0)
		    error ("no base initializers given following ':'");
		  setup_vtbl_ptr ();
		;
    break;}
case 127:
#line 794 "parse.y"
{
		  if (! current_function_parms_stored)
		    store_parm_decls ();

		  if (DECL_CONSTRUCTOR_P (current_function_decl))
		    /* Make a contour for the initializer list.  */
		    do_pushlevel ();
		  else if (current_class_type == NULL_TREE)
		    error ("base initializers not allowed for non-member functions");
		  else if (! DECL_CONSTRUCTOR_P (current_function_decl))
		    error ("only constructors take base initializers");
		;
    break;}
case 128:
#line 810 "parse.y"
{ yyval.itype = 0; ;
    break;}
case 129:
#line 812 "parse.y"
{ yyval.itype = 1; ;
    break;}
case 132:
#line 819 "parse.y"
{
		  if (current_class_name)
		    pedwarn ("anachronistic old style base class initializer");
		  expand_member_init (current_class_ref, NULL_TREE, yyvsp[-1].ttype);
		;
    break;}
case 133:
#line 825 "parse.y"
{
		  if (current_class_name)
		    pedwarn ("anachronistic old style base class initializer");
		  expand_member_init (current_class_ref, NULL_TREE, void_type_node);
		;
    break;}
case 134:
#line 831 "parse.y"
{ expand_member_init (current_class_ref, yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 135:
#line 833 "parse.y"
{ expand_member_init (current_class_ref, yyvsp[-1].ttype, void_type_node); ;
    break;}
case 136:
#line 835 "parse.y"
{ expand_member_init (current_class_ref, yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 137:
#line 837 "parse.y"
{ expand_member_init (current_class_ref, yyvsp[-1].ttype, void_type_node); ;
    break;}
case 138:
#line 839 "parse.y"
{ expand_member_init (current_class_ref, TYPE_MAIN_DECL (yyvsp[-3].ttype),
				      yyvsp[-1].ttype); ;
    break;}
case 139:
#line 842 "parse.y"
{ expand_member_init (current_class_ref, TYPE_MAIN_DECL (yyvsp[-1].ttype),
				      void_type_node); ;
    break;}
case 152:
#line 869 "parse.y"
{ do_type_instantiation (yyvsp[-1].ftype.t, NULL_TREE);
		  yyungetc (';', 1); ;
    break;}
case 154:
#line 873 "parse.y"
{ tree specs = strip_attrs (yyvsp[-1].ftype.t);
		  do_decl_instantiation (specs, yyvsp[0].ttype, NULL_TREE); ;
    break;}
case 156:
#line 877 "parse.y"
{ do_decl_instantiation (NULL_TREE, yyvsp[0].ttype, NULL_TREE); ;
    break;}
case 158:
#line 880 "parse.y"
{ do_decl_instantiation (NULL_TREE, yyvsp[0].ttype, NULL_TREE); ;
    break;}
case 160:
#line 883 "parse.y"
{ do_type_instantiation (yyvsp[-1].ftype.t, yyvsp[-4].ttype);
		  yyungetc (';', 1); ;
    break;}
case 162:
#line 888 "parse.y"
{ tree specs = strip_attrs (yyvsp[-1].ftype.t);
		  do_decl_instantiation (specs, yyvsp[0].ttype, yyvsp[-4].ttype); ;
    break;}
case 164:
#line 892 "parse.y"
{ do_decl_instantiation (NULL_TREE, yyvsp[0].ttype, yyvsp[-3].ttype); ;
    break;}
case 166:
#line 895 "parse.y"
{ do_decl_instantiation (NULL_TREE, yyvsp[0].ttype, yyvsp[-3].ttype); ;
    break;}
case 168:
#line 900 "parse.y"
{ begin_explicit_instantiation(); ;
    break;}
case 169:
#line 903 "parse.y"
{ end_explicit_instantiation(); ;
    break;}
case 170:
#line 912 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 171:
#line 915 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 174:
#line 923 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 175:
#line 928 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 176:
#line 932 "parse.y"
{ 
		  if (yychar == YYEMPTY)
		    yychar = YYLEX;

		  yyval.ttype = finish_template_type (yyvsp[-3].ttype, yyvsp[-1].ttype, 
					     yychar == SCOPE);
		;
    break;}
case 178:
#line 943 "parse.y"
{
		  /* Handle `Class<Class<Type>>' without space in the `>>' */
		  pedwarn ("`>>' should be `> >' in template class name");
		  yyungetc ('>', 1);
		;
    break;}
case 179:
#line 952 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 181:
#line 958 "parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); ;
    break;}
case 182:
#line 960 "parse.y"
{ yyval.ttype = chainon (yyval.ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); ;
    break;}
case 183:
#line 965 "parse.y"
{ yyval.ttype = groktypename (yyvsp[0].ftype.t); ;
    break;}
case 184:
#line 967 "parse.y"
{ yyval.ttype = lastiddecl; ;
    break;}
case 186:
#line 973 "parse.y"
{ yyval.code = NEGATE_EXPR; ;
    break;}
case 187:
#line 975 "parse.y"
{ yyval.code = CONVERT_EXPR; ;
    break;}
case 188:
#line 977 "parse.y"
{ yyval.code = PREINCREMENT_EXPR; ;
    break;}
case 189:
#line 979 "parse.y"
{ yyval.code = PREDECREMENT_EXPR; ;
    break;}
case 190:
#line 981 "parse.y"
{ yyval.code = TRUTH_NOT_EXPR; ;
    break;}
case 191:
#line 986 "parse.y"
{ yyval.ttype = build_x_compound_expr (yyval.ttype); ;
    break;}
case 193:
#line 992 "parse.y"
{ error ("ANSI C++ forbids an empty condition for `%s'",
			 cond_stmt_keyword);
		  yyval.ttype = integer_zero_node; ;
    break;}
case 194:
#line 996 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 195:
#line 1001 "parse.y"
{ error ("ANSI C++ forbids an empty condition for `%s'",
			 cond_stmt_keyword);
		  yyval.ttype = integer_zero_node; ;
    break;}
case 196:
#line 1005 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 197:
#line 1010 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 199:
#line 1013 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 200:
#line 1018 "parse.y"
{ {
		  tree d;
		  for (d = getdecls (); d; d = TREE_CHAIN (d))
		    if (TREE_CODE (d) == TYPE_DECL) {
		      tree s = TREE_TYPE (d);
		      if (TREE_CODE (s) == RECORD_TYPE)
			cp_error ("definition of class `%T' in condition", s);
		      else if (TREE_CODE (s) == ENUMERAL_TYPE)
			cp_error ("definition of enum `%T' in condition", s);
		    }
		  }
		  current_declspecs = yyvsp[-4].ftype.t;
		  yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, /*prefix_attributes*/ NULL_TREE);
		;
    break;}
case 201:
#line 1034 "parse.y"
{ 
		  cp_finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-3].ttype, LOOKUP_ONLYCONVERTING);
		  yyval.ttype = convert_from_reference (yyvsp[-1].ttype); 
		  if (TREE_CODE (TREE_TYPE (yyval.ttype)) == ARRAY_TYPE)
		    cp_error ("definition of array `%#D' in condition", yyval.ttype); 
		;
    break;}
case 207:
#line 1052 "parse.y"
{ yyval.ttype = begin_compound_stmt (1); ;
    break;}
case 208:
#line 1054 "parse.y"
{ finish_compound_stmt (1, yyvsp[-1].ttype); ;
    break;}
case 210:
#line 1061 "parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyval.ttype, 
		                  build_expr_list (NULL_TREE, yyvsp[0].ttype)); ;
    break;}
case 211:
#line 1064 "parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyval.ttype, 
		                  build_expr_list (NULL_TREE, error_mark_node)); ;
    break;}
case 212:
#line 1067 "parse.y"
{ chainon (yyval.ttype, build_expr_list (NULL_TREE, yyvsp[0].ttype)); ;
    break;}
case 213:
#line 1069 "parse.y"
{ chainon (yyval.ttype, build_expr_list (NULL_TREE, error_mark_node)); ;
    break;}
case 214:
#line 1074 "parse.y"
{ yyval.ttype = build_expr_list (NULL_TREE, yyval.ttype); ;
    break;}
case 216:
#line 1080 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 217:
#line 1083 "parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; ;
    break;}
case 218:
#line 1086 "parse.y"
{ yyval.ttype = build_x_indirect_ref (yyvsp[0].ttype, "unary *"); ;
    break;}
case 219:
#line 1088 "parse.y"
{ yyval.ttype = build_x_unary_op (ADDR_EXPR, yyvsp[0].ttype); ;
    break;}
case 220:
#line 1090 "parse.y"
{ yyval.ttype = build_x_unary_op (BIT_NOT_EXPR, yyvsp[0].ttype); ;
    break;}
case 221:
#line 1092 "parse.y"
{ yyval.ttype = finish_unary_op_expr (yyvsp[-1].code, yyvsp[0].ttype); ;
    break;}
case 222:
#line 1095 "parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C++ forbids `&&'");
  		  yyval.ttype = finish_label_address_expr (yyvsp[0].ttype); ;
    break;}
case 223:
#line 1099 "parse.y"
{ yyval.ttype = expr_sizeof (yyvsp[0].ttype); ;
    break;}
case 224:
#line 1101 "parse.y"
{ yyval.ttype = c_sizeof (groktypename (yyvsp[-1].ftype.t));
		  check_for_new_type ("sizeof", yyvsp[-1].ftype); ;
    break;}
case 225:
#line 1104 "parse.y"
{ yyval.ttype = grok_alignof (yyvsp[0].ttype); ;
    break;}
case 226:
#line 1106 "parse.y"
{ yyval.ttype = c_alignof (groktypename (yyvsp[-1].ftype.t)); 
		  check_for_new_type ("alignof", yyvsp[-1].ftype); ;
    break;}
case 227:
#line 1112 "parse.y"
{ yyval.ttype = build_new (NULL_TREE, yyvsp[0].ftype.t, NULL_TREE, yyvsp[-1].itype); 
		  check_for_new_type ("new", yyvsp[0].ftype); ;
    break;}
case 228:
#line 1115 "parse.y"
{ yyval.ttype = build_new (NULL_TREE, yyvsp[-1].ftype.t, yyvsp[0].ttype, yyvsp[-2].itype); 
		  check_for_new_type ("new", yyvsp[-1].ftype); ;
    break;}
case 229:
#line 1118 "parse.y"
{ yyval.ttype = build_new (yyvsp[-1].ttype, yyvsp[0].ftype.t, NULL_TREE, yyvsp[-2].itype); 
		  check_for_new_type ("new", yyvsp[0].ftype); ;
    break;}
case 230:
#line 1121 "parse.y"
{ yyval.ttype = build_new (yyvsp[-2].ttype, yyvsp[-1].ftype.t, yyvsp[0].ttype, yyvsp[-3].itype); 
		  check_for_new_type ("new", yyvsp[-1].ftype); ;
    break;}
case 231:
#line 1125 "parse.y"
{ yyval.ttype = build_new (NULL_TREE, groktypename(yyvsp[-1].ftype.t),
				  NULL_TREE, yyvsp[-3].itype); 
		  check_for_new_type ("new", yyvsp[-1].ftype); ;
    break;}
case 232:
#line 1129 "parse.y"
{ yyval.ttype = build_new (NULL_TREE, groktypename(yyvsp[-2].ftype.t), yyvsp[0].ttype, yyvsp[-4].itype); 
		  check_for_new_type ("new", yyvsp[-2].ftype); ;
    break;}
case 233:
#line 1132 "parse.y"
{ yyval.ttype = build_new (yyvsp[-3].ttype, groktypename(yyvsp[-1].ftype.t), NULL_TREE, yyvsp[-4].itype); 
		  check_for_new_type ("new", yyvsp[-1].ftype); ;
    break;}
case 234:
#line 1135 "parse.y"
{ yyval.ttype = build_new (yyvsp[-4].ttype, groktypename(yyvsp[-2].ftype.t), yyvsp[0].ttype, yyvsp[-5].itype); 
		  check_for_new_type ("new", yyvsp[-2].ftype); ;
    break;}
case 235:
#line 1139 "parse.y"
{ yyval.ttype = delete_sanity (yyvsp[0].ttype, NULL_TREE, 0, yyvsp[-1].itype); ;
    break;}
case 236:
#line 1141 "parse.y"
{ yyval.ttype = delete_sanity (yyvsp[0].ttype, NULL_TREE, 1, yyvsp[-3].itype);
		  if (yychar == YYEMPTY)
		    yychar = YYLEX; ;
    break;}
case 237:
#line 1145 "parse.y"
{ yyval.ttype = delete_sanity (yyvsp[0].ttype, yyvsp[-2].ttype, 2, yyvsp[-4].itype);
		  if (yychar == YYEMPTY)
		    yychar = YYLEX; ;
    break;}
case 238:
#line 1149 "parse.y"
{ yyval.ttype = build_x_unary_op (REALPART_EXPR, yyvsp[0].ttype); ;
    break;}
case 239:
#line 1151 "parse.y"
{ yyval.ttype = build_x_unary_op (IMAGPART_EXPR, yyvsp[0].ttype); ;
    break;}
case 240:
#line 1153 "parse.y"
{ yyval.ttype = build_x_va_arg (yyvsp[-3].ttype, groktypename (yyvsp[-1].ftype.t));
		  check_for_new_type ("__builtin_va_arg", yyvsp[-1].ftype); ;
    break;}
case 241:
#line 1159 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 242:
#line 1161 "parse.y"
{ cp_pedwarn ("old style placement syntax, use () instead");
		  yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 243:
#line 1167 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 244:
#line 1169 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 245:
#line 1171 "parse.y"
{
		  cp_error ("`%T' is not a valid expression", yyvsp[-1].ftype.t);
		  yyval.ttype = error_mark_node;
		;
    break;}
case 246:
#line 1179 "parse.y"
{
		  if (pedantic)
		    pedwarn ("ANSI C++ forbids initialization of new expression with `='");
		  if (TREE_CODE (yyvsp[0].ttype) != TREE_LIST
		      && TREE_CODE (yyvsp[0].ttype) != CONSTRUCTOR)
		    yyval.ttype = build_expr_list (NULL_TREE, yyvsp[0].ttype);
		  else
		    yyval.ttype = yyvsp[0].ttype;
		;
    break;}
case 247:
#line 1193 "parse.y"
{ yyvsp[-1].ftype.t = finish_parmlist (build_tree_list (NULL_TREE, yyvsp[-1].ftype.t), 0);
		  yyval.ttype = make_call_declarator (NULL_TREE, yyvsp[-1].ftype.t, NULL_TREE, NULL_TREE);
		  check_for_new_type ("cast", yyvsp[-1].ftype); ;
    break;}
case 248:
#line 1197 "parse.y"
{ yyvsp[-1].ftype.t = finish_parmlist (build_tree_list (NULL_TREE, yyvsp[-1].ftype.t), 0); 
		  yyval.ttype = make_call_declarator (yyval.ttype, yyvsp[-1].ftype.t, NULL_TREE, NULL_TREE);
		  check_for_new_type ("cast", yyvsp[-1].ftype); ;
    break;}
case 250:
#line 1205 "parse.y"
{ yyval.ttype = reparse_absdcl_as_casts (yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 251:
#line 1207 "parse.y"
{ 
		  tree init = build_nt (CONSTRUCTOR, NULL_TREE,
					nreverse (yyvsp[-2].ttype)); 
		  if (pedantic)
		    pedwarn ("ANSI C++ forbids constructor-expressions");
		  /* Indicate that this was a GNU C constructor expression.  */
		  TREE_HAS_CONSTRUCTOR (init) = 1;

		  yyval.ttype = reparse_absdcl_as_casts (yyval.ttype, init);
		;
    break;}
case 253:
#line 1223 "parse.y"
{ yyval.ttype = build_x_binary_op (MEMBER_REF, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 254:
#line 1225 "parse.y"
{ yyval.ttype = build_m_component_ref (yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 255:
#line 1227 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 256:
#line 1229 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 257:
#line 1231 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 258:
#line 1233 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 259:
#line 1235 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 260:
#line 1237 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 261:
#line 1239 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 262:
#line 1241 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 263:
#line 1243 "parse.y"
{ yyval.ttype = build_x_binary_op (LT_EXPR, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 264:
#line 1245 "parse.y"
{ yyval.ttype = build_x_binary_op (GT_EXPR, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 265:
#line 1247 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 266:
#line 1249 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 267:
#line 1251 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 268:
#line 1253 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 269:
#line 1255 "parse.y"
{ yyval.ttype = build_x_binary_op (yyvsp[-1].code, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 270:
#line 1257 "parse.y"
{ yyval.ttype = build_x_binary_op (TRUTH_ANDIF_EXPR, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 271:
#line 1259 "parse.y"
{ yyval.ttype = build_x_binary_op (TRUTH_ORIF_EXPR, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 272:
#line 1261 "parse.y"
{ yyval.ttype = build_x_conditional_expr (yyval.ttype, yyvsp[-2].ttype, yyvsp[0].ttype); ;
    break;}
case 273:
#line 1263 "parse.y"
{ yyval.ttype = build_x_modify_expr (yyval.ttype, NOP_EXPR, yyvsp[0].ttype);
		  if (yyval.ttype != error_mark_node)
                    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, MODIFY_EXPR); ;
    break;}
case 274:
#line 1267 "parse.y"
{ yyval.ttype = build_x_modify_expr (yyval.ttype, yyvsp[-1].code, yyvsp[0].ttype); ;
    break;}
case 275:
#line 1269 "parse.y"
{ yyval.ttype = build_throw (NULL_TREE); ;
    break;}
case 276:
#line 1271 "parse.y"
{ yyval.ttype = build_throw (yyvsp[0].ttype); ;
    break;}
case 277:
#line 1289 "parse.y"
{ yyval.ttype = build_parse_node (BIT_NOT_EXPR, yyvsp[0].ttype); ;
    break;}
case 278:
#line 1291 "parse.y"
{ yyval.ttype = build_parse_node (BIT_NOT_EXPR, yyvsp[0].ttype); ;
    break;}
case 284:
#line 1300 "parse.y"
{
		  /* If lastiddecl is a TREE_LIST, it's a baselink, which
		     means that we're in an expression like S::f<int>, so
		     don't do_identifier; we only do that for unqualified
		     identifiers.  */
		  if (lastiddecl && TREE_CODE (lastiddecl) != TREE_LIST)
		    yyval.ttype = do_identifier (yyvsp[-1].ttype, 1, NULL_TREE);
		  else
		    yyval.ttype = yyvsp[-1].ttype;
		;
    break;}
case 285:
#line 1313 "parse.y"
{ yyval.ttype = lookup_template_function (yyvsp[-2].ttype, yyvsp[-1].ttype); ;
    break;}
case 286:
#line 1315 "parse.y"
{ yyval.ttype = lookup_template_function (yyvsp[-2].ttype, yyvsp[-1].ttype); ;
    break;}
case 287:
#line 1320 "parse.y"
{ yyval.ttype = lookup_template_function (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 288:
#line 1322 "parse.y"
{ yyval.ttype = lookup_template_function (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 289:
#line 1325 "parse.y"
{ yyval.ttype = lookup_template_function (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 294:
#line 1337 "parse.y"
{
		  /* Provide support for '(' attributes '*' declarator ')'
		     etc */
		  yyval.ttype = decl_tree_cons (yyvsp[-1].ttype, yyvsp[0].ttype, NULL_TREE);
		;
    break;}
case 296:
#line 1347 "parse.y"
{ yyval.ttype = build_parse_node (INDIRECT_REF, yyvsp[0].ttype); ;
    break;}
case 297:
#line 1349 "parse.y"
{ yyval.ttype = build_parse_node (ADDR_EXPR, yyvsp[0].ttype); ;
    break;}
case 298:
#line 1351 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 299:
#line 1356 "parse.y"
{ yyval.ttype = lookup_template_function (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 300:
#line 1358 "parse.y"
{ yyval.ttype = lookup_template_function (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 304:
#line 1368 "parse.y"
{ yyval.ttype = finish_decl_parsing (yyvsp[-1].ttype); ;
    break;}
case 305:
#line 1373 "parse.y"
{
		  if (TREE_CODE (yyvsp[0].ttype) == BIT_NOT_EXPR)
		    yyval.ttype = build_x_unary_op (BIT_NOT_EXPR, TREE_OPERAND (yyvsp[0].ttype, 0));
		  else 
		    yyval.ttype = finish_id_expr (yyvsp[0].ttype);
		;
    break;}
case 308:
#line 1382 "parse.y"
{
		  yyval.ttype = combine_strings (yyval.ttype);
		  /* combine_strings doesn't set up TYPE_MAIN_VARIANT of
		     a const array the way we want, so fix it.  */
		  if (flag_const_strings)
		    TREE_TYPE (yyval.ttype) = build_cplus_array_type
		      (TREE_TYPE (TREE_TYPE (yyval.ttype)),
		       TYPE_DOMAIN (TREE_TYPE (yyval.ttype)));
		;
    break;}
case 309:
#line 1392 "parse.y"
{ yyval.ttype = finish_parenthesized_expr (yyvsp[-1].ttype); ;
    break;}
case 310:
#line 1394 "parse.y"
{ yyvsp[-1].ttype = reparse_decl_as_expr (NULL_TREE, yyvsp[-1].ttype);
		  yyval.ttype = finish_parenthesized_expr (yyvsp[-1].ttype); ;
    break;}
case 311:
#line 1397 "parse.y"
{ yyval.ttype = error_mark_node; ;
    break;}
case 312:
#line 1399 "parse.y"
{ tree scope = current_scope ();
		  if (!scope || TREE_CODE (scope) != FUNCTION_DECL)
		    {
		      error ("braced-group within expression allowed only inside a function");
		      YYERROR;
		    }
		  if (pedantic)
		    pedwarn ("ANSI C++ forbids braced-groups within expressions");  
		  yyval.ttype = begin_stmt_expr (); 
		;
    break;}
case 313:
#line 1410 "parse.y"
{ yyval.ttype = finish_stmt_expr (yyvsp[-2].ttype); ;
    break;}
case 314:
#line 1415 "parse.y"
{ yyval.ttype = finish_call_expr (yyvsp[-3].ttype, yyvsp[-1].ttype, 1); ;
    break;}
case 315:
#line 1417 "parse.y"
{ yyval.ttype = finish_call_expr (yyvsp[-1].ttype, NULL_TREE, 1); ;
    break;}
case 316:
#line 1419 "parse.y"
{ yyval.ttype = finish_call_expr (yyvsp[-3].ttype, yyvsp[-1].ttype, 0); ;
    break;}
case 317:
#line 1421 "parse.y"
{ yyval.ttype = finish_call_expr (yyvsp[-1].ttype, NULL_TREE, 0); ;
    break;}
case 318:
#line 1423 "parse.y"
{ yyval.ttype = grok_array_decl (yyval.ttype, yyvsp[-1].ttype); ;
    break;}
case 319:
#line 1425 "parse.y"
{ yyval.ttype = finish_increment_expr (yyvsp[-1].ttype, POSTINCREMENT_EXPR); ;
    break;}
case 320:
#line 1427 "parse.y"
{ yyval.ttype = finish_increment_expr (yyvsp[-1].ttype, POSTDECREMENT_EXPR); ;
    break;}
case 321:
#line 1430 "parse.y"
{ yyval.ttype = finish_this_expr (); ;
    break;}
case 322:
#line 1432 "parse.y"
{
		  /* This is a C cast in C++'s `functional' notation
		     using the "implicit int" extension so that:
		     `const (3)' is equivalent to `const int (3)'.  */
		  tree type;

		  type = hash_tree_cons (NULL_TREE, yyvsp[-3].ttype, NULL_TREE);
		  type = groktypename (build_decl_list (type, NULL_TREE));
		  yyval.ttype = build_functional_cast (type, yyvsp[-1].ttype);
		;
    break;}
case 324:
#line 1444 "parse.y"
{ tree type = groktypename (yyvsp[-4].ftype.t);
		  check_for_new_type ("dynamic_cast", yyvsp[-4].ftype);
		  yyval.ttype = build_dynamic_cast (type, yyvsp[-1].ttype); ;
    break;}
case 325:
#line 1448 "parse.y"
{ tree type = groktypename (yyvsp[-4].ftype.t);
		  check_for_new_type ("static_cast", yyvsp[-4].ftype);
		  yyval.ttype = build_static_cast (type, yyvsp[-1].ttype); ;
    break;}
case 326:
#line 1452 "parse.y"
{ tree type = groktypename (yyvsp[-4].ftype.t);
		  check_for_new_type ("reinterpret_cast", yyvsp[-4].ftype);
		  yyval.ttype = build_reinterpret_cast (type, yyvsp[-1].ttype); ;
    break;}
case 327:
#line 1456 "parse.y"
{ tree type = groktypename (yyvsp[-4].ftype.t);
		  check_for_new_type ("const_cast", yyvsp[-4].ftype);
		  yyval.ttype = build_const_cast (type, yyvsp[-1].ttype); ;
    break;}
case 328:
#line 1460 "parse.y"
{ yyval.ttype = build_x_typeid (yyvsp[-1].ttype); ;
    break;}
case 329:
#line 1462 "parse.y"
{ tree type = groktypename (yyvsp[-1].ftype.t);
		  check_for_new_type ("typeid", yyvsp[-1].ftype);
		  yyval.ttype = get_typeid (TYPE_MAIN_VARIANT (type)); ;
    break;}
case 330:
#line 1466 "parse.y"
{ yyval.ttype = do_scoped_id (yyvsp[0].ttype, 1); ;
    break;}
case 331:
#line 1468 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 332:
#line 1470 "parse.y"
{
		  got_scope = NULL_TREE;
		  if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
		    yyval.ttype = do_scoped_id (yyvsp[0].ttype, 1);
		  else
		    yyval.ttype = yyvsp[0].ttype;
		;
    break;}
case 333:
#line 1478 "parse.y"
{ yyval.ttype = build_offset_ref (OP0 (yyval.ttype), OP1 (yyval.ttype)); ;
    break;}
case 334:
#line 1480 "parse.y"
{ yyval.ttype = finish_qualified_call_expr (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 335:
#line 1482 "parse.y"
{ yyval.ttype = finish_qualified_call_expr (yyvsp[-1].ttype, NULL_TREE); ;
    break;}
case 336:
#line 1484 "parse.y"
{ 
		  yyval.ttype = build_x_component_ref (yyval.ttype, yyvsp[0].ttype, NULL_TREE, 1); 
		;
    break;}
case 337:
#line 1488 "parse.y"
{ yyval.ttype = finish_object_call_expr (yyvsp[-3].ttype, yyvsp[-4].ttype, yyvsp[-1].ttype); ;
    break;}
case 338:
#line 1490 "parse.y"
{ yyval.ttype = finish_object_call_expr (yyvsp[-1].ttype, yyvsp[-2].ttype, NULL_TREE); ;
    break;}
case 339:
#line 1492 "parse.y"
{ yyval.ttype = build_x_component_ref (yyval.ttype, yyvsp[0].ttype, NULL_TREE, 1); ;
    break;}
case 340:
#line 1494 "parse.y"
{ if (processing_template_decl)
		    yyval.ttype = build_min_nt (COMPONENT_REF, yyvsp[-1].ttype, yyvsp[0].ttype);
		  else
		    yyval.ttype = build_object_ref (yyval.ttype, OP0 (yyvsp[0].ttype), OP1 (yyvsp[0].ttype)); ;
    break;}
case 341:
#line 1499 "parse.y"
{ yyval.ttype = finish_object_call_expr (yyvsp[-3].ttype, yyvsp[-4].ttype, yyvsp[-1].ttype); ;
    break;}
case 342:
#line 1501 "parse.y"
{ yyval.ttype = finish_object_call_expr (yyvsp[-1].ttype, yyvsp[-2].ttype, NULL_TREE); ;
    break;}
case 343:
#line 1503 "parse.y"
{ yyval.ttype = finish_qualified_object_call_expr (yyvsp[-3].ttype, yyvsp[-4].ttype, yyvsp[-1].ttype); ;
    break;}
case 344:
#line 1505 "parse.y"
{ yyval.ttype = finish_qualified_object_call_expr (yyvsp[-1].ttype, yyvsp[-2].ttype, NULL_TREE); ;
    break;}
case 345:
#line 1508 "parse.y"
{ yyval.ttype = finish_pseudo_destructor_call_expr (yyvsp[-3].ttype, NULL_TREE, yyvsp[-1].ttype); ;
    break;}
case 346:
#line 1510 "parse.y"
{ yyval.ttype = finish_pseudo_destructor_call_expr (yyvsp[-5].ttype, yyvsp[-4].ttype, yyvsp[-1].ttype); ;
    break;}
case 347:
#line 1512 "parse.y"
{
		  yyval.ttype = error_mark_node;
		;
    break;}
case 348:
#line 1557 "parse.y"
{ yyval.itype = 0; ;
    break;}
case 349:
#line 1559 "parse.y"
{ got_scope = NULL_TREE; yyval.itype = 1; ;
    break;}
case 350:
#line 1564 "parse.y"
{ yyval.itype = 0; ;
    break;}
case 351:
#line 1566 "parse.y"
{ got_scope = NULL_TREE; yyval.itype = 1; ;
    break;}
case 352:
#line 1571 "parse.y"
{ yyval.ttype = boolean_true_node; ;
    break;}
case 353:
#line 1573 "parse.y"
{ yyval.ttype = boolean_false_node; ;
    break;}
case 355:
#line 1580 "parse.y"
{ yyval.ttype = chainon (yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 356:
#line 1585 "parse.y"
{
		  if (! current_function_parms_stored)
		    store_parm_decls ();
		  setup_vtbl_ptr ();
		;
    break;}
case 357:
#line 1594 "parse.y"
{ got_object = TREE_TYPE (yyval.ttype); ;
    break;}
case 358:
#line 1596 "parse.y"
{
		  yyval.ttype = build_x_arrow (yyval.ttype); 
		  got_object = TREE_TYPE (yyval.ttype);
		;
    break;}
case 359:
#line 1604 "parse.y"
{
		  if (yyvsp[-2].ftype.t && IS_AGGR_TYPE_CODE (TREE_CODE (yyvsp[-2].ftype.t)))
		    note_got_semicolon (yyvsp[-2].ftype.t);
		;
    break;}
case 360:
#line 1609 "parse.y"
{
		  note_list_got_semicolon (yyvsp[-2].ftype.t);
		;
    break;}
case 361:
#line 1613 "parse.y"
{;
    break;}
case 362:
#line 1615 "parse.y"
{
		  shadow_tag (yyvsp[-1].ftype.t);
		  note_list_got_semicolon (yyvsp[-1].ftype.t);
		;
    break;}
case 363:
#line 1620 "parse.y"
{ warning ("empty declaration"); ;
    break;}
case 364:
#line 1622 "parse.y"
{ pedantic = yyvsp[-1].itype; ;
    break;}
case 367:
#line 1636 "parse.y"
{ yyval.ttype = make_call_declarator (NULL_TREE, empty_parms (),
					     NULL_TREE, NULL_TREE); ;
    break;}
case 368:
#line 1639 "parse.y"
{ yyval.ttype = make_call_declarator (yyval.ttype, empty_parms (), NULL_TREE,
					     NULL_TREE); ;
    break;}
case 369:
#line 1646 "parse.y"
{ yyval.ftype.t = build_decl_list (yyvsp[-1].ftype.t, yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 370:
#line 1649 "parse.y"
{ yyval.ftype.t = build_decl_list (yyvsp[-1].ftype.t, yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 371:
#line 1652 "parse.y"
{ yyval.ftype.t = build_decl_list (build_decl_list (NULL_TREE, yyvsp[-1].ftype.t),
					  yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 372:
#line 1656 "parse.y"
{ yyval.ftype.t = build_decl_list (yyvsp[0].ftype.t, NULL_TREE);
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag;  ;
    break;}
case 373:
#line 1659 "parse.y"
{ yyval.ftype.t = build_decl_list (yyvsp[0].ftype.t, NULL_TREE); 
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag; ;
    break;}
case 376:
#line 1675 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[0].ftype.t, yyvsp[-1].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag; ;
    break;}
case 377:
#line 1678 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[-1].ftype.t, yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 378:
#line 1681 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[-2].ftype.t, chainon (yyvsp[-1].ttype, yyvsp[0].ttype)); 
		  yyval.ftype.new_type_flag = yyvsp[-2].ftype.new_type_flag; ;
    break;}
case 379:
#line 1684 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[-1].ftype.t, chainon (yyvsp[0].ttype, yyvsp[-2].ttype)); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 380:
#line 1687 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[-1].ftype.t, chainon (yyvsp[0].ttype, yyvsp[-2].ttype)); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 381:
#line 1690 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[-2].ftype.t,
					 chainon (yyvsp[-1].ttype, chainon (yyvsp[0].ttype, yyvsp[-3].ttype))); 
		  yyval.ftype.new_type_flag = yyvsp[-2].ftype.new_type_flag; ;
    break;}
case 382:
#line 1697 "parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyval.ttype));
		  yyval.ttype = build_decl_list (NULL_TREE, yyval.ttype); ;
    break;}
case 383:
#line 1702 "parse.y"
{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ftype.t, yyval.ttype); ;
    break;}
case 384:
#line 1704 "parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
    break;}
case 385:
#line 1709 "parse.y"
{ yyval.ttype = decl_tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); ;
    break;}
case 386:
#line 1711 "parse.y"
{ yyval.ttype = decl_tree_cons (yyvsp[0].ttype, NULL_TREE, NULL_TREE); ;
    break;}
case 387:
#line 1730 "parse.y"
{ yyval.ttype = yyvsp[0].ftype.t; TREE_STATIC (yyval.ttype) = 1; ;
    break;}
case 388:
#line 1732 "parse.y"
{ yyval.ttype = hash_tree_cons (NULL_TREE, yyval.ttype, NULL_TREE); ;
    break;}
case 389:
#line 1734 "parse.y"
{ yyval.ttype = hash_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype);
		  TREE_STATIC (yyval.ttype) = 1; ;
    break;}
case 390:
#line 1737 "parse.y"
{ if (extra_warnings && TREE_STATIC (yyval.ttype))
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = hash_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype);
		  TREE_STATIC (yyval.ttype) = TREE_STATIC (yyvsp[-1].ttype); ;
    break;}
case 391:
#line 1743 "parse.y"
{ yyval.ttype = hash_tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); ;
    break;}
case 392:
#line 1745 "parse.y"
{ yyval.ttype = hash_tree_cons (yyvsp[0].ttype, NULL_TREE, NULL_TREE); ;
    break;}
case 393:
#line 1756 "parse.y"
{ yyval.ftype.t = build_decl_list (NULL_TREE, yyvsp[0].ftype.t); 
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag; ;
    break;}
case 394:
#line 1759 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[0].ftype.t, yyvsp[-1].ftype.t); 
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag; ;
    break;}
case 395:
#line 1762 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[-1].ftype.t, yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 396:
#line 1765 "parse.y"
{ yyval.ftype.t = decl_tree_cons (NULL_TREE, yyvsp[-1].ftype.t, chainon (yyvsp[0].ttype, yyvsp[-2].ftype.t)); 
		  yyval.ftype.new_type_flag = yyvsp[-2].ftype.new_type_flag; ;
    break;}
case 397:
#line 1771 "parse.y"
{ yyval.ttype = build_decl_list (NULL_TREE, yyvsp[0].ftype.t); ;
    break;}
case 398:
#line 1773 "parse.y"
{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ftype.t, yyvsp[-1].ttype); ;
    break;}
case 400:
#line 1783 "parse.y"
{ yyval.ftype.t = yyvsp[0].ttype; yyval.ftype.new_type_flag = 0; ;
    break;}
case 401:
#line 1785 "parse.y"
{ yyval.ftype.t = yyvsp[0].ttype; yyval.ftype.new_type_flag = 0; ;
    break;}
case 402:
#line 1787 "parse.y"
{ yyval.ftype.t = finish_typeof (yyvsp[-1].ttype);
		  yyval.ftype.new_type_flag = 0; ;
    break;}
case 403:
#line 1790 "parse.y"
{ yyval.ftype.t = groktypename (yyvsp[-1].ftype.t);
		  yyval.ftype.new_type_flag = 0; ;
    break;}
case 404:
#line 1793 "parse.y"
{ tree type = TREE_TYPE (yyvsp[-1].ttype);

                  yyval.ftype.new_type_flag = 0;
		  if (IS_AGGR_TYPE (type))
		    {
		      sorry ("sigof type specifier");
		      yyval.ftype.t = type;
		    }
		  else
		    {
		      error ("`sigof' applied to non-aggregate expression");
		      yyval.ftype.t = error_mark_node;
		    }
		;
    break;}
case 405:
#line 1808 "parse.y"
{ tree type = groktypename (yyvsp[-1].ftype.t);

                  yyval.ftype.new_type_flag = 0;
		  if (IS_AGGR_TYPE (type))
		    {
		      sorry ("sigof type specifier");
		      yyval.ftype.t = type;
		    }
		  else
		    {
		      error("`sigof' applied to non-aggregate type");
		      yyval.ftype.t = error_mark_node;
		    }
		;
    break;}
case 406:
#line 1828 "parse.y"
{ yyval.ftype.t = yyvsp[0].ttype; yyval.ftype.new_type_flag = 0; ;
    break;}
case 407:
#line 1830 "parse.y"
{ yyval.ftype.t = yyvsp[0].ttype; yyval.ftype.new_type_flag = 0; ;
    break;}
case 410:
#line 1837 "parse.y"
{ check_multiple_declarators (); ;
    break;}
case 412:
#line 1843 "parse.y"
{ check_multiple_declarators (); ;
    break;}
case 414:
#line 1849 "parse.y"
{ check_multiple_declarators (); ;
    break;}
case 415:
#line 1854 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 416:
#line 1856 "parse.y"
{ if (TREE_CHAIN (yyvsp[-1].ttype)) yyvsp[-1].ttype = combine_strings (yyvsp[-1].ttype); yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 417:
#line 1861 "parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes); ;
    break;}
case 418:
#line 1865 "parse.y"
{ cp_finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype, LOOKUP_ONLYCONVERTING); ;
    break;}
case 419:
#line 1867 "parse.y"
{ yyval.ttype = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
					  yyvsp[0].ttype, prefix_attributes);
		  cp_finish_decl (yyval.ttype, NULL_TREE, yyvsp[-1].ttype, 0); ;
    break;}
case 420:
#line 1880 "parse.y"
{ parse_decl (yyvsp[-3].ttype, yyvsp[-4].ttype, yyvsp[-1].ttype, 1, &yyval.ttype); ;
    break;}
case 421:
#line 1884 "parse.y"
{ cp_finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype,
				  LOOKUP_ONLYCONVERTING); ;
    break;}
case 422:
#line 1887 "parse.y"
{ tree d;
		  parse_decl (yyvsp[-2].ttype, yyvsp[-3].ttype, yyvsp[0].ttype, 0, &d);
		  cp_finish_decl (d, NULL_TREE, yyvsp[-1].ttype, 0); ;
    break;}
case 423:
#line 1894 "parse.y"
{;
    break;}
case 424:
#line 1899 "parse.y"
{;
    break;}
case 425:
#line 1904 "parse.y"
{ /* Set things up as initdcl0_innards expects.  */
	      yyvsp[0].ttype = yyvsp[-1].ttype; 
              yyvsp[-1].ttype = NULL_TREE; ;
    break;}
case 426:
#line 1908 "parse.y"
{;
    break;}
case 427:
#line 1910 "parse.y"
{ tree d;
		  parse_decl(yyvsp[-2].ttype, NULL_TREE, yyvsp[0].ttype, 0, &d);
		  cp_finish_decl (d, NULL_TREE, yyvsp[-1].ttype, 0); ;
    break;}
case 428:
#line 1919 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 429:
#line 1921 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 430:
#line 1926 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 431:
#line 1928 "parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 432:
#line 1933 "parse.y"
{ yyval.ttype = yyvsp[-2].ttype; ;
    break;}
case 433:
#line 1938 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 434:
#line 1940 "parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); ;
    break;}
case 435:
#line 1945 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 436:
#line 1947 "parse.y"
{ yyval.ttype = build_tree_list (yyvsp[0].ttype, NULL_TREE); ;
    break;}
case 437:
#line 1949 "parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, build_tree_list (NULL_TREE, yyvsp[-1].ttype)); ;
    break;}
case 438:
#line 1951 "parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-5].ttype, tree_cons (NULL_TREE, yyvsp[-3].ttype, yyvsp[-1].ttype)); ;
    break;}
case 439:
#line 1953 "parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 444:
#line 1969 "parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 445:
#line 1971 "parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); ;
    break;}
case 446:
#line 1976 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 447:
#line 1978 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 449:
#line 1986 "parse.y"
{ yyval.ttype = build_nt (CONSTRUCTOR, NULL_TREE, NULL_TREE);
		  TREE_HAS_CONSTRUCTOR (yyval.ttype) = 1; ;
    break;}
case 450:
#line 1989 "parse.y"
{ yyval.ttype = build_nt (CONSTRUCTOR, NULL_TREE, nreverse (yyvsp[-1].ttype));
		  TREE_HAS_CONSTRUCTOR (yyval.ttype) = 1; ;
    break;}
case 451:
#line 1992 "parse.y"
{ yyval.ttype = build_nt (CONSTRUCTOR, NULL_TREE, nreverse (yyvsp[-2].ttype));
		  TREE_HAS_CONSTRUCTOR (yyval.ttype) = 1; ;
    break;}
case 452:
#line 1995 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 453:
#line 2002 "parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyval.ttype); ;
    break;}
case 454:
#line 2004 "parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
    break;}
case 455:
#line 2007 "parse.y"
{ yyval.ttype = build_expr_list (yyvsp[-2].ttype, yyvsp[0].ttype); ;
    break;}
case 456:
#line 2009 "parse.y"
{ yyval.ttype = build_expr_list (yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 457:
#line 2011 "parse.y"
{ yyval.ttype = tree_cons (yyvsp[-2].ttype, yyvsp[0].ttype, yyval.ttype); ;
    break;}
case 458:
#line 2016 "parse.y"
{ start_function (NULL_TREE, yyvsp[0].pi->fndecl, NULL_TREE, 
				  (SF_DEFAULT | SF_PRE_PARSED 
				   | SF_INCLASS_INLINE));
		  reinit_parse_for_function (); ;
    break;}
case 459:
#line 2023 "parse.y"
{
		  expand_body (finish_function (lineno, (int)yyvsp[-1].itype | 2));
		  process_next_inline (yyvsp[-3].pi);
		;
    break;}
case 460:
#line 2028 "parse.y"
{ 
		  expand_body (finish_function (lineno, (int)yyvsp[0].itype | 2)); 
                  process_next_inline (yyvsp[-2].pi);
		;
    break;}
case 461:
#line 2033 "parse.y"
{ 
		  finish_function (lineno, 2); 
		  process_next_inline (yyvsp[-2].pi); ;
    break;}
case 464:
#line 2047 "parse.y"
{ replace_defarg (yyvsp[-2].ttype, yyvsp[-1].ttype); ;
    break;}
case 465:
#line 2049 "parse.y"
{ replace_defarg (yyvsp[-2].ttype, error_mark_node); ;
    break;}
case 467:
#line 2054 "parse.y"
{ do_pending_defargs (); ;
    break;}
case 468:
#line 2056 "parse.y"
{ do_pending_defargs (); ;
    break;}
case 469:
#line 2061 "parse.y"
{ yyval.ttype = current_enum_type;
		  current_enum_type = start_enum (yyvsp[-1].ttype); ;
    break;}
case 470:
#line 2064 "parse.y"
{ yyval.ftype.t = finish_enum (current_enum_type);
		  yyval.ftype.new_type_flag = 1;
		  current_enum_type = yyvsp[-2].ttype;
		  check_for_missing_semicolon (yyval.ftype.t); ;
    break;}
case 471:
#line 2069 "parse.y"
{ yyval.ttype = current_enum_type;
		  current_enum_type = start_enum (make_anon_name ()); ;
    break;}
case 472:
#line 2072 "parse.y"
{ yyval.ftype.t = finish_enum (current_enum_type);
		  yyval.ftype.new_type_flag = 1;
		  current_enum_type = yyvsp[-2].ttype;
		  check_for_missing_semicolon (yyval.ftype.t); ;
    break;}
case 473:
#line 2077 "parse.y"
{ yyval.ftype.t = xref_tag (enum_type_node, yyvsp[0].ttype, 1); 
		  yyval.ftype.new_type_flag = 0; ;
    break;}
case 474:
#line 2080 "parse.y"
{ yyval.ftype.t = xref_tag (enum_type_node, yyvsp[0].ttype, 1); 
		  yyval.ftype.new_type_flag = 0; ;
    break;}
case 475:
#line 2083 "parse.y"
{ yyval.ftype.t = yyvsp[0].ttype;
		  yyval.ftype.new_type_flag = 0; 
		  if (!processing_template_decl)
		    cp_pedwarn ("using `typename' outside of template"); ;
    break;}
case 476:
#line 2089 "parse.y"
{ yyvsp[-1].ftype.t = begin_class_definition (yyvsp[-1].ftype.t); ;
    break;}
case 477:
#line 2091 "parse.y"
{ 
		  int semi;

		  if (yychar == YYEMPTY)
		    yychar = YYLEX;
		  semi = yychar == ';';

		  yyval.ttype = finish_class_definition (yyvsp[-5].ftype.t, yyvsp[0].ttype, semi,
						       yyvsp[-5].ftype.new_type_flag); 
		;
    break;}
case 478:
#line 2102 "parse.y"
{
		  begin_inline_definitions ();
		;
    break;}
case 479:
#line 2106 "parse.y"
{
		  finish_inline_definitions ();
		  yyval.ftype.t = yyvsp[-3].ttype;
		  yyval.ftype.new_type_flag = 1; 
		;
    break;}
case 480:
#line 2112 "parse.y"
{
		  if (yyvsp[0].ftype.new_type_flag && yyvsp[0].ftype.t != error_mark_node)
		    pop_scope (CP_DECL_CONTEXT (TYPE_MAIN_DECL (yyvsp[0].ftype.t)));
		  yyval.ftype.new_type_flag = 0;
		  if (yyvsp[0].ftype.t == error_mark_node)
		    yyval.ftype.t = yyvsp[0].ftype.t;
		  else if (TYPE_BINFO (yyvsp[0].ftype.t) == NULL_TREE)
		    {
		      cp_error ("%T is not a class type", yyvsp[0].ftype.t);
		      yyval.ftype.t = error_mark_node;
		    } 
		  else
		    {
		      yyval.ftype.t = yyvsp[0].ftype.t;
		      /* struct B: public A; is not accepted by the WP grammar.  */
		      if (TYPE_BINFO_BASETYPES (yyval.ftype.t) && !TYPE_SIZE (yyval.ftype.t)
			  && ! TYPE_BEING_DEFINED (yyval.ftype.t))
			cp_error ("base clause without member specification for `%#T'",
				  yyval.ftype.t);
		    }
		;
    break;}
case 484:
#line 2143 "parse.y"
{ if (pedantic && !in_system_header)
		    pedwarn ("comma at end of enumerator list"); ;
    break;}
case 486:
#line 2150 "parse.y"
{ error ("storage class specifier `%s' not allowed after struct or class", IDENTIFIER_POINTER (yyvsp[0].ttype)); ;
    break;}
case 487:
#line 2152 "parse.y"
{ error ("type specifier `%s' not allowed after struct or class", IDENTIFIER_POINTER (yyvsp[0].ttype)); ;
    break;}
case 488:
#line 2154 "parse.y"
{ error ("type qualifier `%s' not allowed after struct or class", IDENTIFIER_POINTER (yyvsp[0].ttype)); ;
    break;}
case 489:
#line 2156 "parse.y"
{ error ("no body nor ';' separates two class, struct or union declarations"); ;
    break;}
case 490:
#line 2158 "parse.y"
{ yyval.ttype = build_decl_list (yyvsp[0].ttype, yyvsp[-1].ttype); ;
    break;}
case 491:
#line 2163 "parse.y"
{ 
		  current_aggr = yyvsp[-1].ttype; 
		  yyval.ttype = yyvsp[0].ttype; 
		;
    break;}
case 492:
#line 2171 "parse.y"
{ current_aggr = yyval.ttype; yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 493:
#line 2173 "parse.y"
{ yyungetc ('{', 1); ;
    break;}
case 494:
#line 2175 "parse.y"
{ yyungetc (':', 1); ;
    break;}
case 495:
#line 2180 "parse.y"
{
		  current_aggr = yyvsp[-2].ttype;
		  yyval.ftype.t = handle_class_head (yyvsp[-2].ttype, yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ftype.new_type_flag = 1;
		;
    break;}
case 496:
#line 2186 "parse.y"
{
		  current_aggr = yyvsp[-3].ttype;
		  yyval.ftype.t = handle_class_head (yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ftype.new_type_flag = 1;
		;
    break;}
case 497:
#line 2192 "parse.y"
{
		  current_aggr = yyvsp[-2].ttype;
		  yyval.ftype.t = handle_class_head (yyvsp[-2].ttype, NULL_TREE, yyvsp[0].ttype);
		  yyval.ftype.new_type_flag = 1;
		;
    break;}
case 498:
#line 2198 "parse.y"
{ 
		  current_aggr = yyvsp[-1].ttype; 
		  yyval.ftype.t = yyvsp[0].ttype;
		  yyval.ftype.new_type_flag = 0;
		;
    break;}
case 499:
#line 2204 "parse.y"
{ 
		  current_aggr = yyvsp[-2].ttype; 
		  yyval.ftype.t = yyvsp[0].ttype;
		  if (CP_DECL_CONTEXT (yyval.ftype.t))
		    push_scope (CP_DECL_CONTEXT (yyval.ftype.t));
		  yyval.ftype.new_type_flag = 1;
		;
    break;}
case 500:
#line 2215 "parse.y"
{ 
		  yyval.ftype.t = xref_tag (current_aggr, yyvsp[0].ttype, 1); 
		  yyval.ftype.new_type_flag = 0;
		;
    break;}
case 501:
#line 2220 "parse.y"
{ yyval.ttype = xref_tag (current_aggr, yyvsp[0].ttype, 0); ;
    break;}
case 502:
#line 2224 "parse.y"
{ 
		  yyval.ftype.t = yyvsp[-1].ttype;
		  yyval.ftype.new_type_flag = 0;
		  if (yyvsp[0].ttype)
                    xref_basetypes (current_aggr, yyvsp[-2].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); 
		;
    break;}
case 503:
#line 2232 "parse.y"
{ 
		  if (yyvsp[-1].ftype.t != error_mark_node)
		    {
		      yyval.ftype.t = TREE_TYPE (yyvsp[-1].ftype.t);
		      yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag;
		      if (current_aggr == union_type_node
			  && TREE_CODE (yyval.ftype.t) != UNION_TYPE)
			cp_pedwarn ("`union' tag used in declaring `%#T'", 
				    yyval.ftype.t);
		      else if (TREE_CODE (yyval.ftype.t) == UNION_TYPE
			       && current_aggr != union_type_node)
			cp_pedwarn ("non-`union' tag used in declaring `%#T'", yyval.ftype);
		      else if (TREE_CODE (yyval.ftype.t) == RECORD_TYPE)
			/* We might be specializing a template with a different
			   class-key; deal.  */
			CLASSTYPE_DECLARED_CLASS (yyval.ftype.t) 
			  = (current_aggr == class_type_node);
		      if (yyvsp[0].ttype)
			{
			  maybe_process_partial_specialization (yyval.ftype.t);
			  xref_basetypes (current_aggr, yyvsp[-1].ftype.t, yyval.ftype.t, yyvsp[0].ttype); 
			}
		    }
		;
    break;}
case 504:
#line 2260 "parse.y"
{ yyval.ttype = xref_tag (yyval.ttype, make_anon_name (), 0);
		  yyungetc ('{', 1); ;
    break;}
case 505:
#line 2270 "parse.y"
{
		  yyval.ftype.t = yyvsp[0].ttype;
		  yyval.ftype.new_type_flag = 0;
		;
    break;}
case 507:
#line 2279 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 508:
#line 2281 "parse.y"
{ yyungetc(':', 1); yyval.ttype = NULL_TREE; ;
    break;}
case 509:
#line 2283 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 511:
#line 2289 "parse.y"
{ yyval.ttype = chainon (yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 512:
#line 2294 "parse.y"
{ yyval.ttype = finish_base_specifier (access_default_node, yyvsp[0].ttype); ;
    break;}
case 513:
#line 2296 "parse.y"
{ yyval.ttype = finish_base_specifier (yyvsp[-2].ttype, yyvsp[0].ttype); ;
    break;}
case 514:
#line 2301 "parse.y"
{ if (yyval.ttype != error_mark_node) yyval.ttype = TYPE_MAIN_DECL (yyvsp[0].ttype); ;
    break;}
case 517:
#line 2308 "parse.y"
{ if (yyvsp[-1].ttype != ridpointers[(int)RID_VIRTUAL])
		    cp_error ("`%D' access", yyvsp[-1].ttype);
		  yyval.ttype = access_default_virtual_node; ;
    break;}
case 518:
#line 2312 "parse.y"
{
		  if (yyvsp[-2].ttype != access_default_virtual_node)
		    error ("multiple access specifiers");
		  else if (yyvsp[-1].ttype == access_public_node)
		    yyval.ttype = access_public_virtual_node;
		  else if (yyvsp[-1].ttype == access_protected_node)
		    yyval.ttype = access_protected_virtual_node;
		  else /* $2 == access_private_node */
		    yyval.ttype = access_private_virtual_node;
		;
    break;}
case 519:
#line 2323 "parse.y"
{ if (yyvsp[-1].ttype != ridpointers[(int)RID_VIRTUAL])
		    cp_error ("`%D' access", yyvsp[-1].ttype);
		  else if (yyval.ttype == access_public_node)
		    yyval.ttype = access_public_virtual_node;
		  else if (yyval.ttype == access_protected_node)
		    yyval.ttype = access_protected_virtual_node;
		  else if (yyval.ttype == access_private_node)
		    yyval.ttype = access_private_virtual_node;
		  else
		    error ("multiple `virtual' specifiers");
		;
    break;}
case 524:
#line 2344 "parse.y"
{
		  current_access_specifier = yyvsp[-1].ttype;
                ;
    break;}
case 525:
#line 2353 "parse.y"
{ 
		  finish_member_declaration (yyvsp[0].ttype);
		;
    break;}
case 526:
#line 2357 "parse.y"
{ 
		  finish_member_declaration (yyvsp[0].ttype);
		;
    break;}
case 528:
#line 2365 "parse.y"
{ error ("missing ';' before right brace");
		  yyungetc ('}', 0); ;
    break;}
case 529:
#line 2370 "parse.y"
{ yyval.ttype = finish_method (yyval.ttype); ;
    break;}
case 530:
#line 2372 "parse.y"
{ yyval.ttype = finish_method (yyval.ttype); ;
    break;}
case 531:
#line 2374 "parse.y"
{ yyval.ttype = finish_method (yyval.ttype); ;
    break;}
case 532:
#line 2376 "parse.y"
{ yyval.ttype = finish_method (yyval.ttype); ;
    break;}
case 533:
#line 2378 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 534:
#line 2380 "parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; ;
    break;}
case 535:
#line 2383 "parse.y"
{  
		  if (yyvsp[0].ttype)
		    yyval.ttype = finish_member_template_decl (yyvsp[0].ttype);
		  else
		    /* The component was already processed.  */
		    yyval.ttype = NULL_TREE;

		  finish_template_decl (yyvsp[-1].ttype);
		;
    break;}
case 536:
#line 2393 "parse.y"
{ 
		  yyval.ttype = finish_member_class_template (yyvsp[-1].ftype.t); 
		  finish_template_decl (yyvsp[-2].ttype);
		;
    break;}
case 537:
#line 2404 "parse.y"
{
		  /* Most of the productions for component_decl only
		     allow the creation of one new member, so we call
		     finish_member_declaration in component_decl_list.
		     For this rule and the next, however, there can be
		     more than one member, e.g.:

		       int i, j;

		     and we need the first member to be fully
		     registered before the second is processed.
		     Therefore, the rules for components take care of
		     this processing.  To avoid registering the
		     components more than once, we send NULL_TREE up
		     here; that lets finish_member_declaration know
		     that there is nothing to do.  */
		  if (!yyvsp[0].itype)
		    grok_x_components (yyvsp[-1].ftype.t);
		  yyval.ttype = NULL_TREE;
		;
    break;}
case 538:
#line 2425 "parse.y"
{ 
		  if (!yyvsp[0].itype)
		    grok_x_components (yyvsp[-1].ttype);
		  yyval.ttype = NULL_TREE; 
		;
    break;}
case 539:
#line 2431 "parse.y"
{ yyval.ttype = grokfield (yyval.ttype, NULL_TREE, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, NULL_TREE)); ;
    break;}
case 540:
#line 2434 "parse.y"
{ yyval.ttype = grokfield (yyval.ttype, NULL_TREE, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, NULL_TREE)); ;
    break;}
case 541:
#line 2437 "parse.y"
{ yyval.ttype = grokbitfield (NULL_TREE, NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 542:
#line 2439 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 543:
#line 2450 "parse.y"
{ tree specs, attrs;
		  split_specs_attrs (yyvsp[-4].ttype, &specs, &attrs);
		  yyval.ttype = grokfield (yyvsp[-3].ttype, specs, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, attrs)); ;
    break;}
case 544:
#line 2455 "parse.y"
{ yyval.ttype = grokfield (yyval.ttype, NULL_TREE, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, NULL_TREE)); ;
    break;}
case 545:
#line 2458 "parse.y"
{ yyval.ttype = do_class_using_decl (yyvsp[0].ttype); ;
    break;}
case 546:
#line 2464 "parse.y"
{ yyval.itype = 0; ;
    break;}
case 547:
#line 2466 "parse.y"
{ 
		  if (PROCESSING_REAL_TEMPLATE_DECL_P ())
		    yyvsp[0].ttype = finish_member_template_decl (yyvsp[0].ttype);
		  finish_member_declaration (yyvsp[0].ttype); 
		  yyval.itype = 1;
		;
    break;}
case 548:
#line 2473 "parse.y"
{ 
		  check_multiple_declarators ();
		  if (PROCESSING_REAL_TEMPLATE_DECL_P ())
		    yyvsp[0].ttype = finish_member_template_decl (yyvsp[0].ttype);
		  finish_member_declaration (yyvsp[0].ttype);
		  yyval.itype = 2;
		;
    break;}
case 549:
#line 2484 "parse.y"
{ yyval.itype = 0; ;
    break;}
case 550:
#line 2486 "parse.y"
{ 
		  if (PROCESSING_REAL_TEMPLATE_DECL_P ())
		    yyvsp[0].ttype = finish_member_template_decl (yyvsp[0].ttype);
		  finish_member_declaration (yyvsp[0].ttype);
		  yyval.itype = 1;
		;
    break;}
case 551:
#line 2493 "parse.y"
{ 
		  check_multiple_declarators ();
		  if (PROCESSING_REAL_TEMPLATE_DECL_P ())
		    yyvsp[0].ttype = finish_member_template_decl (yyvsp[0].ttype);
		  finish_member_declaration (yyvsp[0].ttype); 
		  yyval.itype = 2;
		;
    break;}
case 556:
#line 2514 "parse.y"
{ split_specs_attrs (yyvsp[-4].ttype, &current_declspecs,
				     &prefix_attributes);
		  yyvsp[-4].ttype = current_declspecs;
		  yyval.ttype = grokfield (yyval.ttype, current_declspecs, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, prefix_attributes)); ;
    break;}
case 557:
#line 2520 "parse.y"
{ split_specs_attrs (yyvsp[-4].ttype, &current_declspecs,
				     &prefix_attributes);
		  yyvsp[-4].ttype = current_declspecs;
		  yyval.ttype = grokbitfield (yyval.ttype, current_declspecs, yyvsp[-1].ttype);
		  cplus_decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); ;
    break;}
case 558:
#line 2529 "parse.y"
{ split_specs_attrs (yyvsp[-4].ttype, &current_declspecs,
				     &prefix_attributes);
		  yyvsp[-4].ttype = current_declspecs;
		  yyval.ttype = grokfield (yyval.ttype, current_declspecs, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, prefix_attributes)); ;
    break;}
case 559:
#line 2535 "parse.y"
{ split_specs_attrs (yyvsp[-4].ttype, &current_declspecs,
				     &prefix_attributes);
		  yyvsp[-4].ttype = current_declspecs;
		  yyval.ttype = grokfield (yyval.ttype, current_declspecs, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, prefix_attributes)); ;
    break;}
case 560:
#line 2541 "parse.y"
{ split_specs_attrs (yyvsp[-4].ttype, &current_declspecs,
				     &prefix_attributes);
		  yyvsp[-4].ttype = current_declspecs;
		  yyval.ttype = grokbitfield (yyval.ttype, current_declspecs, yyvsp[-1].ttype);
		  cplus_decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); ;
    break;}
case 561:
#line 2547 "parse.y"
{ split_specs_attrs (yyvsp[-3].ttype, &current_declspecs,
				     &prefix_attributes);
		  yyvsp[-3].ttype = current_declspecs;
		  yyval.ttype = grokbitfield (NULL_TREE, current_declspecs, yyvsp[-1].ttype);
		  cplus_decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); ;
    break;}
case 562:
#line 2556 "parse.y"
{ yyval.ttype = grokfield (yyval.ttype, current_declspecs, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, prefix_attributes)); ;
    break;}
case 563:
#line 2559 "parse.y"
{ yyval.ttype = grokbitfield (yyval.ttype, current_declspecs, yyvsp[-1].ttype);
		  cplus_decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); ;
    break;}
case 564:
#line 2565 "parse.y"
{ yyval.ttype = grokfield (yyval.ttype, current_declspecs, yyvsp[0].ttype, yyvsp[-2].ttype,
				  build_tree_list (yyvsp[-1].ttype, prefix_attributes)); ;
    break;}
case 565:
#line 2568 "parse.y"
{ yyval.ttype = grokbitfield (yyval.ttype, current_declspecs, yyvsp[-1].ttype);
		  cplus_decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); ;
    break;}
case 566:
#line 2571 "parse.y"
{ yyval.ttype = grokbitfield (NULL_TREE, current_declspecs, yyvsp[-1].ttype);
		  cplus_decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); ;
    break;}
case 571:
#line 2591 "parse.y"
{ build_enumerator (yyvsp[0].ttype, NULL_TREE, current_enum_type); ;
    break;}
case 572:
#line 2593 "parse.y"
{ build_enumerator (yyvsp[-2].ttype, yyvsp[0].ttype, current_enum_type); ;
    break;}
case 573:
#line 2599 "parse.y"
{ yyval.ftype.t = build_decl_list (yyvsp[-1].ftype.t, yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 574:
#line 2602 "parse.y"
{ yyval.ftype.t = build_decl_list (yyvsp[0].ftype.t, NULL_TREE); 
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag; ;
    break;}
case 575:
#line 2607 "parse.y"
{
		  if (pedantic)
		    pedwarn ("ANSI C++ forbids array dimensions with parenthesized type in new");
		  yyval.ftype.t = build_parse_node (ARRAY_REF, TREE_VALUE (yyvsp[-4].ftype.t), yyvsp[-1].ttype);
		  yyval.ftype.t = build_decl_list (TREE_PURPOSE (yyvsp[-4].ftype.t), yyval.ftype.t);
		  yyval.ftype.new_type_flag = yyvsp[-4].ftype.new_type_flag;
		;
    break;}
case 576:
#line 2618 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 577:
#line 2620 "parse.y"
{ yyval.ttype = decl_tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
    break;}
case 578:
#line 2625 "parse.y"
{ yyval.ftype.t = hash_tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE);
		  yyval.ftype.new_type_flag = 0; ;
    break;}
case 579:
#line 2628 "parse.y"
{ yyval.ftype.t = hash_tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ftype.t); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 580:
#line 2638 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 581:
#line 2640 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 582:
#line 2642 "parse.y"
{ yyval.ttype = empty_parms (); ;
    break;}
case 583:
#line 2644 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 585:
#line 2652 "parse.y"
{
		  /* Provide support for '(' attributes '*' declarator ')'
		     etc */
		  yyval.ttype = decl_tree_cons (yyvsp[-1].ttype, yyvsp[0].ttype, NULL_TREE);
		;
    break;}
case 586:
#line 2662 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 587:
#line 2664 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 588:
#line 2666 "parse.y"
{ yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 589:
#line 2668 "parse.y"
{ yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 590:
#line 2670 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
		;
    break;}
case 592:
#line 2678 "parse.y"
{ yyval.ttype = make_call_declarator (yyval.ttype, yyvsp[-2].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 593:
#line 2680 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
    break;}
case 594:
#line 2682 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
    break;}
case 595:
#line 2684 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 596:
#line 2686 "parse.y"
{ push_nested_class (yyvsp[-1].ttype, 3);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyval.ttype, yyvsp[0].ttype);
		  TREE_COMPLEXITY (yyval.ttype) = current_class_depth; ;
    break;}
case 598:
#line 2694 "parse.y"
{
		  if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
		    {
		      yyval.ttype = lookup_name (yyvsp[0].ttype, 1);
		      maybe_note_name_used_in_class (yyvsp[0].ttype, yyval.ttype);
		    }
		  else
		    yyval.ttype = yyvsp[0].ttype;
		;
    break;}
case 599:
#line 2704 "parse.y"
{
		  if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
		    yyval.ttype = IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype);
		  else
		    yyval.ttype = yyvsp[0].ttype;
		  got_scope = NULL_TREE;
		;
    break;}
case 602:
#line 2717 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 603:
#line 2722 "parse.y"
{ yyval.ttype = get_type_decl (yyvsp[0].ttype); ;
    break;}
case 605:
#line 2731 "parse.y"
{
		  /* Provide support for '(' attributes '*' declarator ')'
		     etc */
		  yyval.ttype = decl_tree_cons (yyvsp[-1].ttype, yyvsp[0].ttype, NULL_TREE);
		;
    break;}
case 606:
#line 2740 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 607:
#line 2742 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 608:
#line 2744 "parse.y"
{ yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 609:
#line 2746 "parse.y"
{ yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 610:
#line 2748 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
		;
    break;}
case 612:
#line 2756 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 613:
#line 2758 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 614:
#line 2760 "parse.y"
{ yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 615:
#line 2762 "parse.y"
{ yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 616:
#line 2764 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
		;
    break;}
case 618:
#line 2772 "parse.y"
{ yyval.ttype = make_call_declarator (yyval.ttype, yyvsp[-2].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 619:
#line 2774 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 620:
#line 2776 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
    break;}
case 621:
#line 2778 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
    break;}
case 622:
#line 2780 "parse.y"
{ enter_scope_of (yyvsp[0].ttype); ;
    break;}
case 623:
#line 2782 "parse.y"
{ got_scope = NULL_TREE;
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, yyvsp[0].ttype);
		  enter_scope_of (yyval.ttype);
		;
    break;}
case 624:
#line 2790 "parse.y"
{ got_scope = NULL_TREE;
		  yyval.ttype = build_parse_node (SCOPE_REF, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 625:
#line 2793 "parse.y"
{ got_scope = NULL_TREE;
 		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 626:
#line 2799 "parse.y"
{ got_scope = NULL_TREE;
		  yyval.ttype = build_parse_node (SCOPE_REF, yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 627:
#line 2802 "parse.y"
{ got_scope = NULL_TREE;
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 629:
#line 2809 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 630:
#line 2814 "parse.y"
{ yyval.ttype = build_functional_cast (yyvsp[-3].ftype.t, yyvsp[-1].ttype); ;
    break;}
case 631:
#line 2816 "parse.y"
{ yyval.ttype = reparse_decl_as_expr (yyvsp[-3].ftype.t, yyvsp[-1].ttype); ;
    break;}
case 632:
#line 2818 "parse.y"
{ yyval.ttype = reparse_absdcl_as_expr (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 637:
#line 2829 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 638:
#line 2831 "parse.y"
{ got_scope = yyval.ttype 
		    = make_typename_type (yyvsp[-3].ttype, yyvsp[-1].ttype, /*complain=*/1); ;
    break;}
case 639:
#line 2839 "parse.y"
{
		  if (TREE_CODE (yyvsp[-1].ttype) == IDENTIFIER_NODE)
		    {
		      yyval.ttype = lastiddecl;
		      maybe_note_name_used_in_class (yyvsp[-1].ttype, yyval.ttype);
		    }
		  got_scope = yyval.ttype =
		    complete_type (TYPE_MAIN_VARIANT (TREE_TYPE (yyval.ttype)));
		;
    break;}
case 640:
#line 2849 "parse.y"
{
		  if (TREE_CODE (yyvsp[-1].ttype) == IDENTIFIER_NODE)
		    yyval.ttype = lastiddecl;
		  got_scope = yyval.ttype = TREE_TYPE (yyval.ttype);
		;
    break;}
case 641:
#line 2855 "parse.y"
{
		  if (TREE_CODE (yyval.ttype) == IDENTIFIER_NODE)
		    yyval.ttype = lastiddecl;
		  got_scope = yyval.ttype;
		;
    break;}
case 642:
#line 2861 "parse.y"
{ got_scope = yyval.ttype = complete_type (TREE_TYPE (yyvsp[-1].ttype)); ;
    break;}
case 644:
#line 2877 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 645:
#line 2882 "parse.y"
{
		  if (TREE_CODE_CLASS (TREE_CODE (yyvsp[-1].ttype)) == 't')
		    yyval.ttype = make_typename_type (yyvsp[-1].ttype, yyvsp[0].ttype, /*complain=*/1);
		  else if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
		    cp_error ("`%T' is not a class or namespace", yyvsp[0].ttype);
		  else
		    {
		      yyval.ttype = yyvsp[0].ttype;
		      if (TREE_CODE (yyval.ttype) == TYPE_DECL)
			yyval.ttype = TREE_TYPE (yyval.ttype);
		    }
		;
    break;}
case 646:
#line 2895 "parse.y"
{ yyval.ttype = TREE_TYPE (yyvsp[0].ttype); ;
    break;}
case 647:
#line 2897 "parse.y"
{ yyval.ttype = make_typename_type (yyvsp[-1].ttype, yyvsp[0].ttype, /*complain=*/1); ;
    break;}
case 648:
#line 2899 "parse.y"
{ yyval.ttype = make_typename_type (yyvsp[-2].ttype, yyvsp[0].ttype, /*complain=*/1); ;
    break;}
case 649:
#line 2904 "parse.y"
{
		  if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
		    cp_error ("`%T' is not a class or namespace", yyvsp[0].ttype);
		;
    break;}
case 650:
#line 2909 "parse.y"
{
		  if (TREE_CODE_CLASS (TREE_CODE (yyvsp[-1].ttype)) == 't')
		    yyval.ttype = make_typename_type (yyvsp[-1].ttype, yyvsp[0].ttype, /*complain=*/1);
		  else if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
		    cp_error ("`%T' is not a class or namespace", yyvsp[0].ttype);
		  else
		    {
		      yyval.ttype = yyvsp[0].ttype;
		      if (TREE_CODE (yyval.ttype) == TYPE_DECL)
			yyval.ttype = TREE_TYPE (yyval.ttype);
		    }
		;
    break;}
case 651:
#line 2922 "parse.y"
{ got_scope = yyval.ttype 
		    = make_typename_type (yyvsp[-2].ttype, yyvsp[-1].ttype, /*complain=*/1); ;
    break;}
case 652:
#line 2925 "parse.y"
{ got_scope = yyval.ttype 
		    = make_typename_type (yyvsp[-3].ttype, yyvsp[-1].ttype, /*complain=*/1); ;
    break;}
case 653:
#line 2931 "parse.y"
{
		  if (TREE_CODE (yyvsp[-1].ttype) != IDENTIFIER_NODE)
		    yyvsp[-1].ttype = lastiddecl;

		  /* Retrieve the type for the identifier, which might involve
		     some computation. */
		  got_scope = yyval.ttype = complete_type (IDENTIFIER_TYPE_VALUE (yyvsp[-1].ttype));

		  if (yyval.ttype == error_mark_node)
		    cp_error ("`%T' is not a class or namespace", yyvsp[-1].ttype);
		;
    break;}
case 654:
#line 2943 "parse.y"
{
		  if (TREE_CODE (yyvsp[-1].ttype) != IDENTIFIER_NODE)
		    yyval.ttype = lastiddecl;
		  got_scope = yyval.ttype = complete_type (TREE_TYPE (yyval.ttype));
		;
    break;}
case 655:
#line 2949 "parse.y"
{ got_scope = yyval.ttype = complete_type (TREE_TYPE (yyval.ttype)); ;
    break;}
case 658:
#line 2953 "parse.y"
{
		  if (TREE_CODE (yyval.ttype) == IDENTIFIER_NODE)
		    yyval.ttype = lastiddecl;
		  got_scope = yyval.ttype;
		;
    break;}
case 659:
#line 2962 "parse.y"
{ yyval.ttype = build_min_nt (TEMPLATE_ID_EXPR, yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 660:
#line 2967 "parse.y"
{
		  if (TREE_CODE (yyvsp[0].ttype) == IDENTIFIER_NODE)
		    yyval.ttype = IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype);
		  else
		    yyval.ttype = yyvsp[0].ttype;
		  got_scope = NULL_TREE;
		;
    break;}
case 662:
#line 2976 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 663:
#line 2981 "parse.y"
{ got_scope = NULL_TREE; ;
    break;}
case 664:
#line 2983 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; got_scope = NULL_TREE; ;
    break;}
case 665:
#line 2990 "parse.y"
{ got_scope = void_type_node; ;
    break;}
case 666:
#line 2996 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 667:
#line 2998 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); ;
    break;}
case 668:
#line 3000 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 669:
#line 3002 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[0].ttype, NULL_TREE); ;
    break;}
case 670:
#line 3004 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, arg);
		;
    break;}
case 671:
#line 3008 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
		;
    break;}
case 673:
#line 3017 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); ;
    break;}
case 674:
#line 3019 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
    break;}
case 676:
#line 3025 "parse.y"
{
		  /* Provide support for '(' attributes '*' declarator ')'
		     etc */
		  yyval.ttype = decl_tree_cons (yyvsp[-1].ttype, yyvsp[0].ttype, NULL_TREE);
		;
    break;}
case 677:
#line 3035 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 678:
#line 3037 "parse.y"
{ yyval.ttype = make_pointer_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 679:
#line 3039 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[0].ftype.t, NULL_TREE); ;
    break;}
case 680:
#line 3041 "parse.y"
{ yyval.ttype = make_pointer_declarator (NULL_TREE, NULL_TREE); ;
    break;}
case 681:
#line 3043 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 682:
#line 3045 "parse.y"
{ yyval.ttype = make_reference_declarator (NULL_TREE, yyvsp[0].ttype); ;
    break;}
case 683:
#line 3047 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[0].ftype.t, NULL_TREE); ;
    break;}
case 684:
#line 3049 "parse.y"
{ yyval.ttype = make_reference_declarator (NULL_TREE, NULL_TREE); ;
    break;}
case 685:
#line 3051 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-1].ttype, arg);
		;
    break;}
case 686:
#line 3055 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
		;
    break;}
case 688:
#line 3064 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 689:
#line 3067 "parse.y"
{ yyval.ttype = make_call_declarator (yyval.ttype, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 690:
#line 3069 "parse.y"
{ yyval.ttype = make_call_declarator (yyval.ttype, empty_parms (), yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 691:
#line 3071 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, yyvsp[-1].ttype); ;
    break;}
case 692:
#line 3073 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, yyval.ttype, NULL_TREE); ;
    break;}
case 693:
#line 3075 "parse.y"
{ yyval.ttype = make_call_declarator (NULL_TREE, yyvsp[-3].ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 694:
#line 3077 "parse.y"
{ set_quals_and_spec (yyval.ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 695:
#line 3079 "parse.y"
{ set_quals_and_spec (yyval.ttype, yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 696:
#line 3081 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); ;
    break;}
case 697:
#line 3083 "parse.y"
{ yyval.ttype = build_parse_node (ARRAY_REF, NULL_TREE, NULL_TREE); ;
    break;}
case 704:
#line 3106 "parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C++ forbids label declarations"); ;
    break;}
case 707:
#line 3117 "parse.y"
{ 
		  while (yyvsp[-1].ttype)
		    {
		      finish_label_decl (TREE_VALUE (yyvsp[-1].ttype));
		      yyvsp[-1].ttype = TREE_CHAIN (yyvsp[-1].ttype);
		    }
		;
    break;}
case 708:
#line 3130 "parse.y"
{;
    break;}
case 710:
#line 3136 "parse.y"
{ yyval.ttype = begin_compound_stmt (0); ;
    break;}
case 711:
#line 3138 "parse.y"
{ yyval.ttype = finish_compound_stmt (0, yyvsp[-1].ttype); ;
    break;}
case 712:
#line 3143 "parse.y"
{
		  yyval.ttype = begin_if_stmt ();
		  cond_stmt_keyword = "if";
		;
    break;}
case 713:
#line 3148 "parse.y"
{ finish_if_stmt_cond (yyvsp[0].ttype, yyvsp[-1].ttype); ;
    break;}
case 714:
#line 3150 "parse.y"
{ yyval.ttype = finish_then_clause (yyvsp[-3].ttype); ;
    break;}
case 716:
#line 3155 "parse.y"
{ yyval.ttype = begin_compound_stmt (0); ;
    break;}
case 717:
#line 3157 "parse.y"
{ yyval.ttype = finish_compound_stmt (0, yyvsp[-1].ttype); ;
    break;}
case 718:
#line 3162 "parse.y"
{;
    break;}
case 720:
#line 3168 "parse.y"
{ finish_stmt (); ;
    break;}
case 721:
#line 3170 "parse.y"
{ finish_expr_stmt (yyvsp[-1].ttype); ;
    break;}
case 722:
#line 3172 "parse.y"
{ begin_else_clause (); ;
    break;}
case 723:
#line 3174 "parse.y"
{ 
		  finish_else_clause (yyvsp[-3].ttype); 
		  finish_if_stmt ();
		;
    break;}
case 724:
#line 3179 "parse.y"
{ finish_if_stmt (); ;
    break;}
case 725:
#line 3181 "parse.y"
{
		  yyval.ttype = begin_while_stmt ();
		  cond_stmt_keyword = "while";
		;
    break;}
case 726:
#line 3186 "parse.y"
{ finish_while_stmt_cond (yyvsp[0].ttype, yyvsp[-1].ttype); ;
    break;}
case 727:
#line 3188 "parse.y"
{ finish_while_stmt (yyvsp[-3].ttype); ;
    break;}
case 728:
#line 3190 "parse.y"
{ yyval.ttype = begin_do_stmt (); ;
    break;}
case 729:
#line 3192 "parse.y"
{
		  finish_do_body (yyvsp[-2].ttype);
		  cond_stmt_keyword = "do";
		;
    break;}
case 730:
#line 3197 "parse.y"
{ finish_do_stmt (yyvsp[-1].ttype, yyvsp[-5].ttype); ;
    break;}
case 731:
#line 3199 "parse.y"
{ yyval.ttype = begin_for_stmt (); ;
    break;}
case 732:
#line 3201 "parse.y"
{ finish_for_init_stmt (yyvsp[-2].ttype); ;
    break;}
case 733:
#line 3203 "parse.y"
{ finish_for_cond (yyvsp[-1].ttype, yyvsp[-5].ttype); ;
    break;}
case 734:
#line 3205 "parse.y"
{ finish_for_expr (yyvsp[-1].ttype, yyvsp[-8].ttype); ;
    break;}
case 735:
#line 3207 "parse.y"
{ finish_for_stmt (yyvsp[-3].ttype, yyvsp[-10].ttype); ;
    break;}
case 736:
#line 3209 "parse.y"
{ yyval.ttype = begin_switch_stmt (); ;
    break;}
case 737:
#line 3211 "parse.y"
{ finish_switch_cond (yyvsp[-1].ttype, yyvsp[-3].ttype); ;
    break;}
case 738:
#line 3213 "parse.y"
{ finish_switch_stmt (yyvsp[-3].ttype, yyvsp[-5].ttype); ;
    break;}
case 739:
#line 3215 "parse.y"
{ finish_case_label (yyvsp[-1].ttype, NULL_TREE); ;
    break;}
case 741:
#line 3218 "parse.y"
{ finish_case_label (yyvsp[-3].ttype, yyvsp[-1].ttype); ;
    break;}
case 743:
#line 3221 "parse.y"
{ finish_case_label (NULL_TREE, NULL_TREE); ;
    break;}
case 745:
#line 3224 "parse.y"
{ finish_break_stmt (); ;
    break;}
case 746:
#line 3226 "parse.y"
{ finish_continue_stmt (); ;
    break;}
case 747:
#line 3228 "parse.y"
{ finish_return_stmt (NULL_TREE); ;
    break;}
case 748:
#line 3230 "parse.y"
{ finish_return_stmt (yyvsp[-1].ttype); ;
    break;}
case 749:
#line 3232 "parse.y"
{ 
		  finish_asm_stmt (yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE, NULL_TREE,
				   NULL_TREE); 
		;
    break;}
case 750:
#line 3238 "parse.y"
{ 
		  finish_asm_stmt (yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE,
				   NULL_TREE); 
		;
    break;}
case 751:
#line 3244 "parse.y"
{ finish_asm_stmt (yyvsp[-8].ttype, yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE); ;
    break;}
case 752:
#line 3248 "parse.y"
{ finish_asm_stmt (yyvsp[-10].ttype, yyvsp[-8].ttype, yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype); ;
    break;}
case 753:
#line 3250 "parse.y"
{ 
		  if (pedantic)
		    pedwarn ("ANSI C++ forbids computed gotos");
		  finish_goto_stmt (yyvsp[-1].ttype);
		;
    break;}
case 754:
#line 3256 "parse.y"
{ finish_goto_stmt (yyvsp[-1].ttype); ;
    break;}
case 756:
#line 3259 "parse.y"
{ error ("label must be followed by statement");
		  yyungetc ('}', 0); ;
    break;}
case 757:
#line 3262 "parse.y"
{ finish_stmt (); ;
    break;}
case 760:
#line 3266 "parse.y"
{ do_local_using_decl (yyvsp[0].ttype); ;
    break;}
case 762:
#line 3272 "parse.y"
{ yyval.ttype = begin_function_try_block (); ;
    break;}
case 763:
#line 3274 "parse.y"
{ finish_function_try_block (yyvsp[-2].ttype); ;
    break;}
case 764:
#line 3276 "parse.y"
{
		  finish_function_handler_sequence (yyvsp[-4].ttype);
		  yyval.itype = yyvsp[-3].itype;
		;
    break;}
case 765:
#line 3284 "parse.y"
{ yyval.ttype = begin_try_block (); ;
    break;}
case 766:
#line 3286 "parse.y"
{ finish_try_block (yyvsp[-1].ttype); ;
    break;}
case 767:
#line 3288 "parse.y"
{ finish_handler_sequence (yyvsp[-3].ttype); ;
    break;}
case 770:
#line 3298 "parse.y"
{ yyval.ttype = begin_handler(); ;
    break;}
case 771:
#line 3300 "parse.y"
{ yyval.ttype = finish_handler_parms (yyvsp[0].ttype, yyvsp[-1].ttype); ;
    break;}
case 772:
#line 3302 "parse.y"
{ finish_handler (yyvsp[-1].ttype, yyvsp[-3].ttype); ;
    break;}
case 775:
#line 3312 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 776:
#line 3328 "parse.y"
{ 
		  check_for_new_type ("inside exception declarations", yyvsp[-1].ftype);
		  yyval.ttype = start_handler_parms (TREE_PURPOSE (yyvsp[-1].ftype.t),
					    TREE_VALUE (yyvsp[-1].ftype.t));
		;
    break;}
case 777:
#line 3337 "parse.y"
{ finish_label_stmt (yyvsp[-1].ttype); ;
    break;}
case 778:
#line 3339 "parse.y"
{ finish_label_stmt (yyvsp[-1].ttype); ;
    break;}
case 779:
#line 3341 "parse.y"
{ finish_label_stmt (yyvsp[-1].ttype); ;
    break;}
case 780:
#line 3343 "parse.y"
{ finish_label_stmt (yyvsp[-1].ttype); ;
    break;}
case 781:
#line 3348 "parse.y"
{ finish_expr_stmt (yyvsp[-1].ttype); ;
    break;}
case 783:
#line 3351 "parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C++ forbids compound statements inside for initializations");
		;
    break;}
case 784:
#line 3360 "parse.y"
{ emit_line_note (input_filename, lineno);
		  yyval.ttype = NULL_TREE; ;
    break;}
case 785:
#line 3363 "parse.y"
{ emit_line_note (input_filename, lineno); ;
    break;}
case 786:
#line 3368 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 788:
#line 3371 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 789:
#line 3378 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 792:
#line 3385 "parse.y"
{ yyval.ttype = chainon (yyval.ttype, yyvsp[0].ttype); ;
    break;}
case 793:
#line 3390 "parse.y"
{ yyval.ttype = build_tree_list (yyval.ttype, yyvsp[-1].ttype); ;
    break;}
case 794:
#line 3395 "parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyval.ttype, NULL_TREE); ;
    break;}
case 795:
#line 3397 "parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyval.ttype); ;
    break;}
case 796:
#line 3408 "parse.y"
{
		  yyval.ttype = empty_parms();
		;
    break;}
case 798:
#line 3413 "parse.y"
{ yyval.ttype = finish_parmlist (build_tree_list (NULL_TREE, yyvsp[0].ftype.t), 0);
		  check_for_new_type ("inside parameter list", yyvsp[0].ftype); ;
    break;}
case 799:
#line 3421 "parse.y"
{ yyval.ttype = finish_parmlist (yyval.ttype, 0); ;
    break;}
case 800:
#line 3423 "parse.y"
{ yyval.ttype = finish_parmlist (yyvsp[-1].ttype, 1); ;
    break;}
case 801:
#line 3426 "parse.y"
{ yyval.ttype = finish_parmlist (yyvsp[-1].ttype, 1); ;
    break;}
case 802:
#line 3428 "parse.y"
{ yyval.ttype = finish_parmlist (build_tree_list (NULL_TREE,
							 yyvsp[-1].ftype.t), 1); ;
    break;}
case 803:
#line 3431 "parse.y"
{ yyval.ttype = finish_parmlist (NULL_TREE, 1); ;
    break;}
case 804:
#line 3433 "parse.y"
{
		  /* This helps us recover from really nasty
		     parse errors, for example, a missing right
		     parenthesis.  */
		  yyerror ("possibly missing ')'");
		  yyval.ttype = finish_parmlist (yyvsp[-1].ttype, 0);
		  yyungetc (':', 0);
		  yychar = ')';
		;
    break;}
case 805:
#line 3443 "parse.y"
{
		  /* This helps us recover from really nasty
		     parse errors, for example, a missing right
		     parenthesis.  */
		  yyerror ("possibly missing ')'");
		  yyval.ttype = finish_parmlist (build_tree_list (NULL_TREE,
							 yyvsp[-1].ftype.t), 0); 
		  yyungetc (':', 0);
		  yychar = ')';
		;
    break;}
case 806:
#line 3458 "parse.y"
{ maybe_snarf_defarg (); ;
    break;}
case 807:
#line 3460 "parse.y"
{ yyval.ttype = yyvsp[0].ttype; ;
    break;}
case 810:
#line 3471 "parse.y"
{ check_for_new_type ("in a parameter list", yyvsp[0].ftype);
		  yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ftype.t); ;
    break;}
case 811:
#line 3474 "parse.y"
{ check_for_new_type ("in a parameter list", yyvsp[-1].ftype);
		  yyval.ttype = build_tree_list (yyvsp[0].ttype, yyvsp[-1].ftype.t); ;
    break;}
case 812:
#line 3477 "parse.y"
{ check_for_new_type ("in a parameter list", yyvsp[0].ftype);
		  yyval.ttype = chainon (yyval.ttype, yyvsp[0].ftype.t); ;
    break;}
case 813:
#line 3480 "parse.y"
{ yyval.ttype = chainon (yyval.ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); ;
    break;}
case 814:
#line 3482 "parse.y"
{ yyval.ttype = chainon (yyval.ttype, build_tree_list (yyvsp[0].ttype, yyvsp[-2].ttype)); ;
    break;}
case 816:
#line 3488 "parse.y"
{ check_for_new_type ("in a parameter list", yyvsp[-1].ftype);
		  yyval.ttype = build_tree_list (NULL_TREE, yyvsp[-1].ftype.t); ;
    break;}
case 817:
#line 3498 "parse.y"
{ tree specs = strip_attrs (yyvsp[-1].ftype.t);
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag;
		  yyval.ftype.t = build_tree_list (specs, yyvsp[0].ttype); ;
    break;}
case 818:
#line 3502 "parse.y"
{ yyval.ftype.t = build_tree_list (yyvsp[-1].ftype.t, yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 819:
#line 3505 "parse.y"
{ yyval.ftype.t = build_tree_list (build_decl_list (NULL_TREE, yyvsp[-1].ftype.t),
					  yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 820:
#line 3509 "parse.y"
{ tree specs = strip_attrs (yyvsp[-1].ftype.t);
		  yyval.ftype.t = build_tree_list (specs, yyvsp[0].ttype);
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag; ;
    break;}
case 821:
#line 3513 "parse.y"
{ tree specs = strip_attrs (yyvsp[0].ftype.t);
		  yyval.ftype.t = build_tree_list (specs, NULL_TREE); 
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag; ;
    break;}
case 822:
#line 3517 "parse.y"
{ tree specs = strip_attrs (yyvsp[-1].ttype);
		  yyval.ftype.t = build_tree_list (specs, yyvsp[0].ttype); 
		  yyval.ftype.new_type_flag = 0; ;
    break;}
case 823:
#line 3524 "parse.y"
{ yyval.ftype.t = build_tree_list (NULL_TREE, yyvsp[0].ftype.t);
		  yyval.ftype.new_type_flag = yyvsp[0].ftype.new_type_flag;  ;
    break;}
case 824:
#line 3527 "parse.y"
{ yyval.ftype.t = build_tree_list (yyvsp[0].ttype, yyvsp[-1].ftype.t);
		  yyval.ftype.new_type_flag = yyvsp[-1].ftype.new_type_flag;  ;
    break;}
case 827:
#line 3538 "parse.y"
{ see_typename (); ;
    break;}
case 828:
#line 3543 "parse.y"
{
		  error ("type specifier omitted for parameter");
		  yyval.ttype = build_tree_list (integer_type_node, NULL_TREE);
		;
    break;}
case 829:
#line 3548 "parse.y"
{
		  error ("type specifier omitted for parameter");
		  if (TREE_CODE (yyval.ttype) == SCOPE_REF
		      && (TREE_CODE (TREE_OPERAND (yyval.ttype, 0)) == TEMPLATE_TYPE_PARM
			  || TREE_CODE (TREE_OPERAND (yyval.ttype, 0)) == TEMPLATE_TEMPLATE_PARM))
		    cp_error ("  perhaps you want `typename %E' to make it a type", yyval.ttype);
		  yyval.ttype = build_tree_list (integer_type_node, yyval.ttype);
		;
    break;}
case 830:
#line 3560 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 831:
#line 3562 "parse.y"
{ yyval.ttype = yyvsp[-1].ttype; ;
    break;}
case 832:
#line 3564 "parse.y"
{ yyval.ttype = empty_except_spec; ;
    break;}
case 833:
#line 3569 "parse.y"
{
		  check_for_new_type ("exception specifier", yyvsp[0].ftype);
		  yyval.ttype = groktypename (yyvsp[0].ftype.t);
		;
    break;}
case 834:
#line 3577 "parse.y"
{ yyval.ttype = add_exception_specifier (NULL_TREE, yyvsp[0].ttype, 1); ;
    break;}
case 835:
#line 3579 "parse.y"
{ yyval.ttype = add_exception_specifier (yyvsp[-2].ttype, yyvsp[0].ttype, 1); ;
    break;}
case 836:
#line 3584 "parse.y"
{ yyval.ttype = NULL_TREE; ;
    break;}
case 837:
#line 3586 "parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 838:
#line 3588 "parse.y"
{ yyval.ttype = make_reference_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); ;
    break;}
case 839:
#line 3590 "parse.y"
{ tree arg = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype);
		  yyval.ttype = build_parse_node (SCOPE_REF, yyvsp[-2].ttype, arg);
		;
    break;}
case 840:
#line 3597 "parse.y"
{ got_scope = NULL_TREE; ;
    break;}
case 841:
#line 3602 "parse.y"
{ yyval.ttype = ansi_opname[MULT_EXPR]; ;
    break;}
case 842:
#line 3604 "parse.y"
{ yyval.ttype = ansi_opname[TRUNC_DIV_EXPR]; ;
    break;}
case 843:
#line 3606 "parse.y"
{ yyval.ttype = ansi_opname[TRUNC_MOD_EXPR]; ;
    break;}
case 844:
#line 3608 "parse.y"
{ yyval.ttype = ansi_opname[PLUS_EXPR]; ;
    break;}
case 845:
#line 3610 "parse.y"
{ yyval.ttype = ansi_opname[MINUS_EXPR]; ;
    break;}
case 846:
#line 3612 "parse.y"
{ yyval.ttype = ansi_opname[BIT_AND_EXPR]; ;
    break;}
case 847:
#line 3614 "parse.y"
{ yyval.ttype = ansi_opname[BIT_IOR_EXPR]; ;
    break;}
case 848:
#line 3616 "parse.y"
{ yyval.ttype = ansi_opname[BIT_XOR_EXPR]; ;
    break;}
case 849:
#line 3618 "parse.y"
{ yyval.ttype = ansi_opname[BIT_NOT_EXPR]; ;
    break;}
case 850:
#line 3620 "parse.y"
{ yyval.ttype = ansi_opname[COMPOUND_EXPR]; ;
    break;}
case 851:
#line 3622 "parse.y"
{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
    break;}
case 852:
#line 3624 "parse.y"
{ yyval.ttype = ansi_opname[LT_EXPR]; ;
    break;}
case 853:
#line 3626 "parse.y"
{ yyval.ttype = ansi_opname[GT_EXPR]; ;
    break;}
case 854:
#line 3628 "parse.y"
{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
    break;}
case 855:
#line 3630 "parse.y"
{ yyval.ttype = ansi_assopname[yyvsp[0].code]; ;
    break;}
case 856:
#line 3632 "parse.y"
{ yyval.ttype = ansi_opname [MODIFY_EXPR]; ;
    break;}
case 857:
#line 3634 "parse.y"
{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
    break;}
case 858:
#line 3636 "parse.y"
{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
    break;}
case 859:
#line 3638 "parse.y"
{ yyval.ttype = ansi_opname[POSTINCREMENT_EXPR]; ;
    break;}
case 860:
#line 3640 "parse.y"
{ yyval.ttype = ansi_opname[PREDECREMENT_EXPR]; ;
    break;}
case 861:
#line 3642 "parse.y"
{ yyval.ttype = ansi_opname[TRUTH_ANDIF_EXPR]; ;
    break;}
case 862:
#line 3644 "parse.y"
{ yyval.ttype = ansi_opname[TRUTH_ORIF_EXPR]; ;
    break;}
case 863:
#line 3646 "parse.y"
{ yyval.ttype = ansi_opname[TRUTH_NOT_EXPR]; ;
    break;}
case 864:
#line 3648 "parse.y"
{ yyval.ttype = ansi_opname[COND_EXPR]; ;
    break;}
case 865:
#line 3650 "parse.y"
{ yyval.ttype = ansi_opname[yyvsp[0].code]; ;
    break;}
case 866:
#line 3652 "parse.y"
{ yyval.ttype = ansi_opname[COMPONENT_REF]; ;
    break;}
case 867:
#line 3654 "parse.y"
{ yyval.ttype = ansi_opname[MEMBER_REF]; ;
    break;}
case 868:
#line 3656 "parse.y"
{ yyval.ttype = ansi_opname[CALL_EXPR]; ;
    break;}
case 869:
#line 3658 "parse.y"
{ yyval.ttype = ansi_opname[ARRAY_REF]; ;
    break;}
case 870:
#line 3660 "parse.y"
{ yyval.ttype = ansi_opname[NEW_EXPR]; ;
    break;}
case 871:
#line 3662 "parse.y"
{ yyval.ttype = ansi_opname[DELETE_EXPR]; ;
    break;}
case 872:
#line 3664 "parse.y"
{ yyval.ttype = ansi_opname[VEC_NEW_EXPR]; ;
    break;}
case 873:
#line 3666 "parse.y"
{ yyval.ttype = ansi_opname[VEC_DELETE_EXPR]; ;
    break;}
case 874:
#line 3669 "parse.y"
{ yyval.ttype = grokoptypename (yyvsp[-1].ftype.t, yyvsp[0].ttype); ;
    break;}
case 875:
#line 3671 "parse.y"
{ yyval.ttype = ansi_opname[ERROR_MARK]; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 542 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 3674 "parse.y"


#ifdef SPEW_DEBUG
const char *
debug_yytranslate (value)
    int value;
{
  return yytname[YYTRANSLATE (value)];
}

#endif
